package Communication;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;

//import JPLCommunicator.main;

//import JPLCommunicator.main;

public class Communicator implements CommunicatorInterface{
	String[] separator = { "%^%" };
    String serveraddress = "127.0.0.1";
    int serverport = 8001;
    
    public Communicator () 
	{
    	String configfile = System.getProperties().getProperty("jpl.deconfliction");
    	if(configfile==null) {
    		System.out.println("No access to configuration file");
    		configfile = "C:\\IHMCJPL\\Config.txt";;
    	}
		Configuration c = new Configuration(configfile);
        serveraddress = c.getParameter("ServerAddress");
        serverport = Integer.parseInt(c.getParameter("ServerPort"));
	}
    
	public Communicator (String configfile) 
	{
		Configuration c = new Configuration(configfile);
        serveraddress = c.getParameter("ServerAddress");
        serverport = Integer.parseInt(c.getParameter("ServerPort"));
	}
	
	 public String sendPolicies(String GuardID, String owl)
     {
         String response = "";
         ServerClass sc = new ServerClass();
         String send = "1" + separator[0] + GuardID + separator[0] + owl;
         if (owl != null && owl.contains("RDF"))
         {
            response = sc.callServer(send, serveraddress, serverport);
         }
         else
         {
             response = "Check the owl file!";
         }
         return response;
     }
	 
	 private String listToString(ArrayList<String> l, String dividor) {
		 String s="";
		 for(int i=0; i< l.size();i++){
			 if(i>0) {
				s += dividor; 
			 }
			 s += l.get(i);
		 }
		 return s;
	 }
	 
	 public String sendPoliciesEnvironmentVector(String GuardID, ArrayList<String> listPolicyID, ArrayList<String> listEpisode, String starttime, String currenttime) {
		 String policies = listToString(listPolicyID, ",");
		 String missionEpisode = listToString(listEpisode,"#=#");
		 return sendPoliciesAndEnvironmentVector(GuardID, policies, missionEpisode, starttime, currenttime);
	 }
	 
	 public String sendPoliciesEnvironmentVector(String GuardID, ArrayList<String> policies, ArrayList<String> MissionEpisode)
     {
         return sendPoliciesEnvironmentVector(GuardID, policies, MissionEpisode, "12:00", "13:00");
     }
	 
	 public String sendPoliciesAndEnvironmentVector(String GuardID, String policies, String missionEpisode, String starttime, String currenttime)
     {
         if (GuardID.length() == 0 || policies.length() == 0 || missionEpisode.length() == 0 || starttime.length() == 0 || currenttime.length() == 0)
         {
             return "check input parameters!";
         }
         String mission_episode =missionEpisode;
         ServerClass sc = new ServerClass();
         String send = "4" + separator[0] + GuardID + separator[0] + policies + separator[0] + mission_episode;
         String response = sc.callServer(send, serveraddress, serverport);
         return response;
     }
	 


     public String getResolvedActivePolicies(String GuardID)
     {
         String send = "5" + separator[0] + GuardID + separator[0];
         ServerClass sc = new ServerClass();
         String response = sc.callServer(send, serveraddress, serverport);
         return response;
     }
     
     private static ArrayList<String> getPolicyIDs(String s, String dividor) {
 		ArrayList<String> l = new ArrayList<String>();
 		String[] ss = s.split(dividor);
 		for(int i=0; i< ss.length;i++) {
 			l.add(ss[i]);
 		}
 		return l;
 	}
     
     public static void main (String... aArguments) 
     {
    		 String GuardID = "1221";
    		 String OWLfile = "C:\\Users\\arudenko\\Documents\\Owl\\OWLfromHMS\\policyNetwork5.cfg";
    		 FSClass fsc = new FSClass();
    		 String owl = fsc.readFile(OWLfile);
    		 System.out.println("Policies: "+owl);
    		 System.out.println("New file contents: "+GuardID);
    		 //Communicator c = new Communicator("C:\\Users\\arudenko\\Documents\\Owl\\OWLfromHMS\\Config.txt");
    		 Communicator c = new Communicator();
    		 String response0 = c.sendPolicies(GuardID, owl);
    		 
    		 System.out.println("Response from server, policies: "+response0);
    		 String policies = "fe9319a9,feb37674,01160592,338b88dd,3372b41b,fea21955,3385de86,fea86fad,31d31c84,fe8d5555,fea64f25";
    		 ArrayList<String> listPolicyID = getPolicyIDs(policies,",");
    		 OWLfile = "C:\\Users\\arudenko\\Documents\\Owl\\OWLfromHMS\\EnvironmentInOWLOriginal.txt";
    		 String environment = fsc.readFile(OWLfile);
    		 ArrayList<String> listEV = getPolicyIDs(environment,"#=#");
    		 System.out.println("Policy IDs: "+policies);
    		 System.out.println("Environment: "+environment);
    		 
    		 String response1 = c.sendPoliciesEnvironmentVector(GuardID, listPolicyID, listEV, "12:00", "13:00");
    		 System.out.println("Response from server, conflicts: "+response1);

    		 try {
    			 BufferedReader inFromUser = new BufferedReader( new InputStreamReader(System.in));
    			 String sentence = inFromUser.readLine();
    			 System.out.println(sentence);
    		 }catch(Exception io){}
    		 String response2 = c.getResolvedActivePolicies(GuardID);
    		 System.out.println("Active policies w/o conflicts are returned: "+response2);
     }
}
