/**
 * Last Modified by: $Author: auszok $
 * On: $Date: 2011/04/15 04:33:11 $
 */
package kaos.core.csi;

/**
 *   This interface contains methods allowing to create and investigate a description of an Action instance.
 *   
 *   $Revision: 1.6 $
 */
public interface ActionInstanceDescription extends OntInstanceDescription, Cloneable
{
    /**
     *   Get the name of the actor.
     */
    public String getActor();

    /**
     *   Get the name of the class of action.
     */
    public String getActionClassName();
    
    // --------------------------------------
    
    /**
     *   Set the name of the concept mapping.
     *   
     *   @param name - the name of the concept mapping
     */
    public void setConceptMappingName(String name);
    
    /**
     *   Get the name of the concept mapping.
     */
    public String getConceptMappingName();
    
    public void setPropertyPopulatorKey(String aKey);

    public String getPropertyPopulatorKey();    
    
    public ActionInstanceDescription clone();
}