/**
 * Last Modified by: $Author: auszok $
 * On: $Date: 2012/03/26 20:37:21 $
 */
 
package kaos.core.csi.extension.classification;

import kaos.core.csi.extension.KAoSExtensionComponent;
import kaos.core.service.directory.DirectoryService;
 
/**
 *   Interface to instance classifier
 *
 *   $Revision: 1.8 $
 */
public interface InstanceClassifier extends KAoSExtensionComponent
{         
    /**
     * Check if the instance is in of the given class 
     *
     * @param className                 name of the class (as url to the ontology concept)
     * @param classDesc                 the optional class description
     * @param instance	                the instance to be classified 
     * @param instDesc			the optional instance description	
     * @param checkedPolicyType         the type of the checked policy
     *
     * @return                          True if the instance is of the specified class, false if not.
     *
     * @throws ClassifierException 
     */
    public boolean classify(String className, Object classDesc, String instanceName, Object instDesc) throws ClassifierException;
    
    /**
     * TODO: remove it when OntologyService become available in CSI
     * 
     * Set optional OntologyService to be used to retrieve a missing ontology definition of not provided explicitly 
     * in the classify method arguments
     *
     * @param ontInterfaces             OntologyService to be used, if needed for instance classification.
     */
    public void setOntologyInterfaces(DirectoryService ontInterfaces);
}
