/**
 * Last Modified by: $Author: mvignati $
 * On: $Date: 2012/01/26 19:29:57 $
 */

package kaos.core.csi.extension.classification;

import kaos.core.csi.extension.KAoSExtensionComponentManagerImpl;
import kaos.core.csi.extension.KAoSExtensionsTypes;

import javax.agent.service.ServiceException;
import javax.agent.service.ServiceProperties;

/**
 * Class implementing functionality of the Classifier Factory
 */
public class InstanceClassifierManagerImpl extends KAoSExtensionComponentManagerImpl implements InstanceClassifierManager         
{
    private static InstanceClassifierManager    __INSTANCE;
    private static boolean                      __INITIALIZED = false;
    
    /**
     * Private constructor
     */
    private InstanceClassifierManagerImpl()
    {
        super(KAoSExtensionsTypes.CLASSIFIERS);
    }
    
    /**
     * Retrieve an instance of ClassifierManagement.
     *
     * @return a singleton, InstanceClassifierManager.
     */
    public static InstanceClassifierManager getInstance()
    {
        if ( __INITIALIZED ) return __INSTANCE;
        
        __INSTANCE = new InstanceClassifierManagerImpl();
        __INITIALIZED = true;
            
        return __INSTANCE;
    }
    
    //------- kaos.ontology.matching.InstanceClassifierFactory interface implementation  - Begin
     
    /*
     * @see kaos.core.csi.extension.classification.InstanceClassifierManager#getClassifier(java.lang.String)
     */
    public  InstanceClassifier getClassifier (String ontologyAttribute)
    {
        return (InstanceClassifier)getComponent(ontologyAttribute, null);
    }

    /* 
     * @see kaos.core.csi.extension.KAoSExtensionComponentManagerImpl#initialize(javax.agent.service.ServiceProperties)
     */
    public void initialize(ServiceProperties env) throws ServiceException 
    {
        super.initialize(env);
    }
}























