/**
 * Last Modified by: $Author: auszok $ On: $Date: 2009/01/27 05:11:09 $
 */

package kaos.core.csi.extension.obligation;

import kaos.core.csi.extension.KAoSExtensionComponentManagerImpl;
import kaos.core.csi.extension.KAoSExtensionsTypes;

/**
 * This class implements the OntologyAnnotationManager interface, which defines a factory method for obtaining an OntologyAnnotationService, whose ontological type is given.
 * $Revision: 1.4 $
 */
public class ObligationMonitorManager extends KAoSExtensionComponentManagerImpl
{
    public static final String              OBLIGATION_MONITOR_MANAGER_TYPE = "ObligationMonitor";

    private static ObligationMonitorManager __INSTANCE;
    private static boolean                  __INITIALIZED                   = false;

    private ObligationMonitorManager()
    {
        super(KAoSExtensionsTypes.OBLIGATION_MONITOR);
    }

    /**
     * Retrieve an instance of ObligationMonitorManager.
     * 
     * @return a singleton, ObligationMonitorManager.
     */
    public static ObligationMonitorManager getInstance()
    {
        if (__INITIALIZED)
            return __INSTANCE;

        __INSTANCE = new ObligationMonitorManager();
        __INITIALIZED = true;

        return __INSTANCE;
    }
}
