/**
 * Last Modified by: $Author: auszok $ On: $Date: 2009/09/14 21:20:38 $
 */

package kaos.core.csi.observe;

/**
 * Defines the operation to receive updates when the KAoSObservable object, with whom this KAoSObserver was registered, changes.
 * 
 * @author KAoS Team $Revision: 1.9 $
 */
public interface KAoSObserver
{
    /**
     * Receive an update from the KAoSObservable when the KAoSObservable has a change or event to report.
     * 
     * @param observableID String identifying the KAoSObservable sending the update.
     * @param updateType String indicating type of update.
     * @param updateCondition String describing the condition of the update.
     * @param update Object containing the update.
     * @throws NotificationException when the update fails.
     */
    public void update(String observableID, String updateType, Object updateCondition, Object update) throws NotificationException;

    /**
     * Return the unique identifier of this observer.
     * 
     * @return String containing the unique ID of this observer.
     */
    public String getID();
}