/**
 * Last Modified by: $Author: auszok $
 * On: $Date: 2012/03/28 20:37:57 $
 */
package kaos.core.csi.ontology;

import kaos.core.service.boot.KAoSGuardBootstrapper;
import kaos.core.service.directory.DirectoryService;

/**
 * Defines the operations to manage and access Ontology Service and its
 * repository
 * 
 * @author KAoS Team $Revision: 1.1 $
 */
public class OntologyRepositoryServiceImpl
{
    private static boolean          __INITIALIZED = false;

    private static DirectoryService _dirProxy     = null;

    /*
     * Retrieve an instance of OntologyService. The returned instance has initialized communication with the DS.
     * @param transportName String specifying the name of the transport to use for communication with the KAoS Directory Service.
     * @return a singleton, OntologyService.
     */
    public static OntologyRepositoryService getInstance(String transportName) throws Exception
    {
        if (__INITIALIZED)
            return _dirProxy;

        try
        {
            _dirProxy = KAoSGuardBootstrapper.getKAoSDirectoryProxyForTransport(transportName);
        }
        catch (Exception e)
        {
            e.printStackTrace();

            throw new Exception("getInstance: unable to obtain a reference the DirectoryService for transport: " + transportName + "!");
        }

        __INITIALIZED = true;

        return _dirProxy;
    }
}