/**
 * Last Modified by: $Author: auszok $
 * On: $Date: 2008/09/26 06:01:53 $
 */
package kaos.core.csi.policy;

/**
 * This interface contains methods that allow to set and retrieve alternate actors of the obligation described by this ObligationActionDescription.
 * Those actors may be asked to perform the obligation if the primary obligation actor is unable to execute the obligation.
 *   
 * $Revision: 1.3 $
 */
import kaos.core.csi.ActionInstanceDescription;

import java.util.Set;

public interface ObligationActionDescription extends ActionInstanceDescription
{
    /*
     * Get the alternate actors of the obligation.
     * 
     * @return Set containing the GUIDs of alternate obligation actors.
     */
    public Set<String> getAlternateActors();

    /*
     * Set the alternate actors of the obligation. This set will replace the current set of actors, if present.
     * 
     * @param alternateObligationActors - Set containing the GUIDs of the actors that may also perform this obligation.
     */
    public void setAlternateActors(Set<String> alternateObligationActors);
}
