/**
 * Last Modified by: $Author: mvignati $
 * On: $Date: 2012/01/26 19:30:01 $
 */
 
package kaos.core.csi.policy;

import kaos.core.util.PolicyMsg;

import java.util.List;

/**
 * This interface defines a method to receive an atomic policy update.
 *
 * $Revision: 1.3 $
 */
public interface PolicyListener
{
    /**
     * Receive policy updates and apply them accordingly.
     * 
     * @param  addedPolicies        The List of policies to be added to the collection of stored policies. 
     * @param  changedPolicies      The List of policies to be changed in the collection of stored policies.
     * @param  removedPolicies      The List of policies to be removed from the collection of stored policies.
     */
    public void updatePolicies(List<PolicyMsg> addedPolicies, List<PolicyMsg> changedPolicies, List<PolicyMsg> removedPolicies);
    
    /**
     *  Replace the current policy set with the given set
     */ 
    public void setPolicies (List<PolicyMsg> policies);      
    
    /*
     * Method allowing to modify the in force value of a policy.
     * @param policyId id of the policy
     * @param inForce boolean to indicate if a policy is in force.
     */
    public void updateInForceValue(String policyId, Boolean inForce);
}
