package kaos.core.csi.policy;

import kaos.core.service.boot.KAoSGuardBootstrapper;
import kaos.core.service.directory.DirectoryService;

/*
 * Defines the operations to manage policies in KAoS including adding, modifying and removing.
 * 
 * @author KAoS Team
 */
public class PolicyManagementImpl
{
    private static boolean                        __INITIALIZED = false;

    private static DirectoryService _dirProxy     = null;

    /*
     * Retrieve an instance of PolicyManagement. The returned instance has initialized communication with the DS.
     * 
     * @param transportName String specifying the name of the transport to use for communication with the KAoS Directory Service.
     * @return a singleton, PolicyManagement.
     */
    public static PolicyManagement getInstance(String transportName) throws Exception
    {
        if (__INITIALIZED)
            return _dirProxy;

        try
        {
            _dirProxy = KAoSGuardBootstrapper.getKAoSDirectoryProxyForTransport(transportName);
        }
        catch (Exception e)
        {
            e.printStackTrace();

            throw new Exception("getInstance: unable to obtain a reference the DirectoryService for transport: " + transportName + "!");
        }

        __INITIALIZED = true;

        return _dirProxy;
    }
}