/**
 * Last Modified by: $Author: auszok $
 * On: $Date: 2012/03/26 20:37:20 $
 */

package kaos.core.csi.query;

import kaos.core.service.boot.KAoSGuardBootstrapper;
import kaos.core.service.directory.DirectoryService;

/**
 * Defines the operations to query the different aspects of domain and actor registrations
 *
 * @author KAoS Team
 * $Revision: 1.12 $
 */
public class QueryStateImpl
{
    private static boolean __INITIALIZED = false;

    private static DirectoryService _dirProxy     = null;

	/**
     * Retrieve an instance of QueryState.
     *
     * @param transportName String specifying the name of the transport to use for communication with the KAoS Directory Service.
     *
     * @return a singleton, QueryState.
     */
    public static QueryState getInstance(String transportName) throws Exception
    {
        if (__INITIALIZED)
            return _dirProxy;

        try
        {
            _dirProxy = KAoSGuardBootstrapper.getKAoSDirectoryProxyForTransport(transportName);
        }
        catch (Exception e)
        {
            e.printStackTrace();

            throw new Exception("getInstance: unable to obtain a reference the DirectoryService for transport: " + transportName + "!");
        }

        __INITIALIZED = true;

        return _dirProxy;
    }

    private QueryStateImpl()
    {
    }
    

    /*****************************************************************************************
       kaos.core.csi.query.QueryState interface implementation - end
    *****************************************************************************************/
   
    
    private void initialize(String transportName) throws Exception
    {
        try {
            _dirProxy = KAoSGuardBootstrapper.getKAoSDirectoryProxyForTransport(transportName);
        }
        catch(Exception e) 
        {
            e.printStackTrace();
            throw new Exception("    \n\n    *** QueryStateImpl: unable to obtain a reference the DirectoryService for transport: " + transportName + "!");
        }
    }
 }