/**
 * Last Modified by: $Author: auszok $
 * On: $Date: 2012/04/14 05:50:40 $
 */
 
package kaos.core.csi.query.data;


/**
 *  Contains information describing a restriction of a subproperty of the ontology class
 *
 *   $Revision: 1.3 $
 */
public class ActionPropertyDescription extends OntClassPropertyDescription 
{
    private static final long serialVersionUID = -485893117626708060L;
    
    public static final String ADDITIONAL_ACTION_PROPERTY = "AdditionalActionProperty";
    
    public ActionPropertyDescription (OntClassPropertyDescription ontPropertyInfo)
    {
        super(ontPropertyInfo);
    }
    
    public ActionPropertyDescription (String _targetRoleName, String _targetClassName)
    {
        super(_targetRoleName);
        this.setRangeName(_targetClassName);
    }
     
    /**
     *   Gets the ontology originated name of the role of this target. 
     *   The default is <a href="http://ontology.coginst.uwf.edu/Action.daml#performedOn">performedOn</a>.
     */
    public String getTargetRoleName() 
    {
        return getPropertyName();
    }
    
    /**
     * Get the name of the target class.
     */
    public String getTargetClassName()
    {
        return getRangeName();
    }
    
    /**
     * Sets Relation to Action property information
     */
    public void setRelationToActionProperty(String myValue)
    {
        if (myValue.equals(MAIN_PROPERTY) || myValue.equals(SECONDARY_PROPERTY) || myValue.equals(ADDITIONAL_ACTION_PROPERTY))
            _relationToClass = myValue;
    }
}