/*
 * AgentConfiguration.java
 *
 * Created on December 8, 2006, 3:05 PM
 */

package kaos.core.csi.registration;

import ri.service.boot.BootProperties;

import javax.agent.service.ServiceProperties;
import java.util.*;

/**
 *
 * @author jlott
 */
public class AgentConfiguration
{
    public AgentConfiguration (String agentId,
                               List domains,
                               List ontologicalTypes,
                               Map ontologicalOperations)
    {
        _agentId = agentId;
        _domains = domains;
        _ontTypes = ontologicalTypes;
        _ontOps = ontologicalOperations;
    }

    public AgentConfiguration (ServiceProperties serviceProps)
    {
        _agentId = (String) serviceProps.get("javax.agent.service.id");
        BootProperties domains = (BootProperties) serviceProps.get("javax.agent.service.domains");
        _domains = new Vector(domains.keySet());
        BootProperties ontologicalTypes = (BootProperties) serviceProps.get("javax.agent.service.ontological-types");
        _ontTypes = new Vector(ontologicalTypes.keySet());
        BootProperties ontologicalOps = (BootProperties) serviceProps.get("javax.agent.service.OntologicalOperations");
        _ontOps = new Hashtable();
        if (ontologicalOps != null)
        {
            for (Iterator it = ontologicalOps.keySet().iterator(); it.hasNext();)
            {
                String key = (String) it.next();
                _ontOps.put(key, ontologicalOps.get(key));
            }
        }
    }

    public String getAgentId()
    {
        return _agentId;
    }

    public List getDomains()
    {
        return _domains;
    }

    public List getOntologicalTypes()
    {
        return _ontTypes;
    }

    public Map getOntologicalOperations()
    {
        return _ontOps;
    }

    private String _agentId;
    private List _domains;
    private List _ontTypes;
    private Map _ontOps;

}
