/**
 * Last Modified by: $Author: auszok $
 * On: $Date: 2008/09/10 14:56:39 $
 */

package kaos.core.csi.registration;

import kaos.core.service.directory.ModificationException;

import javax.agent.service.directory.DirectoryFailure;
import javax.agent.service.directory.NotRegisteredException;

/**
 * Defines the operations to register and deregister entities with group properties
 * 
 * @author KAoS Team
 * $Revision: 1.2 $
 */
public interface GroupRegistration
{
    /**
     * Adds the specified actor as a leader of the given group. Sets values in the ontology service for both the Group.hasLeader and Actor.isLeaderOf properties.
     * 
     * @param actorId - unique identifier of the Actor (Agent) individual to be set as the leader
     * @param teamURI - unique URI of the Group for which to set the leader 
     * @return
     * @throws NotRegisteredException
     * @throws DirectoryFailure
     * @throws ModificationException
     */
    public ModificationType addGroupLeader(String actorId, String groupURI) throws NotRegisteredException, DirectoryFailure, ModificationException;

    /**
     * Remove the specified actor as a leader of the given group. Clears values in the ontology service for both the Group.hasLeader and Actor.isLeaderOf properties.
     * 
     * @param actorId - unique identifier of the Actor (Agent) individual to be removed as the leader
     * @param teamURI - unique URI of the Group from which to remove the leader 
     * @return
     * @throws NotRegisteredException
     * @throws DirectoryFailure
     * @throws ModificationException
     */
    public ModificationType removeGroupLeader(String actorId, String groupURI) throws NotRegisteredException, DirectoryFailure, ModificationException;
}
