/**
 * Last Modified by: $Author: auszok $
 * On: $Date: 2012/02/22 17:43:14 $
 */
 
package kaos.core.csi.registration;

import kaos.core.service.directory.DirectoryEventNotifier;


/**
 * Defines the operations to register and deregister entities and entity hosting environments
 * in the KAoS Directory Service and operations to modify the registration information, to
 * register entities in KAoS Domain and to maintain domain hierarchy.
 * 
 * @author KAoS Team
 * $Revision: 1.5 $
 */
public interface Registration extends DirectoryRegistration,
                                      DomainHierarchyConfiguration,
                                      DomainRegistration,
                                      GroupRegistration,
                                      SpatialRegistration,
                                      DirectoryEventNotifier
{
    public AgentConfiguration getAgentConfiguration();
    public AgentConfiguration getAgentConfiguration (String configFile);    
}
