/**
 * Last Modified by: $Author: auszok $
 * On: $Date: 2008/01/23 17:17:58 $
 */

package kaos.core.csi.request;

import kaos.core.csi.ActionInstanceDescription;

/**
 * Defines the operations to process an obligation request described by the given obligation ActionInstanceDescription.  
 * In addition, the obligation trigger is given as well to provide more information about the context, in which the trigger action has occurred.
 * 
 * @author KAoS Team
 */
public interface ObligationRequestReceiver 
{	
	/**
	 * This method accepts an obligation request to execute by the ObligationRequestReceiver.  The obligation is described by the given ActionInstanceDescription.  
	 * Also the trigger  ActionInstanceDescription is given for the contextual information of the trigger action.
	 * 
	 * @param       obligationAID		 	is an ActionInstanceDescription containing the obligation action name and its properties.
	 * 
	 * @param		triggerAID	            is an ActionInstanceDescription containing the trigger action name and its properties. 
	 * 
	 * @throws	    ActionFailureException  containing the reason for failure. See ontology to determine specific reasons available for a given action
	 */
	public void processObligationRequest(ActionInstanceDescription obligationAID, ActionInstanceDescription triggerAID) throws ActionFailureException;
}
