/**
 * Last Modified by: $Author: mvignati $
 * On: $Date: 2012/01/26 19:29:57 $
 */

package kaos.core.csi.util.tcpSupport;

import kaos.core.util.Logger;

import java.io.*;
import java.net.Socket;

public class CommHandler 
    implements Runnable
{
    
	protected PrintStream   _os;
	protected Socket        _clientSocket;
    protected Logger      	_logger = Logger.getLogger(this);
	
	/**
	 * Constructor
	 * 
	 * @param clientSocket	the socket for the client handler to read from
	 */
	
	public CommHandler (Socket clientSocket)
	throws Exception
    {
        if ( clientSocket == null ) throw new Exception("\n\n    CommHandler.constructor: clientSocket is null!!!! Terminating..." );
        
        System.out.println("\n\n    CommHandler.constructor: socket on port: " + clientSocket.getPort() 
                            + " addreSs: " + clientSocket.getInetAddress());
        try{
			_os = new PrintStream (clientSocket.getOutputStream());
		}
		catch(IOException e){
			e.printStackTrace();
			System.out.println("\n\n    CommHandler.constructor: unable to create PrintStream for client socket on port: " 
			                    + clientSocket.getPort() + "\n  Terminating..." );
			throw e;
		}
        _clientSocket = clientSocket;
    }
        
    /**
	 * Start a thread for the server handler to run in.
	 * 
	 */
    public void start()
    {
        Thread thrd = new Thread (this);
        thrd.setDaemon (true);
        thrd.start();            
    }
    
    /**
     */
    protected void processBuffer(String line, BufferedReader bufferedReader)
	{
	    System.out.println("\n\n    CommHandler.processBuffer: received line: " + line);
	}
	
    /**
     */
    protected void processLine(String line)
	{
	    System.out.println("\n\n    CommHandler.processLine: received line: " + line);
	}
	
  
    protected String readLine(BufferedReader bufferedReader)
    {
        String line = null;
        
        if ( _os == null ) return null;
        try {
            line = bufferedReader.readLine();
        }
        catch(IOException e){
            // e.printStackTrace();
            System.out.println("\n  Unable to read next line from socket on port: " + _clientSocket.getPort() 
                                + " addreess: " + _clientSocket.getInetAddress() + " Terminating connection!");
	        _os.close();
	        _os = null;
	        try {
	            bufferedReader.close();
	            _clientSocket.close();
	        }
	        catch(IOException ioe){
	            ioe.printStackTrace();
	        }
        }
        if (_logger.isEnabledFor(Logger.DEBUG))
			_logger.logMessage("readLine: read:\n " + line, Logger.DEBUG);
   
        return line;
    }
  
    /**
	 * run
	 * 
	 * While connected, continues to read the object input stream and
	 * adds all objects to the newObjects vector
	 */
    public void run()
    {
		InputStream inputStream;
        try {
            inputStream = _clientSocket.getInputStream();
			InputStreamReader inputStreamReader = new InputStreamReader(inputStream);
			BufferedReader bufferedReader = new BufferedReader(inputStreamReader);
			String line = null;
			while ( (line = readLine(bufferedReader)) != null )
			{
			    processBuffer(line, bufferedReader);
				
			}// end while ((line = bufferedReader.readLine())
        }
		catch(IOException e ) {
		     e.printStackTrace();
		}
        _clientSocket = null;
    }	
          
 
   
}