package kaos.core.tutorial;

import kaos.core.csi.AgentCapability;
import kaos.core.csi.AgentCapabilityImpl;
import kaos.core.csi.registration.Property;
import kaos.core.csi.registration.PropertyImpl;
import kaos.ontology.vocabulary.ActionConcepts;
import kaos.ontology.vocabulary.ActorConcepts;
import kaos.ontology.vocabulary.EntityConcepts;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Vector;

public class SimpleAgentRobot extends SimpleAgent
{
   public SimpleAgentRobot(String[] args) throws Exception
   {
      super(args);
   }

   public SimpleAgentRobot(String name, Vector domainNames) throws Exception
   {
      super(name, domainNames);
   }

   /**
    *  define the type of entity the agent is
    */
   protected void setEntityOntologicalType()
   {
      this.addOntologicalType(ActorConcepts.Robot());
   }

   protected List getActorProperties()
   {
      // add test property for robots
      try
      {
         Property property = new PropertyImpl();
         property.setName(ActionConcepts.capableOfPerforming());
         property.setValue(ActionConcepts.MobilityAction());
         ArrayList<Property> properties = new ArrayList<Property>();
         properties.add(property);

         return properties;
      }
      catch (Exception e)
      {
         e.printStackTrace();
      }

      return null;
   }

   /**
    * define properties that describe what capabilities the agent has
    */
   protected List<AgentCapability> getAgentCapabilities()
   {
      List<AgentCapability> capabilities = new ArrayList<AgentCapability>();
      AgentCapability agentCapability = new AgentCapabilityImpl();
      agentCapability.setName(EntityConcepts.Entity());
      capabilities.add(agentCapability);

      return capabilities;
   }

   public void Beep()
   {
      System.out.println(_actorDesc.getAgentNickname() + ": BEEP!");
   }

   public void Beep(HashMap properties)
   {
      Beep();
   }
}
