package kaos.metrics;

/**
 * Interface to be implemented by objects wishing to use the Timer class
 * functionality.  The timer class can accept a number of listeners that
 * implement this interface.
 *
 * @see TaskTimer
 */
public interface TimerCallBack {
   /**
    * This method is called by the Timer for each object registered as a
    * call back.  The Timer executes a wait loop for the specified timer
    * interval and then calls all the listening objects.
    */
   public void timerExpired();
}
