/*
 * Created on Mar 25, 2011 To change the template for this generated file go to Window - Preferences - Java - Code Generation - Code and Comments
 */
package kaos.ontology.roleValueMap;

import kaos.ontology.roleValueMap.KAoSRoleValueMapImpl.IncorrectMapType;

import java.util.List;
import java.util.Vector;

public interface KAoSRoleValueMap
{
    // Object type role-value-map constraints
    public static String               OBJECT_EQUALITY_MAP                = "equals";
    public static String               CONTAINMENT_FROM_LEFT_TO_RIGHT_MAP = "contains";
    public static String               CONTAINMENT_FROM_RIGHT_TO_LEFT_MAP = "contained in";
    public static String               UNEMPTY_INTERSECTION_MAP           = "intersects";
    public static String               DISJOINTMENT_MAP                   = "disjoint with";

    // String type role-value-map constraints
    public static String               STRING_EQUALITY_MAP                = "text matches";
    public static String               STRING_STARTS_WITH_MAP             = "text starts with";
    public static String               STRING_CONTAINMENT_MAP             = "text contains";

    // Numeric type role-value-map constraints
    public static String               LESS_THAN_MAP                      = "is less than";
    public static String               LESS_OR_EQUAL_MAP                  = "is less or equal to";
    public static String               NUMERIC_EQUALITY_MAP               = "is equal to";
    public static String               GREATER_OR_EQUAL_MAP               = "is greater or equal to";
    public static String               GREATER_THAN_MAP                   = "is greater than";
    
    // ontology OBJECT map types
    public static final String[]       OBJECT_ROLE_VALUE_MAP_TYPES    = { OBJECT_EQUALITY_MAP, CONTAINMENT_FROM_LEFT_TO_RIGHT_MAP,
            CONTAINMENT_FROM_RIGHT_TO_LEFT_MAP, UNEMPTY_INTERSECTION_MAP, DISJOINTMENT_MAP };
    public static final Vector<String> OBJECT_ROLE_VALUE_MAP_TYPES_V  = new Vector<String>();
    // STRING map types
    public static final String[]       STRING_ROLE_VALUE_MAP_TYPES    = { STRING_EQUALITY_MAP, STRING_STARTS_WITH_MAP, STRING_CONTAINMENT_MAP };
    public static final List<String>   STRING_ROLE_VALUE_MAP_TYPES_V  = new Vector<String>();
    // NUMERIC map types
    public static final String[]       NUMERIC_ROLE_VALUE_MAP_TYPES   = { LESS_THAN_MAP, LESS_OR_EQUAL_MAP, NUMERIC_EQUALITY_MAP, GREATER_OR_EQUAL_MAP,
            GREATER_THAN_MAP                                         };
    public static final List<String>   NUMERIC_ROLE_VALUE_MAP_TYPES_V = new Vector<String>();
    public static final List<String>   ALL_ROLE_VALUE_MAP_TYPES_V     = new Vector<String>();

    /**
     * @param firstPath List of property names constituting the first path to the value(s)
     */
    public void setFirstPath(List<String> firstPath);

    /**
     * @param secondPath List of property names constituting the second path to the value(s)
     */
    public void setSecondPath(List<String> secondPath);

    /**
     * @param _mapType Determines the type of the map either EQUALITY_MAP or CONTAINMENT_MAP
     */
    public void setMapType(String mapType) throws IncorrectMapType;

    /**
     * @return Map id
     */
    public String getMapID();

    /**
     * @return List of property names constituting the first path to the value(s)
     */
    public List<String> getFirstPath();

    /**
     * @return List of property names constituting the second path to the value(s)
     */
    public List<String> getSecondPath();

    /**
     * @return Type of the map
     */
    public String getMapType();

    public void setMapID(String mapID);

}