/*
 * Created on Mar 25, 2011 To change the template for this generated file go to Window - Preferences - Java - Code Generation - Code and Comments
 */
package kaos.ontology.roleValueMap;

import com.hp.hpl.jena.rdf.model.Model;
import kaos.ontology.util.SerializableOntModelImpl;

import java.util.List;

public interface KAoSRoleValueMapContainer
{
    /*
     * Adds map to the container, if object with this id already exists, its old version will be first removed
     * 
     * @param _map KAoSRoleValueMap object to be added to the container
     */
    public void addMap(KAoSRoleValueMapImpl _map);

    /*
     * @param mapID Id of the map to be removed from the container
     */
    public void removeMap(String mapID);

    /*
     * Find all the maps whose either path starts with the specified property
     * 
     * @param propertyName name of the property starting a path
     */
    public List<KAoSRoleValueMapImpl> findMapsForProperty(String propertyName);

    public List<KAoSRoleValueMapImpl> findMapsForProperty(String propertyName, boolean firstPathOnly);

    /*
     * Find all the maps whose either path starts with the specified subpath
     * 
     * @param subPath vector representing the subpath
     */
    public List<KAoSRoleValueMapImpl> findMapsForSubPath(List<String> subPath);

    public List<KAoSRoleValueMapImpl> findMapsForSubPath(List<String> subPath, boolean firstPathOnly);

    /*
     * @param mapID Id of the map to be found in the container
     */
    public KAoSRoleValueMap findMap(String mapID);

    public List<KAoSRoleValueMapImpl> getAllMaps();

    public Model getOntModel(String boundToResource);

    public void readMapFromOntModel(SerializableOntModelImpl roleValueMapModel, String boundToResource);

    public void clear();
}