/*
 * Created on Mar 24, 2011 To change the template for this generated file go to Window - Preferences - Java - Code Generation - Code and Comments
 */
package kaos.ontology.util;

public interface KAoSOntBuilder
{
    // Type Labels
    final public static String _someValuesFromRestriction = "SomeValuesFromRestriction";
    final public static String _allValuesFromRestriction  = "AllValuesFromRestriction";
    final public static String _isHasValueRestriction = "IsHasValueRestriction";
    
    /*
     * Return the ontology structure as OntModel.
     * @return SerializableOntModel containing the ontology structure definition
     * @exception BuildingNotCompleted if the current structure is not fully specified
     */
    public SerializableOntModelImpl getOntModel() throws BuildingNotCompleted, ValueNotSet;
    
    /*
     * Return the ontology structure as OWL.
     * @return String containing the ontology structure definition
     * @exception BuildingNotCompleted if the current structure is not fully specified
     */
    public String getOWL() throws BuildingNotCompleted, ValueNotSet;
    
    /*
     * A method parsing a given ontology model and reading the complete  description which id is set as the OntologyStructureId in the model. 
     * If the id is not set in the model then the method reads the first structure
     * 
     * @param ontologyModel the model from which to read (the id is set in the model)
     */
    public void readFromModel(SerializableOntModelImpl ontologyModel);

    /*
     * A method parsing a given OWL string and reading the complete  description which is defined in the ontology. 
     * If the id is not provided then the method reads the first found structure
     * @param ontologyModel the model from which to read
     * @param ID id of the structure to be parsed out from ontology
     */
    public void readFromOWL(String ontologyModel, String ID);
}