package kaos.ontology.vocabulary;

import kaos.ontology.util.OntologyLanguageTagSelector;

/**
 * Class generated automatically by kaos.tools.OWLOntologyJavaMapper.
 * Provides static methods to obtain URI's for the ontology concepts and properties.
 */
final public class KAoSSystemConcepts
{
	final private static String KAoSSystemOwlURL = "http://ontology.ihmc.us/KAoSSystem.owl#";

    public static String KAoSSystemOwlURL() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL); 
	}

     // Concepts
    public static final String PolicyGUITemplateWindow = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "PolicyGUITemplateWindow");
    public static final String PolicyGUITemplateWindowElement = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "PolicyGUITemplateWindowElement");
    public static final String KAoSGuard = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "KAoSGuard");
    public static final String PolicyGUITemplate = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "PolicyGUITemplate");
    public static final String KAoSDirectoryService = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "KAoSDirectoryService");
    public static final String KAoSUser = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "KAoSUser");

    public static String PolicyGUITemplateWindow() { return PolicyGUITemplateWindow; };
    public static String PolicyGUITemplateWindowElement() { return PolicyGUITemplateWindowElement; };
    public static String KAoSGuard() { return KAoSGuard; };
    public static String PolicyGUITemplate() { return PolicyGUITemplate; };
    public static String KAoSDirectoryService() { return KAoSDirectoryService; };
    public static String KAoSUser() { return KAoSUser; };

     // Properties
    public static final String hasDomainPriority = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "hasDomainPriority");
    public static final String hasPrivilege = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "hasPrivilege");
    public static final String hasUserPriority = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "hasUserPriority");
    public static final String hasPolicyTemplatePriority = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "hasPolicyTemplatePriority");
    public static final String hasTemplateCreator = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "hasTemplateCreator");
    public static final String hasTemplateWindow = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "hasTemplateWindow");
    public static final String hasPassword = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "hasPassword");
    public static final String createdUsingTemplate = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "createdUsingTemplate");
    public static final String hasAccessToKPATTemplate = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "hasAccessToKPATTemplate");
    public static final String originatedFromPolicy = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "originatedFromPolicy");
    public static final String hasTemplateWindowElement = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "hasTemplateWindowElement");
    public static final String createdUsingTemplateID = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "createdUsingTemplateID");
    public static final String hasAccessToKPATTab = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "hasAccessToKPATTab");
    public static final String defaultAuthorization = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "defaultAuthorization");
    public static final String hasTemplateWindowElementState = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "hasTemplateWindowElementState");
    public static final String isInForce = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "isInForce");
    public static final String isHarmonizedBy = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "isHarmonizedBy");
    public static final String hasTemplateCategory = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "hasTemplateCategory");

    public static String hasDomainPriority() { return hasDomainPriority; };
    public static String hasPrivilege() { return hasPrivilege; };
    public static String hasUserPriority() { return hasUserPriority; };
    public static String hasPolicyTemplatePriority() { return hasPolicyTemplatePriority; };
    public static String hasTemplateCreator() { return hasTemplateCreator; };
    public static String hasTemplateWindow() { return hasTemplateWindow; };
    public static String hasPassword() { return hasPassword; };
    public static String createdUsingTemplate() { return createdUsingTemplate; };
    public static String hasAccessToKPATTemplate() { return hasAccessToKPATTemplate; };
    public static String originatedFromPolicy() { return originatedFromPolicy; };
    public static String hasTemplateWindowElement() { return hasTemplateWindowElement; };
    public static String createdUsingTemplateID() { return createdUsingTemplateID; };
    public static String hasAccessToKPATTab() { return hasAccessToKPATTab; };
    public static String defaultAuthorization() { return defaultAuthorization; };
    public static String hasTemplateWindowElementState() { return hasTemplateWindowElementState; };
    public static String isInForce() { return isInForce; };
    public static String isHarmonizedBy() { return isHarmonizedBy; };
    public static String hasTemplateCategory() { return hasTemplateCategory; };

     // Instances
    public static final String DefaultDenial = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "DefaultDenial");
    public static final String DefaultPermission = OntologyLanguageTagSelector.selectLanguageForTag(KAoSSystemOwlURL + "DefaultPermission");

    public static String DefaultDenial() { return DefaultDenial; };
    public static String DefaultPermission() { return DefaultPermission; };
}
