package kaos.ontology.vocabulary;

import kaos.ontology.util.OntologyLanguageTagSelector;

final public class OWLConcepts 
{
    final public static String owlURL = "http://www.w3.org/2002/07/owl#";
    
    // OWL concepts
    public static String OntologyClass() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "Class"); 
	}
    
    public static String Restriction() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "Restriction"); 
	}
	
	public static String Thing() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "Thing"); 
	}
	
	public static String ObjectProperty() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "ObjectProperty"); 
	}
	
	public static String DatatypeProperty() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "DatatypeProperty"); 
	}
	
	public static String TransitiveProperty() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "TransitiveProperty"); 
	}
    
    public static String SymmetricProperty() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "SymmetricProperty"); 
	}
    
    public static String FunctionalProperty() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "FunctionalProperty"); 
	}
	
	public static String InverseFunctionalProperty() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "InverseFunctionalProperty"); 
	}
	
	public static String AllDifferent() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "AllDifferent"); 
	}
	
	public static String Ontology() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "Ontology"); 
	}
	
	public static String DeprecatedClass() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "DeprecatedClass"); 
	}
    
    // OWL properties
    public static String equivalentProperty() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "equivalentProperty"); 
	}
    
    public static String equivalentClass() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "equivalentClass"); 
	}
	
	public static String disjointWith() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "disjointWith"); 
	}
	
	public static String sameAs() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "sameAs"); 
	}
	
	public static String differentFrom() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "differentFrom"); 
	}
	
	public static String distinctMembers() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "distinctMembers"); 
	}
    
    public static String unionOf() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "unionOf"); 
	}
    
    public static String intersectionOf() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "intersectionOf"); 
	}
	
	public static String complementOf() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "complementOf"); 
	}
	
	public static String oneOf() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "oneOf"); 
	}
	
	public static String onProperty() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "onProperty"); 
	}
	
	public static String allValuesFrom() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "allValuesFrom"); 
	}
   
    public static String hasValue() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "hasValue"); 
	}
    
    public static String toClass() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "toClass"); 
	}
	
    public static String someValuesFrom() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "someValuesFrom"); 
	}
	
	public static String minCardinality() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "minCardinality"); 
	}
	
	public static String maxCardinality() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "maxCardinality"); 
	}
	
	public static String cardinality() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "cardinality"); 
	}
	
	public static String inverseOf() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "inverseOf"); 
	}
	
	public static String imports()
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "imports"); 
	}
    
    public static String versionInfo() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "versionInfo"); 
	}
    
    public static String priorVersion() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "priorVersion"); 
	}
	
	public static String backwardCompatibleWith() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "backwardCompatibleWith"); 
	}
	
	public static String incompatibleWith() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(owlURL + "incompatibleWith"); 
	}
}