package kaos.ontology.vocabulary;

import kaos.ontology.util.OntologyLanguageTagSelector;

/**
 * Class generated automatically by kaos.tools.OWLOntologyJavaMapper.
 * Provides static methods to obtain URI's for the ontology concepts and properties.
 */
final public class PolicyConcepts
{
	final private static String PolicyOwlURL = "http://ontology.ihmc.us/Policy.owl#";

    public static String PolicyOwlURL() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL); 
	}

     // Concepts
    public static final String PosAuthorizationPolicy = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "PosAuthorizationPolicy");
    public static final String Policy = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "Policy");
    public static final String ObligationPolicy = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "ObligationPolicy");
    public static final String PosObligationPolicy = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "PosObligationPolicy");
    public static final String SiteOfEnforcement = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "SiteOfEnforcement");
    public static final String StartAfterRefActionEnd = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "StartAfterRefActionEnd");
    public static final String PolicyCondition = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "PolicyCondition");
    public static final String ObligationConstraint = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "ObligationConstraint");
    public static final String PrecedenceDescriptor = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "PrecedenceDescriptor");
    public static final String PolicySet = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "PolicySet");
    public static final String CollectiveObligationPolicy = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "CollectiveObligationPolicy");
    public static final String StartBeforeRefActionStart = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "StartBeforeRefActionStart");
    public static final String SatisfactionCondition = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "SatisfactionCondition");
    public static final String NegAuthorizationPolicy = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "NegAuthorizationPolicy");
    public static final String NegObligationPolicy = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "NegObligationPolicy");
    public static final String FinishBeforeRefActionEnd = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "FinishBeforeRefActionEnd");
    public static final String FinishBeforeRefActionStart = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "FinishBeforeRefActionStart");
    public static final String AuthorizationPolicy = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "AuthorizationPolicy");
    public static final String FinishWithSuccess = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "FinishWithSuccess");
    public static final String StartBeforeRefActionEnd = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "StartBeforeRefActionEnd");

    public static String PosAuthorizationPolicy() { return PosAuthorizationPolicy; };
    public static String Policy() { return Policy; };
    public static String ObligationPolicy() { return ObligationPolicy; };
    public static String PosObligationPolicy() { return PosObligationPolicy; };
    public static String SiteOfEnforcement() { return SiteOfEnforcement; };
    public static String StartAfterRefActionEnd() { return StartAfterRefActionEnd; };
    public static String PolicyCondition() { return PolicyCondition; };
    public static String ObligationConstraint() { return ObligationConstraint; };
    public static String PrecedenceDescriptor() { return PrecedenceDescriptor; };
    public static String PolicySet() { return PolicySet; };
    public static String CollectiveObligationPolicy() { return CollectiveObligationPolicy; };
    public static String StartBeforeRefActionStart() { return StartBeforeRefActionStart; };
    public static String SatisfactionCondition() { return SatisfactionCondition; };
    public static String NegAuthorizationPolicy() { return NegAuthorizationPolicy; };
    public static String NegObligationPolicy() { return NegObligationPolicy; };
    public static String FinishBeforeRefActionEnd() { return FinishBeforeRefActionEnd; };
    public static String FinishBeforeRefActionStart() { return FinishBeforeRefActionStart; };
    public static String AuthorizationPolicy() { return AuthorizationPolicy; };
    public static String FinishWithSuccess() { return FinishWithSuccess; };
    public static String StartBeforeRefActionEnd() { return StartBeforeRefActionEnd; };

     // Properties
    public static final String hasSiteOfEnforcement = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "hasSiteOfEnforcement");
    public static final String controls = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "controls");
    public static final String hasObligationStartDeadline = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "hasObligationStartDeadline");
    public static final String hasActionStateCondition = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "hasActionStateCondition");
    public static final String hasAdditionAuthorizationForThePeriodOfObligation = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "hasAdditionAuthorizationForThePeriodOfObligation");
    public static final String hasActionHistoryCondition = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "hasActionHistoryCondition");
    public static final String hasAlternativeActor = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "hasAlternativeActor");
    public static final String hasSourceAuthority = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "hasSourceAuthority");
    public static final String hasTrigger = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "hasTrigger");
    public static final String hasAdditionalPolicyIfObligationFailure = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "hasAdditionalPolicyIfObligationFailure");
    public static final String hasAuthority = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "hasAuthority");
    public static final String governs = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "governs");
    public static final String hasObligationConstraint = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "hasObligationConstraint");
    public static final String hasAction = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "hasAction");
    public static final String hasPrecedence = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "hasPrecedence");
    public static final String hasObligationFinishDeadline = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "hasObligationFinishDeadline");
    public static final String hasPolicyCondition = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "hasPolicyCondition");
    public static final String hasPriority = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "hasPriority");
    public static final String hasSatisfactionCondition = OntologyLanguageTagSelector.selectLanguageForTag(PolicyOwlURL + "hasSatisfactionCondition");

    public static String hasSiteOfEnforcement() { return hasSiteOfEnforcement; };
    public static String controls() { return controls; };
    public static String hasObligationStartDeadline() { return hasObligationStartDeadline; };
    public static String hasActionStateCondition() { return hasActionStateCondition; };
    public static String hasAdditionAuthorizationForThePeriodOfObligation() { return hasAdditionAuthorizationForThePeriodOfObligation; };
    public static String hasActionHistoryCondition() { return hasActionHistoryCondition; };
    public static String hasAlternativeActor() { return hasAlternativeActor; };
    public static String hasSourceAuthority() { return hasSourceAuthority; };
    public static String hasTrigger() { return hasTrigger; };
    public static String hasAdditionalPolicyIfObligationFailure() { return hasAdditionalPolicyIfObligationFailure; };
    public static String hasAuthority() { return hasAuthority; };
    public static String governs() { return governs; };
    public static String hasObligationConstraint() { return hasObligationConstraint; };
    public static String hasAction() { return hasAction; };
    public static String hasPrecedence() { return hasPrecedence; };
    public static String hasObligationFinishDeadline() { return hasObligationFinishDeadline; };
    public static String hasPolicyCondition() { return hasPolicyCondition; };
    public static String hasPriority() { return hasPriority; };
    public static String hasSatisfactionCondition() { return hasSatisfactionCondition; };

     // Instances

}
