package kaos.ontology.vocabulary;

import kaos.ontology.util.OntologyLanguageTagSelector;

/**
 * Class generated automatically by kaos.tools.OWLOntologyJavaMapper.
 * Provides static methods to obtain URI's for the ontology concepts and properties.
 */
final public class PolicyConflictResolutionConcepts
{
	final private static String PolicyConflictResolutionOwlURL = "http://ontology.ihmc.us/PolicyConflictResolution.owl#";

    public static String PolicyConflictResolutionOwlURL() 
	{
		return OntologyLanguageTagSelector.selectLanguageForTag(PolicyConflictResolutionOwlURL); 
	}

     // Concepts
    public static final String PolicyOverride = OntologyLanguageTagSelector.selectLanguageForTag(PolicyConflictResolutionOwlURL + "PolicyOverride");
    public static final String PrecedencePolicy = OntologyLanguageTagSelector.selectLanguageForTag(PolicyConflictResolutionOwlURL + "PrecedencePolicy");
    public static final String ResolvePolicyConflicts = OntologyLanguageTagSelector.selectLanguageForTag(PolicyConflictResolutionOwlURL + "ResolvePolicyConflicts");
    public static final String PolicyPrecedenceAction = OntologyLanguageTagSelector.selectLanguageForTag(PolicyConflictResolutionOwlURL + "PolicyPrecedenceAction");
    public static final String ConflictResolutionPolicy = OntologyLanguageTagSelector.selectLanguageForTag(PolicyConflictResolutionOwlURL + "ConflictResolutionPolicy");
    public static final String PolicyActor = OntologyLanguageTagSelector.selectLanguageForTag(PolicyConflictResolutionOwlURL + "PolicyActor");
    public static final String ObtainConflictResolutionApproval = OntologyLanguageTagSelector.selectLanguageForTag(PolicyConflictResolutionOwlURL + "ObtainConflictResolutionApproval");

    public static String PolicyOverride() { return PolicyOverride; };
    public static String PrecedencePolicy() { return PrecedencePolicy; };
    public static String ResolvePolicyConflicts() { return ResolvePolicyConflicts; };
    public static String PolicyPrecedenceAction() { return PolicyPrecedenceAction; };
    public static String ConflictResolutionPolicy() { return ConflictResolutionPolicy; };
    public static String PolicyActor() { return PolicyActor; };
    public static String ObtainConflictResolutionApproval() { return ObtainConflictResolutionApproval; };

     // Properties
    public static final String includeOverlappingPolicies = OntologyLanguageTagSelector.selectLanguageForTag(PolicyConflictResolutionOwlURL + "includeOverlappingPolicies");
    public static final String hasDeferredConflict = OntologyLanguageTagSelector.selectLanguageForTag(PolicyConflictResolutionOwlURL + "hasDeferredConflict");
    public static final String hasPreferredPolicy = OntologyLanguageTagSelector.selectLanguageForTag(PolicyConflictResolutionOwlURL + "hasPreferredPolicy");
    public static final String hasOverriddenPolicy = OntologyLanguageTagSelector.selectLanguageForTag(PolicyConflictResolutionOwlURL + "hasOverriddenPolicy");

    public static String includeOverlappingPolicies() { return includeOverlappingPolicies; };
    public static String hasDeferredConflict() { return hasDeferredConflict; };
    public static String hasPreferredPolicy() { return hasPreferredPolicy; };
    public static String hasOverriddenPolicy() { return hasOverriddenPolicy; };

     // Instances
    // Default Policy Set Instances
    public static final String DefaultPrecedencePolicySet = OntologyLanguageTagSelector.selectLanguageForTag("urn:KAoS#DefaultPrecedencePolicySet");
    public static String DefaultPrecedencePolicySet() { return DefaultPrecedencePolicySet; };

    public static final String DefaultConflictResolutionPolicySet = OntologyLanguageTagSelector.selectLanguageForTag("urn:KAoS#DefaultConflictResolutionPolicySet");
    public static String DefaultConflictResolutionPolicySet() { return DefaultConflictResolutionPolicySet; };

}
