/*
 * Created on Jan 28, 2009 To change the template for this generated file go to Window - Preferences - Java - Code Generation - Code and Comments
 */
package kaos.policy.builder;

import kaos.ontology.roleValueMap.KAoSRoleValueMapContainer;
import kaos.ontology.util.KAoSOntBuilder;
import kaos.ontology.util.KAoSOntClassBuilder;
import kaos.ontology.util.ValueNotSet;
import kaos.policy.history.HistoryActionBuilder;

public interface ConditionBuilder extends KAoSOntBuilder
{
    /*
     * @return the container with role-value-map constraints for Condition Class
     */
    public KAoSRoleValueMapContainer getRVMContainer();

    /*
     * Set the container with role-value-map constraints for Condition Class
     * @param rvmContainer - the role-value-map constraints 
     */
    public void setRVMContainer(KAoSRoleValueMapContainer rvmContainer);
    
    /*
     * Get the name of the current Condition class.
     * @return the name of the Condition
     * @exception ValueNotSet if the name is not known
     */
    public String getConditionClassName() throws ValueNotSet;

    /*
     * Set the pertinent history class ; if the it is already set, it will be replaced by the given one.
     * @param history the class describing pertinent history
     */
    public void setConditionClass(HistoryActionBuilder history);

    /*
     * Set the pertinent state class for this condition; if the class is already set, it will be replaced by the given one.
     * @param state the class describing pertinent state.
     */
    public void setConditionClass(KAoSOntClassBuilder state);
    
    /*
     * Get the pertinent history class or state of this condition.
     * @return the pertinent history class
     */
    public KAoSOntClassBuilder getConditionClass();

    /*
     * A utility method to print the condition.
     */
    public void showCondition();

    public class ConditionBuildingNotCompleted extends Exception
    {
        private static final long serialVersionUID = 4332980170456481251L;

        public ConditionBuildingNotCompleted()
        {
            super();
        }

        public ConditionBuildingNotCompleted(String s)
        {
            super(s);
        }
    }
}