/**
 * Last Modified by: $Author: auszok $
 * On: $Date: 2011/03/24 15:24:10 $
 */

package kaos.policy.history;

import kaos.ontology.roleValueMap.KAoSRoleValueMapContainer;
import kaos.ontology.util.ClassNameNotSet;
import kaos.ontology.util.KAoSOntClassBuilder;
import kaos.ontology.util.ValueNotSet;
import kaos.time.DurationDescription;

public interface HistoryActionBuilder extends KAoSOntClassBuilder
{
    public OntologyHistoryActionContainer getOntologyActionHistoryContainer();
    
    /*
     * Method to set the action for whom the history would be searched
     */
    public void setRegisteredAction(KAoSOntClassBuilder action) throws ClassNameNotSet;

    /*
     * to get the KAoSClassBuilder object representing the registered action of this history builder
     */
    public KAoSOntClassBuilder getRegisteredActionClass() throws ValueNotSet;

    /*
     * To set the minimum # for which an action, belonging to the registered action class, has to occur in order to make a policy applicable.
     */
    public void setMinCardinality(int count) throws ClassNameNotSet;

    /*
     * To get the minimum cardinality
     */
    public int getMinCardinality() throws ValueNotSet;

    /*
     * Set the beginning of the time window for which the history applies (e.g. in the last *30* to 60 seconds)
     */
    public void setHistoryValidityStartDuration(DurationDescription validityStartDuration) throws ClassNameNotSet;

    /*
     * Get the beginning of the time window for which the history applies (e.g. in the last *30* to 60 seconds)
     */
    public DurationDescription getHistoryValidityStartDuration() throws ValueNotSet;

    /*
     * Set the ending of the time window for which the history applies (e.g. in the last 30 to *60* seconds)
     */
    public void setHistoryValidityEndDuration(DurationDescription validityEndDuration) throws ClassNameNotSet;

    /*
     * Get the ending of the time window for which the history applies (e.g. in the last 30 to *60* seconds)
     */
    public DurationDescription getHistoryValidityEndDuration() throws ValueNotSet;

    /*
     * Set the role value map container for the history (a shared peer RVM, history does not have its own)
     */
    public void setRegisteredActionRVMContainer(KAoSRoleValueMapContainer actionContainer);

    /*
     * Get the role value map container for the history (a shared peer RVM, history does not have its own)
     */
    public KAoSRoleValueMapContainer getRegisteredActionRVMContainer();
}