package kaos.tools.webServiceTool;

import java.util.Map;
import java.util.Vector;
import java.util.Iterator;
import java.util.Collections;
import java.util.ArrayList;
import java.util.HashMap;

/**
 * User: mbreedy
 * Date: Mar 17, 2011
 * Time: 9:28:30 AM
 * @author Maggie Breedy
 * @version: $Revision: 1.26 $
 *
 */
public class OntologyServicesBuilder
{
    public OntologyServicesBuilder  (Map<String, ServicesObject> mainServicesMap, String fileType)
    {
        _mainServicesMap = mainServicesMap;
        _fileType = fileType;
        //System.out.println ("**getDataInOWL:_mainServicesMap: " + _mainServicesMap);
    }

    protected StringBuffer init (String serviceName)
    {
        //System.out.println ("**getDataInOWL:ServiceName: " + serviceName);
        String actionStr = "";
        String serviceNameStr = "";
        if (serviceName.contains (".wsdl")) {
           //_fileType = "wsdl";
           String[] array = serviceName.split (".wsdl");
           //System.out.println ("**array[0]: " + array[0]);
           if (array.length > 0) {
               serviceNameStr = array[0];
           }
           actionStr = "Action";
        }
        else if (serviceName.contains (".xsd")) {
           //_fileType = "xsd";
           String[] array = serviceName.split (".xsd");
           if (array.length > 0) {
               serviceNameStr = array[0];
           }
           actionStr = "Entity";
        }
        else {
           //_fileType = "other";
           serviceNameStr = serviceName;
           actionStr = "Action";
        }

        StringBuffer sb = new StringBuffer();
        ServicesObject servObj = _mainServicesMap.get (serviceName);
        if (servObj == null) {
            return sb;
        }
        Map<String, Vector> simpleTypes = servObj._simpleTypesMap;
        Map<String, OperationsObject> operationsMap = servObj._operationsMap;

        //************write the ontology header**************************
        String logicalURL = servObj._logicalURL;
        //System.out.println ("**getDataInOWL:logicalURL: " + logicalURL);
        sb.append (setOntologyHeader (logicalURL, "", "", serviceNameStr));

        //************Set the ontology imports***************************
        Map<String, String> importsMap = servObj._importedOntMap;

        sb.append ("\n" + "<!--Imports-->" + "\n");
        importsMap = servObj._importedOntMap;
        sb.append ("    <owl:Ontology rdf:about=\"\">" + "\n");
        Iterator it = importsMap.keySet().iterator();
        while (it.hasNext()) {
            //String impabbr = (String) it.next();
            String uri = importsMap.get (it.next());
            sb.append (setOntologyImports (uri));

        }
        sb.append ( "    </owl:Ontology>");
        sb.append ("\n");

        //*******************Write the classes and actions*****************
        if (_fileType.equals("mib")) {
            sb.append ("\n" + "\n" +"<!--Section with class and property definitions-->" + "\n");
        }
        else {
            sb.append ("\n" + "\n" +"<!--Section with class definitions-->" + "\n");
        }

        //sb.append (setSuperClassDefinition (serviceNameStr));
        String serObjName =  servObj._serviceName;
        if (serObjName.contains (".wsdl")) {
            String[] array = serObjName.split (".wsdl");
            //System.out.println ("**array[0]: " + array[0]);
            if (array.length > 0) {
                serObjName = array[0];
            }
        }
        else if (serObjName.contains (".xsd")) {
            String[] array = serObjName.split (".xsd");
            if (array.length > 0) {
                serObjName = array[0];
            }
        }
        //System.out.println ("**getDataInOWL:serObjName: " + serObjName);
        sb.append (setSuperClassDefinition (serObjName, actionStr, _fileType)); //**//

        String superClass = "";
        String action = "";
        //OperationsObject oo = null;
        Vector v = new Vector (operationsMap.keySet());
        Collections.sort (v);
        Iterator itr = v.iterator();
        while (itr.hasNext()) {
            String opName = (String) itr.next();
            //System.out.println ("**opName: " + opName);
            OperationsObject oo = operationsMap.get (opName);
            String objectID = oo._objectID;
            superClass = oo._actionSuperClassName;
            //System.out.println ("**superClass: " + superClass);
            action = oo._actionName;
            //System.out.println ("**action: " + action);
            //System.out.println ("**servNameStr: " + servNameStr);
            if (superClass.contains (":")) {
                //System.out.println ("**superClass contains abbr:" + abbr);
                String[] scArray = superClass.split(":");
                if (scArray.length > 1) {
                    String abbr = scArray[0];
                    //System.out.println ("**superClass abbr: " + abbr);
                    String uri = importsMap.get (abbr);
                    //System.out.println ("**superClass uri: " + uri);
                    //System.out.println ("**superClass scArray[1]: " + scArray[1]);
                    superClass =   uri + "/" + scArray[1];
                    //System.out.println ("**superClass splitted: " + superClass);
                    //sb.append (setSuperClassDefinition (superClass, actionStr, _fileType));
                    sb.append (setSuperClassDefinitionForOps (oo._operationName, abbr, uri, superClass));
                }
            }
            else if (action.contains (":")) {
                String[] acArray = action.split(":");
                if (acArray.length > 1) {
                    String abbr = acArray[0];
                    //System.out.println ("**Class abbr: " + abbr);
                    String uri = importsMap.get (abbr);
                    //System.out.println ("**Class uri: " + uri);
                    //System.out.println ("**Class acArray[1]: " + acArray[1]);
                    action =   uri + "/" + acArray[1];
                    //System.out.println ("**superClass splitted: " + superClass);
                    sb.append (setSuperClassDefinitionForOps (oo._operationName, abbr, uri, superClass));
                }
            }
            else {
                if (!_fileType.equalsIgnoreCase ("mib")) {
                    sb.append (setClassDefinition (oo._operationName, serviceNameStr, _fileType, objectID));
                }
            }
        }

        if (!_fileType.equals ("mib")) {
            sb.append ("\n" + "<!--Section with property definitions-->" + "\n");
        }

        Iterator it2 = operationsMap.keySet().iterator();
        while (it2.hasNext()) {
            String operationName = (String) it2.next();
            //System.out.println ("**operationName for properties: " + operationName);
            OperationsObject op = operationsMap.get (operationName);
            String opName = op._operationName;
            Map<String, ParametersObject> paramsMap = op._paramsMap;
            //System.out.println ("**operationName for properties: " + operationName);
            //System.out.println ("**opName for properties: " + opName);

            ParametersObject po = paramsMap.get (operationName);
            if (po == null) {
                continue;
            }
            //System.out.println ("**po: " + po);
            Vector<String> paramVector = po._owlPropertyName;
            Vector<String> rangeVector = po._owlPropertyRange;
            //System.out.println ("**typeVector: " + rangeVector);
            //System.out.println ("**paramVector: " + paramVector);
            Vector<String> minOccVector = po._minOcParam;
            Vector<String> maxOccVector = po._maxOcParam;
            //System.out.println ("**Ontology maxOccVector:<" + maxOccVector + ">");
            //System.out.println ("**Ontology minOccVector:<" + minOccVector + ">");
            Vector<Object> seqVector = po._sequencesVector;

            String objProp = "";
            String dataProp = "";

            if (opName.contains (":")) {
                String[] oparray = opName.split(":");
                if (oparray.length > 1) {
                    //System.out.println ("**oparray: " + oparray[0]);
                    if (importsMap.containsKey(oparray[0])) {
                        String uri = importsMap.get (oparray[0]);
                        opName = uri + "#" + oparray[1];
                    }
                }
            }

            //****************************Property vectors*******************************//

            if (_fileType.equalsIgnoreCase ("mib")) {
                String clssDef = "";
                String objectID = op._objectID;
                //System.out.println ("*******setClassDefinition1: " + op._actionName);

                if (op._actionName.contains ("Access")) {  //Textual Conventions name are not included
                    sb.append (setClassDefinition (opName, op._actionName, _fileType, objectID));
                }


                //for (int i=0; i<paramVector.size(); i++) {
                    //System.out.println ("**paramVector.elementAt(i): " + paramVector.elementAt(i));
                    //System.out.println ("**rangeVector.elementAt(i): " + rangeVector.elementAt(i));
                    //System.out.println ("**tcVector.elementAt(i): " + tcVector);
                    //System.out.println ("*******action: " + op._actionName);

                if (opName.contains ("Table")) {
                    //System.out.println ("*******opname is a Table!!");
                    objectID = "";
                    String name = "";
                    if (op._actionName.contains ("Access")) {
                        String[] sa = op._actionName.split ("Access");
                        name = sa[1];
                    }
                    else {
                        name = op._actionName;
                    }

                    for (int i=0; i<paramVector.size(); i++) {    //Needs to check ontology for many reads and writes
                        if (rangeVector.elementAt(i).contains ("write") && rangeVector.contains ("read")) {
                            System.out.println ("*******rangeVector.elementAt(i): " +rangeVector.elementAt(i));
                            String[] access = parseMibAccessStr (rangeVector.elementAt(i));
                            for (int j = 0; j< access.length; j++) {
                                //System.out.println ("*******access: " + access.length + " access name: " + access[j]);
                                if (access[j].equalsIgnoreCase ("write")) {
                                    //System.out.println ("*******setClassDefinition W: " + opName);
                                    clssDef = setClassDefinition (opName + "Write", name, "mib", "");
                                    sb.append (clssDef);
                                    //Special table mapping
                                    String spStr = setSpecialTableMapping ("Write" + opName, op._actionName, "mib");
                                    sb.append (spStr);
                                }
                                else {
                                    //System.out.println ("*******setClassDefinition R: " + opName);
                                    clssDef = setClassDefinition (opName + "Read", opName + "Write", "mib", "");
                                    sb.append (clssDef);
                                    String spStr = setSpecialTableMapping ("Read" + opName, op._actionName, "mib");
                                    sb.append (spStr);
                                }
                            }
                            break;
                        }
                        else if (rangeVector.elementAt(i).contains ("read-only")) {
                            clssDef = setClassDefinition (opName + "Read", opName + "Read", "mib", "");
                            sb.append (clssDef);
                            //Special table mapping
                            String spStr = setSpecialTableMapping ("Read" + opName, op._actionName, "mib");
                            sb.append (spStr);
                            break;
                        }
                    }
                    for (int i=0; i<paramVector.size(); i++) {
                        //System.out.println ("*******paramVector.elementAt(i): " + paramVector.elementAt(i));
                        if (seqVector.size() > i) {
                            //System.out.println ("*******paramVector.elementAt(ii): " + paramVector.elementAt(ii));
                            //Get the sequences associated with the range.
                            if (seqVector.elementAt(i) instanceof Vector) {
                                Vector<String> vec = (Vector) seqVector.elementAt(i);
                                //System.out.println ("*******vec: " + vec);
                                String seqTypes = "";
                                if (paramVector.elementAt(i).contains ("Type")) {
                                    seqTypes = setSimpleTypes (paramVector.elementAt(i)+ "Type", vec);
                                }
                                else {
                                    seqTypes = setSimpleTypes (paramVector.elementAt(i), vec);
                                }
                                sb.append (seqTypes);

                            }
                            else {
                                //do nothing
                            }
                        }
                        if (rangeVector.elementAt(i).contains ("read") && !rangeVector.elementAt(i).contains ("write")) {
                            //System.out.println ("*******actionNew:contains write: " + op._actionName);
                            if (seqVector.size() > i) {
                                //System.out.println ("*******tcVector.elementAt(i): " + tcVector.elementAt(i));
                                if (seqVector.elementAt(i).toString().contains("xsd:")) {
                                    String[] sa = seqVector.elementAt(i).toString().split("xsd:");
                                    String datProp = "";
                                    if (sa.length > 0) {
                                        datProp = setDataProperty (sa[1], paramVector.elementAt(i), opName, "mib");
                                    }
                                    sb.append (datProp);
                                }
                                else {
                                    String obPropStr = setSpecialObjectProperties (paramVector.elementAt(i), opName +
                                                                                   "Read", "mib", seqVector.elementAt(i).toString());
                                    sb.append (obPropStr);
                                }
                            }
                        }
                        else { //read and write
                            //System.out.println ("*******paramVector.elementAt(ii): " + rangeVector.elementAt(i));
                            //System.out.println ("*******rangeVector.elementAt(ii): " + rangeVector.elementAt(i));
                            if (seqVector.size() > i) {
                                if (seqVector.elementAt(i).toString().contains("xsd:")) {
                                        String[] sa = seqVector.elementAt(i).toString().split("xsd:");
                                        String datProp = "";
                                        if (sa.length > 0) {
                                            datProp = setDataProperty (sa[1], paramVector.elementAt(i), opName, "mib");
                                        }
                                        sb.append (datProp);
                                }
                                else if (!(seqVector.elementAt(i) instanceof Vector)) {
                                    String obPropStr = setSpecialObjectProperties (paramVector.elementAt(i), opName +
                                                                                   "Write", "mib", seqVector.elementAt(i).toString());
                                    sb.append (obPropStr);
                                }
                            }
                        }
                    }
                    /**for (int ii=0; ii<paramVector.size(); ii++) {
                        if (seqVector.size() > ii) {
                            //System.out.println ("*******paramVector.elementAt(ii): " + paramVector.elementAt(ii));
                            //Get the sequences associated with the range.
                            if (seqVector.elementAt(ii) instanceof Vector) {
                                Vector<String> vec = (Vector) seqVector.elementAt(ii);
                                //System.out.println ("*******vec: " + vec);
                                String seqTypes = "";
                                if (paramVector.elementAt(ii).contains("Type")) {
                                    seqTypes = setSimpleTypes (paramVector.elementAt(ii)+ "Type", vec);
                                }
                                else {
                                    seqTypes = setSimpleTypes (paramVector.elementAt(ii), vec);
                                }
                                sb.append (seqTypes);
                            }
                            else {
                                //do nothing
                            }
                        }
                    }**/
                }
                else {   //It is not a Table
                    //System.out.println ("*******It is not a Table: " + op._operationName);
                    //If it is a trap
                    if (op._operationName.contains ("Trap")) {
                        String[] sa = opName.split ("Trap");
                        if (sa.length > 0) {
                            opName = sa[0];
                        }
                        String trapStr = "";
                        String property = "";
                        String definition = "";
                        String tcString = "";
                        if (paramVector.size() > 0) {
                            property = paramVector.elementAt (0); //Contains the object of the trap class
                        }
                        if (rangeVector.size() > 0) {
                            definition = rangeVector.elementAt (0); //Contains the class the object belogs to
                        }
                        if (seqVector.size() > 0) {
                            tcString = seqVector.elementAt (0).toString(); //Contains the object type
                        }
                        trapStr = setTrapsDefinition (property, opName, objectID, definition, tcString);
                        sb.append (trapStr);
                        //System.out.println ("**setTrapsDefinition:trapsOwlDef: " + trapStr);
                    }
                    else {
                        //System.out.println ("*******ELSE:actionNew:rangeVector: " + rangeVector);
                       // if (rangeVector.contains("write") && rangeVector.contains("read")) {
                            for (int i=0; i<paramVector.size(); i++) {
                                //System.out.println ("*******ELSE:actionNew:contains write: " + rangeVector.elementAt(i));
                                if (rangeVector.elementAt(i).contains ("read")) {
                                    //System.out.println ("*******actionNew:contains write: " + op._actionName);
                                    clssDef = setClassDefinition ("Read" + opName, op._actionName, "mib", "");
                                    sb.append (clssDef);
                                }
                                else if (rangeVector.elementAt(i).contains ("write")) {
                                    //System.out.println ("*******actionNew:contains write " + op._actionName);
                                    clssDef = setClassDefinition ("Write" + opName, op._actionName, "mib", "");
                                    sb.append (clssDef);
                                }
                            }
                        //}
                    }
                }
            //}
            }
            else {
                for (int i=0; i<paramVector.size(); i++) {
                    //System.out.println ("**paramVector.elementAt(i): " + paramVector.elementAt(i));
                    String param = "";
                    String cardinalProp = "";
                    String clssDef = "";

                    if (paramVector.elementAt(i).contains (":")) {
                        //System.out.println ("**paramVector contains ::paramVector.elementAt(i): " + paramVector.elementAt(i));
                        String[] array = paramVector.elementAt(i).split(":");
                        if (array.length > 1) {
                            //System.out.println ("**paramVector added with abbr array[0]: " + array[0]);
                            String abb = array[0];
                            if (abb.contains ("x")) {
                                //System.out.println ("**DataProp:param1: " + param);
                                dataProp = setDataPropertyImpOnt (rangeVector.elementAt(i), param, opName);
                                sb.append (dataProp);
                            }
                            else {
                                if (importsMap.containsKey (abb)) {
                                    String uri = importsMap.get (abb);
                                    //System.out.println ("**paramVector added with uri in importsMap: " + uri);
                                    //System.out.println ("**paramVector added with array[1]: " + array[1]);
                                    objProp = setObjectImpProperties (array[1], opName, uri, "param");
                                    //System.out.println ("**paramVector appending1: " + objProp);
                                }
                                else {
                                    //System.out.println ("**paramVector appending2: " + objProp);
                                    sb.append (objProp);
                                    objProp = setObjectProperties (array[1], opName, _fileType);
                                }
                                //System.out.println ("**paramVector appending: " + objProp);
                                sb.append (objProp);
                            }
                        }
                    }
                    if (rangeVector.elementAt(i).contains (":")) {
                        //System.out.println ("*******rangeVector contains <:>:rangeVector.elementAt(i): " + rangeVector.elementAt(i));
                        param = paramVector.elementAt(i);
                        //System.out.println ("**DataProp:param2: " + param);
                        if (param.contains (":")) {
                            String[] parray = opName.split(":");
                            if (parray.length > 1) {
                                //System.out.println ("**oparray: " + parray[0]);
                                if (importsMap.containsKey(parray[0])) {
                                    String uri = importsMap.get (parray[0]);
                                    param = uri + "#" + parray[1];
                                }
                            }
                        }
                        //System.out.println ("**DataProp:param3: " + param);
                        String[] array = rangeVector.elementAt(i).split(":");
                        //System.out.println ("**data added with array[0]: " + array[0]);
                        if (array.length > 1) {
                            String abb = array[0];
                            //System.out.println ("**data added with abbr: " + abb);
                            if (abb.contains("x")) {
                                //System.out.println ("**data contains x:range: " + range + "..param: " + param + " ..opName:" + opName);
                                dataProp = setDataProperty (array[1], param, opName, _fileType);
                                sb.append (dataProp);
                            }
                            else if (abb.contains ("dm")) {
                                //System.out.println ("**OntoBuilder: abb: " + abb);
                                //objProp = setObjectProperties (array[1], operationName, _fileType);
                                String letter = findXSDFileForRange (servObj, array[1]);
                                //System.out.println ("**OntoBuilder:data adding letter: " + letter);
                                String typeAbbr = "dm" + letter;
                                //System.out.println ("**data added with typeAbbr: " + typeAbbr);
                                String uri = importsMap.get (typeAbbr);
                                //System.out.println ("**data added with uri: " + uri);
                                objProp = setObjectImpProperties (array[1], opName, uri, "range");
                                sb.append (objProp);

                            }
                            else if (abb.contains ("tns")){
                                //System.out.println ("**data with tns array[1]: " + array[1] + " ..with abb: " + abb);
                                //objProp = setSpecialObjectProperties (array[1], op._operationName,_fileType);
                                objProp = setSpecialObjectProperties (array[1], opName,_fileType, "");
                                sb.append (objProp);
                            }
                            else if (importsMap.containsKey (abb)) {
                                String uri = importsMap.get (abb);
                                //System.out.println ("**data added with uri: " + uri);
                                //item = "range";
                                objProp = setObjectImpProperties (array[1], opName, uri, "range");
                                sb.append (objProp);
                            }
                            //sb.append (dataProp);
                        }
                    }
                    if (!paramVector.elementAt(i).contains (":") && !rangeVector.elementAt(i).contains (":")){ //else
                        //System.out.println ("**paramVector.elementAt(i) last else: " + paramVector.elementAt(i));
                        //System.out.println ("***************last else*************");
                        //System.out.println ("**Ontology typeVector.elementAt(i): " + rangeVector.elementAt(i));
                        if (rangeVector.elementAt(i).equals("int")){
                                //System.out.println ("**Ontology equals??? typeVector.elementAt(i): " + typeVector.elementAt(i));
                                //dataProp = setDataProperty (rangeVector.elementAt(i), paramVector.elementAt(i),
                                //                            op._operationName, _fileType);
                                dataProp = setDataProperty (rangeVector.elementAt(i), paramVector.elementAt(i),
                                                            opName, _fileType);
                                sb.append (dataProp);
                        }
                        else if (paramVector.elementAt(i).equals("NoAttribute") && rangeVector.elementAt(i).equals("NoCT")) {
                            //Do nothing for now
                        }
                        else if (!paramVector.elementAt(i).equals("NoAttribute") && !rangeVector.elementAt(i).equals("NoType")) {
                            //objProp = setObjectProperties (paramVector.elementAt(i), rangeVector.elementAt(i),_fileType);
                            //objProp = setObjectProperties (paramVector.elementAt(i), op._operationName,_fileType);
                            objProp = setObjectProperties (paramVector.elementAt(i), opName,_fileType);
                            sb.append (objProp);
                        }
                        //sb.append (dataProp);
                    }

                    if (minOccVector.size() > 0 && maxOccVector.size() > 0) {
                        if (!maxOccVector.elementAt(i).equals("") &&  !minOccVector.elementAt(i).equals("")) {
                                cardinalProp = setCardinality (opName, paramVector.elementAt(i), maxOccVector.elementAt(i),
                                                               minOccVector.elementAt(i), _fileType);
                            }
                          else if (maxOccVector.elementAt(i).equals("") &&  !minOccVector.elementAt(i).equals("")) {
                                cardinalProp = setCardinality (opName, paramVector.elementAt(i), "", minOccVector.elementAt(i),
                                                               _fileType);
                           }
                           else if (!maxOccVector.elementAt(i).equals("") &&  minOccVector.elementAt(i).equals("")) {
                                cardinalProp = setCardinality (opName, paramVector.elementAt(i), maxOccVector.elementAt(i), "",
                                                               _fileType);
                            }
                            sb.append (cardinalProp);
                    }

                }
            }
        }
        //Simple Types
        if (simpleTypes.size() > 0) {
            //System.out.println ("**Ontology simpleTypes.size(): " + simpleTypes.size());
            String dataProp = "";
            Iterator itre = simpleTypes.keySet().iterator();
            while (itre.hasNext()) {
                String name = (String) itre.next();
                //System.out.println ("**Ontology simpleTypes name: " + name);
                Vector vst = simpleTypes.get(name);
                //To ensure no MIB table entry shows in the ontology
                if (!name.contains("Entry")) {
                    if (vst.contains("INTEGER")) {
                        dataProp = setDataProperty ("int", name, name, "mib");
                        sb.append (dataProp);
                    }
                    else if (vst.contains("STRING")) {
                        dataProp = setDataProperty ("string", name, name, "mib");
                        sb.append (dataProp);
                    }
                    else {
                        String simpTyp = setSimpleTypes (name, vst);
                        sb.append (simpTyp);
                    }
                }
            }
        }

        sb.append (setFinalStatement());
        //System.out.println ("**sb: " + sb);
        return sb;
    }

    protected StringBuffer getTableElements (Map<String, HashMap> tableMap)
    {
        StringBuffer sb = new StringBuffer();
        Iterator it = tableMap.keySet().iterator();
        while (it.hasNext()) {
            String tableName = (String) it.next();
            System.out.println ("------tableName: " + tableName);
            HashMap<String,Vector> tableDataTypes = tableMap.get (tableName);
            Iterator it2 = tableDataTypes.keySet().iterator();
            while (it2.hasNext()) {
                String elemName = (String) it.next();
                System.out.println ("------elemName: " + elemName);
                Vector<String> tableVector = tableDataTypes.get (elemName);
                 System.out.println ("------tableVector: " + tableVector);
                if (tableVector.size() > 2) {
                    String objId = tableVector.elementAt(0);
                    String access = tableVector.elementAt(1);
                    String[] strArray = parseMibAccessStr (access);
                    if (strArray.length > 0) {
                        if (strArray.length > 1) {
                            for (int i=0; i< strArray.length; i++) {
                                //System.out.println ("------strArray[i]: " + strArray[i]);
                                String str = setObjectProperties (strArray[i], elemName + "Write", "mibs");
                                sb.append (str);
                            }
                        }
                        else {
                            String str = setObjectProperties (strArray[0], elemName + "Read", "mibs");
                            sb.append (str);
                        }
                    }
                }
            }
        }
        return sb;
    }

    /**
     * Finds the xsd file that defines the range index.
     * @param servObj
     * @param rangeStr
     * @return the range index
     */
    public String findXSDFileForRange (ServicesObject servObj, String rangeStr)
    {
        String rangeDef = "";
        Map<String, OperationsObject> operationsMap = null;
        //System.out.println(" ********rangeStr: " + rangeStr);
        TreeFileObject treeObject = servObj._treeObject;
        ArrayList listOfXSD = treeObject._listOfChildren;
        for (Object servNameObj : listOfXSD) {
            //System.out.println(" ********_mainServicesMap: " + _mainServicesMap);
            //System.out.println(" ********_xsdFileHashtable: " + _xsdFileHashtable);
            //System.out.println(" ********servNameObj: " + servNameObj.toString());
            ServicesObject so = _mainServicesMap.get (servNameObj.toString());
            if (so != null) {
                operationsMap = so._operationsMap;
            }

            if (operationsMap != null) {
                Iterator it = operationsMap.keySet().iterator();
                while (it.hasNext()) {
                    String opName = (String) it.next();
                    //System.out.println(" ********opName: " + opName);
                    if (opName.equals (rangeStr)) {
                        String str = servNameObj.toString();
                        rangeDef = str.substring (0,1);
                    }
                }
            }
        }
        //System.out.println(" ********Substring of: " + rangeDef);
        return rangeDef;
    }

       /**
     * Define the object properties for the ontology
     *
     * @param property name of the property
     * @param classDef name of the method
     * @return string of properties
     */
    protected String setObjectProperties (String property, String classDef, String fileType)
    {
        //System.out.println ("**setObjectProperties:fileType: " + fileType);
        //System.out.println ("**setObjectProperties:property: " + property);
        //System.out.println ("**setObjectProperties:classOwlDef: " + classDef);
        String props = "";
        if (classDef.contains ("Action")) {
            String[] sa = classDef.split ("Action");
            if (sa.length > 0) {
                classDef = sa[0];
            }
        }

        if (fileType.equals ("wsdl")) {
            props = "\n" + "    <owl:ObjectProperty rdf:ID=" + "\"" + property + "\"> \n" +
                    "         <rdfs:domain rdf:resource=\"" + "#" + classDef + "Action" + "\"" + "/>\n" +
                      "    </owl:ObjectProperty> \n";
        }
        else {
            props = "\n" + "    <owl:ObjectProperty rdf:ID=" + "\"" + property + "\"> \n" +
                    "         <rdfs:domain rdf:resource=\"" + "#" + classDef + "\"" + "/>\n" +
                      "    </owl:ObjectProperty> \n";
        }
        //System.out.println ("**ObjProp: " + props); range was classDef
        return props;
    }

    protected String setSpecialObjectProperties (String property, String classDef, String fileType, String tcString)
    {
        //System.out.println ("**setSpObjectProperties:fileType: " + fileType);
        //System.out.println ("**setSpObjectProperties:property: " + property);
        //System.out.println ("**setSpObjectProperties:classOwlDef: " + classDef);
        String props = "";
        if (classDef.contains ("Action")) {
            String[] sa = classDef.split ("Action");
            if (sa.length > 0) {
                classDef = sa[0];
            }
        }

        if (fileType.equals ("wsdl")) {
            props = "\n" + "    <owl:ObjectProperty rdf:ID=" + "\"" + property + "\"> \n" +
                    "         <rdfs:domain rdf:resource=\"" + "#" + classDef + "Action" + "\"" + "/>\n" +
                    "       <rdfs:range rdf:resource=" + "\"" + "#" + classDef + "Action" + "\"" + "/> \n" +
                      "    </owl:ObjectProperty> \n";
        }
        else if (fileType.equals ("mib")) {
            //Remove "Access"
            if (classDef.contains ("Access")) {
                String[] sa = classDef.split ("Access");
                if (sa.length > 0) {
                    classDef = sa[1];
                }
            }
            //System.out.println ("**setSpObjectProperties:classOwlDef: " + classDef);
            props = "\n" + "    <owl:ObjectProperty rdf:ID=" + "\"" + "has" + property + "\"> \n" +
                    "         <rdfs:domain rdf:resource=\"" + "#" + classDef + "\"" + "/>\n" +
                    "       <rdfs:range rdf:resource=" + "\"" + "#" + tcString + "\"" + "/> \n" +
                      "    </owl:ObjectProperty> \n";
        }
        else {
            props = "\n" + "    <owl:ObjectProperty rdf:ID=" + "\"" + property + "\"> \n" +
                    "         <rdfs:domain rdf:resource=\"" + "#" + classDef + "\"" + "/>\n" +
                    "       <rdfs:range rdf:resource=" + "\"" + "#" + classDef + "\"" + "/> \n" +
                      "    </owl:ObjectProperty> \n";
        }
        //System.out.println ("**ObjProp: " + props); range was classDef
        return props;
    }

    /**
     * Maps tables that have read and write access to ontology. Only for MIB files
     * @param property  read and write access
     * @param classDef  name of the table
     * @param fileType  mib file
     * @return
     */
    protected String setSpecialTableMapping (String property, String classDef, String fileType)
    {
        String props = "";
        if (property.contains ("Action")) {
            String[] sa = classDef.split ("Action");
            if (sa.length > 0) {
                property = sa[0];
            }
        }
        if (classDef.contains ("Access")) {
            String[] sa = classDef.split ("Access");
            if (sa.length > 0) {
                classDef = sa[1];
            }
        }

        props = "\n" + "    <owl:Class rdf:ID=\"" +  property + "Action" + "\"> \n" +
                        "        <rdfs:subClassOf rdf:resource=\"#" + "Access" + classDef + "\"/>\n" +
                        "        <rdfs:subClassOf> \n" +
                        "           <owl:Restriction>\n" +
                        "              <owl:onProperty><owl:ObjectProperty rdf:about=\"#" + classDef + "\"/>" + "</owl:onProperty>\n" +
                        "              <owl:allValuesFrom><owl:Class rdf:about=\"#" + property + "\"/>" + "</owl:allValuesFrom>\n" +
                        "           </owl:Restriction>\n" +
                        "        </rdfs:subClassOf> \n" +
                        "    </owl:Class>" + "\n";
        return props;
    }


    /**
     * Defines the object properties for the ontology.
     *
     * @param property  name of a property
     * @param classDef  operation name
     * @param uri  the uri of the imported ontology
     * @return string of the object properties
     */
    protected String setObjectImpProperties (String property, String classDef, String uri, String item)
    {
        /*System.out.println ("**setObjectImpProperties:property: " + property);
        System.out.println ("**setObjectImpProperties:classOwlDef: " + classDef);
        System.out.println ("**setObjectImpProperties:uri: " + uri);*/

        String props = "";
        if (item.equals ("param")) {
            props = "\n" + "    <owl:ObjectProperty rdf:about=" + "\"" + uri + "#" + property + "\"> \n" +
                    "         <rdfs:domain rdf:resource=\"" + "#" + classDef + "\"" + "/>\n" +
                      "    </owl:ObjectProperty> \n";
        }
        else if (item.equals ("range")) {
            props = "\n" + "    <owl:ObjectProperty rdf:about=" + "\"" + uri + "#" + property + "\"> \n" +
                    "         <rdfs:domain rdf:resource=\"" + "#" + classDef + "\"" + "/>\n" +
                    "       <rdfs:range rdf:resource=" + "\"" + uri + "#" + property + "\"" + "/> \n" +
                      "    </owl:ObjectProperty> \n";
        }
        
        //System.out.println ("**ObjProps with uri: " + uri + " **ObjProp: " + props);
        return props;
    }

    /**
     * Define the data properties for the ontology
     *
     * @param property  name of the property
     * @param type  type of the property
     * @param classDef  name of the method
     * @return  string of properties
     */
    protected String setDataProperty (String property, String type, String classDef, String fileType)
    {
        String props = "";
        if (classDef.contains ("Action")) {
            String[] sa = classDef.split ("Action");
            if (sa.length > 0) {
                classDef = sa[0];
            }
        }

        if (fileType.equals ("wsdl")) {
            props = "\n" + "    <owl:DatatypeProperty rdf:ID=" + "\"" + type + "\"" + "> \n" +
                    "       <rdf:type rdf:resource=" + "\"" + "http://www.w3.org/2002/07/owl#FunctionalProperty" +
                    "\"" + "/> \n" +
                    "       <rdfs:domain rdf:resource="+ "\"" + "#" + classDef + "Action" + "\"" + "/> \n" +
                    "       <rdfs:range rdf:resource=" + "\"" + "http://www.w3.org/2001/XMLSchema#" + property + "\"" + "/> \n" +
                    "    </owl:DatatypeProperty> \n";
        }
        else {
            props = "\n" + "    <owl:DatatypeProperty rdf:ID=" + "\"" + type + "\"" + "> \n" +
                    "       <rdf:type rdf:resource=" + "\"" + "http://www.w3.org/2002/07/owl#FunctionalProperty" +
                    "\"" + "/> \n" +
                    "       <rdfs:domain rdf:resource="+ "\"" + "#" + classDef + "\"" + "/> \n" +
                    "       <rdfs:range rdf:resource=" + "\"" + "http://www.w3.org/2001/XMLSchema#" + property + "\"" + "/> \n" +
                    "    </owl:DatatypeProperty> \n";
        }
        //System.out.println ("**dataProp: " + props);
        return props;
    }
    

   /**
     * Defines the data properties for the ontology.
     *
     * @param property  name of a property
     * @param parameter name of a parameter
     * @param classDef  operation name
     * @return  string of the data properties
     */
    protected String setDataPropertyImpOnt (String property, String parameter, String classDef)
    {
        //System.out.println ("**New classDef: " + classDef);
        //System.out.println ("**New range:range: " + property);
        //System.out.println ("**New parameter:parameter: " + parameter);

        String props = "\n" + "    <owl:DatatypeProperty rdf:about=" + "\"" + parameter + "\"" + "> \n" +
                "       <rdf:type rdf:resource=" + "\"" + "http://www.w3.org/2002/07/owl#FunctionalProperty" +
                "\"" + "/> \n" +
                "       <rdfs:domain rdf:resource="+ "\"" + classDef + "\"" + "/> \n" +
                "       <rdfs:range rdf:resource=" + "\"" + "http://www.w3.org/2001/XMLSchema#" + property + "\"" + "/> \n" +
                "    </owl:DatatypeProperty> \n";
        //System.out.println ("**dataProp: " + props);
        return props;
    }

    /**
     * Defines all class definitions for the ontology
     *
     * @param classDef  the name of the method
     * @param serviceName  service name selected
     * @return string class definition
     */
    protected String setClassDefinition (String classDef, String serviceName, String fileType, String objectID)
    {
        //System.out.println ("**setClassDefinition:fileType: " + fileType);
        //System.out.println ("**setClassDefinition:ServiceName: " + serviceName);
        serviceName = printCapitalized (serviceName);
        String servClassOwlDef = "";
        String objectIDString = "        <rdfs:comment>" + "OID:" + objectID + "</rdfs:comment> \n";

        if (classDef.contains ("Action") && !fileType.equals("mib")) {
            String[] sa = classDef.split ("Action");
            if (sa.length > 0) {
                classDef = sa[0];
            }
        }

        if (fileType.equals ("wsdl")) {
            if (!serviceName.contains ("Action")) {
                serviceName = serviceName + "Action";
            }
            if (objectID.equals ("")) {
                servClassOwlDef = "\n" + "    <owl:Class rdf:ID=\"" +  classDef + "Action" + "\"> \n" +
                        "        <rdfs:subClassOf rdf:resource=\"#" + serviceName + "\"/>\n"
                                 + "    </owl:Class>\n";
            }
            else {
                servClassOwlDef = "\n" + "    <owl:Class rdf:ID=\"" +  classDef + "Action" + "\"> \n" + objectIDString +
                        "        <rdfs:subClassOf rdf:resource=\"#" + serviceName + "\"/>\n"
                                 + "    </owl:Class>\n";
            }
        }
        else if (fileType.equals ("mib")) {
            if (classDef.contains ("Table")) {
                String[] sa = classDef.split("Access");
                if (!objectID.equals ("")) {
                    //System.out.println ("**setClassDefinition:classDef: " + classDef);
                    //System.out.println ("**setClassDefinition:objectID: " + objectID);
                    if (!classDef.contains("Read") && !classDef.contains("Write")) {
                        String ont1 = "http://ontology.ihmc.us/Computing/Network/NetworkAction.owl#NetworkAction";
                        String servClass1 = "\n" + "    <owl:Class rdf:ID=\"" +  classDef + "Action" + "\"> \n" +
                                "        <rdfs:subClassOf rdf:resource=\"" + ont1 + "\"/> \n" + objectIDString +
                                          "    </owl:Class>\n";
                        //System.out.println ("**setClassDefinition:servClass1: " + servClass1);

                        String ont2 = "http://ontology.ihmc.us/Computing/Network/NetworkEntity.owl#NetworkEntity";
                            String servClass2 = "";
                        if (classDef.contains("Access")) {
                            //String[] sa = classDef.split("Access");
                            servClass2 = "\n" + "    <owl:Class rdf:ID=\"" +  sa[1] + "\"> \n" +
                                "        <rdfs:subClassOf rdf:resource=\"" + ont2 + "\"/> \n" + objectIDString +
                                          "    </owl:Class>\n";
                        }
                        else {
                            servClass2 = "\n" + "    <owl:Class rdf:ID=\"" +  classDef + "\"> \n" +
                                "        <rdfs:subClassOf rdf:resource=\"" + ont2 + "\"/> \n" + objectIDString +
                                          "    </owl:Class>\n";
                        }
                        //System.out.println ("**setClassDefinition:servClass2: " + servClass2);
                        servClassOwlDef = servClass1 + "\n" + servClass2;
                    }
                }
                else {
                    String servClass3 = "";
                    if (classDef.contains("Access")) {
                        classDef = sa[1];
                    }
                    if (classDef.contains("Write")) {
                        servClass3 = "\n" + "    <owl:Class rdf:ID=\"" +   classDef + "\"> \n" +
                            "        <rdfs:subClassOf rdf:resource=\"#" + serviceName + "\"/>\n"
                                     + "    </owl:Class>\n";

                    }
                    else if (classDef.contains("Read")) {
                        servClass3 = "\n" + "    <owl:Class rdf:ID=\"" +   classDef + "\"> \n" +
                            "        <rdfs:subClassOf rdf:resource=\"#" + serviceName + "\"/>\n"
                                     + "    </owl:Class>\n";
                    }
                    servClassOwlDef = servClass3 + "\n";
                }
            }
            else {
                if (objectID.equals ("")) {
                    servClassOwlDef = "\n" + "    <owl:Class rdf:ID=\"" +  classDef + "Action" + "\"> \n" +
                            "        <rdfs:subClassOf rdf:resource=\"#" + serviceName + "\"/>\n"
                                     + "    </owl:Class>\n";
                }
                else {
                    String ontologyURL = "http://ontology.ihmc.us/Computing/Network/NetworkAction.owl#NetworkAction";
                    servClassOwlDef = "\n" + "    <owl:Class rdf:ID=\"" +  classDef + "Action" + "\"> \n" +
                            "        <rdfs:subClassOf rdf:resource=\"" + ontologyURL + "\"/> \n" + objectIDString +
                                      "    </owl:Class>\n";
                }
            }
        }
        else {
            if (serviceName.contains ("Action")) {
                String[] sa = serviceName.split ("Action");
                 if (sa.length > 0) {
                    serviceName = sa[0];
                 }
            }
            if (objectID.equals ("")) {
                servClassOwlDef = "\n" + "    <owl:Class rdf:ID=\"" +  classDef + "\"> \n" +
                        "        <rdfs:subClassOf rdf:resource=\"#" + serviceName + "\"/>\n"
                                 + "    </owl:Class>\n";
            }
            else {
                servClassOwlDef = "\n" + "    <owl:Class rdf:ID=\"" +  classDef + "\"> \n" + objectIDString +
                        "        <rdfs:subClassOf rdf:resource=\"#" + serviceName + "\"/>\n"
                                 + "    </owl:Class>\n";
            }
        }

        return servClassOwlDef;
    }

    /**
     * Maps the MIB traps to the ontology
     * 
     * @param property  name of the object of this notification type
     * @param classDef  name of the class of action
     * @param objectID  object ID of the class of action
     * @param definition name of the table which the object belongs to
     * @return
     */
    protected String setTrapsDefinition (String property, String classDef, String objectID, String definition, String tcStr)
    {
        //System.out.println ("**setTrapsDefinition:classDef: " + classDef);
        StringBuffer trapsOwlDef = new StringBuffer();
        String rangeRes = "";
        if (tcStr.contains("xsd:")) {
             String[] sa = tcStr.split("xsd:");
             if (sa.length > 0) {
                 //tcStr = "\"http://www.w3.org/2000/01/rdf-schema#" + sa[1] + "\"";
                 tcStr = "http://www.w3.org/2000/01/rdf-schema#" + sa[1];
             }
        }
        else {
            tcStr = "#" + tcStr;
        }
        String objectIDString = "        <rdfs:comment>" + "OID:" + objectID + "</rdfs:comment> \n";

        String ontologyURL = "http://ontology.ihmc.us/Computing/Network/NetworkAction.owl#NetworkAction";

        String prop1 = "\n" + "    <owl:Class rdf:ID=\"" +  "Receive" + classDef + "Action" + "\"> \n" +
                "        <rdfs:subClassOf rdf:resource=\"" + ontologyURL + "\"/> \n" + objectIDString +
                          "    </owl:Class>\n";
        trapsOwlDef.append (prop1);

        String prop2 = "\n" + "    <owl:ObjectProperty rdf:ID=\"" + "has" + property + "\"> \n" +
                    "         <rdfs:domain>\n" +
                    "            <owl:Class>\n" +
                    "               <owl:unionOf rdf:parseType=\"" + "Collection" + "\"> \n" +
                    "                  <owl:Class rdf:about=\"" + "#" + "Receive" + classDef + "\"/> \n" +
                    "                  <owl:Class rdf:about=\"" + "#" + definition + "\"/> \n" +
                    "               </owl:unionOf>\n" +
                    "            </owl:Class>\n" +
                    "         </rdfs:domain>\n" +
                    "       <rdfs:range rdf:resource=\"" + tcStr + "\"/> \n" +
                    "    </owl:ObjectProperty> \n";

        trapsOwlDef.append (prop2);

        return trapsOwlDef.toString();
    }

    /**
      * Defines the operations name for the ontology
      *
      * @param operationName operation name
      * @param abbr  abbreviation of the uri
      * @param uri   the uri of the imported ontology
      * @param superClass superServName super class name string
      * @return  string with operations name definitions
      */
     protected String setSuperClassDefinitionForOps (String operationName, String abbr, String uri, String superClass)
     {
         //System.out.println ("**classOwlDef:operationName: " + operationName);
         //System.out.println ("**classOwlDef:uri: " + uri);
         //System.out.println ("**classOwlDef:superClass: " + superClass);
         String newImpOntAdded = null;
         if (operationName.contains(":")) {
             String[] array = operationName.split(":");
             if (array.length > 1) {
                 operationName = array[1];
                 newImpOntAdded = "\n" + "    <owl:Class rdf:about=\"" +  uri + "#" + operationName + "\"> \n" +
                    "        <rdfs:subClassOf rdf:resource=\"" + superClass + "\"/>\n" +
                    "    </owl:Class>\n";
             }
         }
         else {
             newImpOntAdded = "\n" + "    <owl:Class rdf:about=\"" +  "#" + operationName + "\"> \n" +
                    "        <rdfs:subClassOf rdf:resource=\"" + superClass + "\"/>\n" +
                    "    </owl:Class>\n";
         }

         //System.out.println ("**classOwlDef: " + classOwlDef);
         return newImpOntAdded;
     }


    /**
     * Defines the ontology header
     *
     * @param logicalURL    the logical url string
     * @param abbr  abbreviation of the uri
     * @param uriStr    the uri of the imported ontology
     * @return  string of the header of the ontology
     */
    protected String setOntologyHeader (String logicalURL, String abbr, String uriStr, String servNameStr)
    {
        String header = "";

        if (abbr.equals ("") && uriStr.equals ("")) {
            String header1 = "<?xml version='1.0'?>\n" +
                "<!--OWL Language, version 08/2003-->" + "\n" +
                "<rdf:RDF xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" \n" +
                "    xmlns:rdfs=\"http://www.w3.org/2000/01/rdf-schema#\" \n" +
                "    xmlns:owl=\"http://www.w3.org/2002/07/owl#\"\n" +
                "    xmlns=\"" + logicalURL + "#\"> \n" ;
            header = header1;
        }

        return header;
    }

    protected String setOntologyImports (String importURI)
    {
        String imports =
                "        <owl:imports rdf:resource=\"" + importURI + "\"/>\n";
        return imports;
    }

    /**
     * Defines the super class definition in the ontology
     *
     * @param serviceName service name selected
     * @return string super class definition
     */
    protected String setSuperClassDefinition (String serviceName, String actionStr, String fileType)
    {
        String servClassOwlDef = "";
        serviceName = printCapitalized (serviceName);
        actionStr = printCapitalized (actionStr);

        if (fileType.equals ("wsdl")) {
            if (!serviceName.contains ("Action")) {
                serviceName = serviceName + "Action";
            }
            servClassOwlDef = "\n" + "    <owl:Class rdf:ID=\"" +  serviceName +"\"> \n" +
                "        <rdfs:subClassOf rdf:resource=\"http://ontology.ihmc.us/" + actionStr + ".owl#"
                 + "Action" + "\"/>\n" + "    </owl:Class>\n";
        }
        else {
            if (serviceName.contains ("Action")) {
                String[] sa = serviceName.split ("Action");
                 if (sa.length > 0) {
                    serviceName = sa[0];
                 }
            }
            servClassOwlDef = "\n" + "    <owl:Class rdf:ID=\"" +  serviceName +"\"> \n" +
                "        <rdfs:subClassOf rdf:resource=\"http://ontology.ihmc.us/" + actionStr + ".owl#LogicalEntity"
                 + "\"/>\n" + "    </owl:Class>\n";
        }

        //System.out.println ("**serviceName: " + serviceName);
        //System.out.println ("**classOwlDef: " + classOwlDef);
        return servClassOwlDef;
    }

    protected String setCardinality (String classDef, String property, String maxCardinality, String minCardinality,
                                     String fileType)
    {
        String cardinalProperty = "";
        if (!fileType.equals ("wsdl") && classDef.contains ("Action")) {
            String[] sa = classDef.split ("Action");
            if (sa.length > 0) {
                classDef = sa[0];
            }
        }

        if (!maxCardinality.equals ("") && minCardinality.equals ("")) {
            cardinalProperty = "\n" + "    <owl:Class rdf:ID=" + classDef + "\"> \n" +
                "             <rdfs:subClassOf>" + "\n" +
                "                <owl:Restriction>" + "\n" +
                "                    <owl:onProperty rdf:resource=\"" + "#"  + property + "\"/>\n" +
                "                    <owl:maxCardinality>" + maxCardinality + "</owl:maxCardinality>\n" +
                "                </owl:Restriction>\n" +
                "            </rdfs:subClassOf>\n" +
                "      </owl:Class>\n";
        }
        else if (maxCardinality.equals ("") && !minCardinality.equals ("")) {
            cardinalProperty = "\n" + "   <owl:Class rdf:ID=" + classDef + "\"> \n" +
                "             <rdfs:subClassOf>" + "\n" +
                "                <owl:Restriction>" + "\n" +
                "                    <owl:onProperty rdf:resource=\"" + "#"  + property + "\"/>\n" +
                "                    <owl:minCardinality>" + minCardinality + "</owl:minCardinality>\n" +
                "                </owl:Restriction>\n" +
                "            </rdfs:subClassOf>\n" +
                "      </owl:Class>\n";
        }
        else {
            cardinalProperty = "\n" + "    <owl:Class rdf:ID=" + classDef + "\"> \n" +
                    "             <rdfs:subClassOf>" + "\n" +
                    "                <owl:Restriction>" + "\n" +
                    "                    <owl:onProperty rdf:resource=\"" + "#"  + property + "\"/>\n" +
                    "                    <owl:minCardinality>" + minCardinality + "</owl:minCardinality>\n" +
                    "                    <owl:maxCardinality>" + maxCardinality + "</owl:maxCardinality>\n" +
                    "                </owl:Restriction>\n" +
                    "             </rdfs:subClassOf>\n" +
                    "      </owl:Class>\n";
        }
        return cardinalProperty;
    }

    protected String setSimpleTypes (String classDef, Vector<String> v)
    {
        StringBuffer simpleTypesSB = new StringBuffer();
        if (_fileType.equals ("mib")) {
            String header = "\n" + "   <owl:Class rdf:ID=\"" + classDef + "\">" ;
            simpleTypesSB.append (header);
            String header2 = "\n" + "          <owl:oneOf rdf:parseType=\"" + "Collection" + "\">" ;
            simpleTypesSB.append (header2);
            Iterator it = v.iterator();
            while (it.hasNext()) {
                String st = (String) it.next();
                 simpleTypesSB.append ("\n" + "               <owl:Thing rdf:about=\"" + "#" + st + "\"/>");
            }
            simpleTypesSB.append ("\n" +"          </owl:oneOf>");
            simpleTypesSB.append ("\n" +"   </owl:Class>\n");
        }
        else {
            String header = "\n" + "   <owl:oneOf rdf:parseType=" + classDef + "\">" ;
            simpleTypesSB.append (header);

            Iterator it = v.iterator();
            while (it.hasNext()) {
                String st = (String) it.next();
                 simpleTypesSB.append ("\n" + "        <owl:Thing rdf:about=\"" + "#" + st + "\"/>");
            }
            simpleTypesSB.append ("\n" +"   </owl:oneOf>\n");
        }
        return simpleTypesSB.toString();
    }

    /**
     * Defines the final statement of the ontology
     *
     * @return  string
     */
    protected String setFinalStatement()
    {
        return "\n" +"</rdf:RDF>";
    }

    protected String printCapitalized (String str)
    {
        StringBuffer result = new StringBuffer (str.length()) ;
        String[] words = str.split("\\s");
        if (words.length > 0) {
            for (int i=0,l=words.length;i<l;++i) {
                if (i > 0) result.append(" ");
                result.append (Character.toUpperCase(words[i].charAt(0))).append(words[i].substring(1));
            }
        }

        return result.toString();
    }

   /**
     * Parses the the access when it contains two words separated by -.
     * Example: read-write
     *
     * @param access
     * @return a string array of the elements .
     */
    public String[] parseMibAccessStr (String access)
    {
        String[] accessArray = null;
        if (access.contains ("write")) {
            accessArray = new String [access.length()];
            String accessStr = access.substring (0, access.length());
            accessArray = accessStr.split ("-");
            //System.out.println ("**accessArray: " + accessArray.length);
        }
        else if (access.contains ("read")) {
            accessArray = new String [access.length()];
            String accessStr = access.substring (0, access.length());
            accessArray = accessStr.split ("-");
            //System.out.println ("**accessArray 1: " + accessArray[1]);
            //System.out.println ("**accessArray: " + accessArray.length);
        }
        else {
            String accessStr = access.substring (0, access.length());
            accessArray = new String[1];
            accessArray[0] = accessStr;
        }

        if (accessArray.length > 0) {
            if (accessArray[1].equalsIgnoreCase ("only")) {
                //System.out.println ("**accessArray 1: " + accessArray[1]);
                String[] sArr = new String [1];
                sArr[0] = accessArray[0];
                return sArr;
            }
            else {
                return accessArray;
            }
        }
        else {
            return new String[0];
        }
    }

    //Variables
    protected Map<String, ServicesObject> _mainServicesMap;
    protected String _fileType;
}
