package kaos.tools.webServiceTool;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.net.URL;
import java.net.MalformedURLException;
import java.util.Vector;
import java.util.Map;
import java.util.HashMap;
import java.util.ArrayList;
import java.util.Iterator;

import org.apache.xerces.parsers.DOMParser;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import javax.xml.transform.TransformerFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Source;
import javax.xml.transform.Result;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.dom.DOMSource;
import javax.swing.*;

import kaos.kpat.applet.ExampleFileFilter;

/**
 * Parsing the web services file using DOM parser.
 *
 * Date: May 21, 2010
 * Time: 3:46:41 PM
 *
 * @author Maggie Breedy <KAoS group>
 * @version: $Revision: 1.42 $
 */
public class ParseWithDOM
{
    public ParseWithDOM()
    {
    }

    /**
     * Reads the wsdl file and store the information in a hashtable
     * which the key is the name of the operation and the value is a
     * map of attributes.
     *
     * @param filename  the name of the service
     * @param str   the wsdl xml file.
     */
    public void init (String str, String filename)
    {
        try {
            //System.out.println("***file name : "+ file.getName());
            _fileInfo = new HashMap<String,Map>();
            _complexTypeInfo = new HashMap<String,Map>();

            //_impOntDefMap = new HashMap<String,String>();
            ArrayList schLocList = new ArrayList();
            //Map<String, String> impMap = new HashMap<String,String>();
            String uri = null;

            File wsdlFile = new File (str);
            //System.out.println("***wsdlFile : "+ wsdlFile.getName());
            if (wsdlFile.exists()){
                DOMParser parser = new DOMParser();
                parser.parse (str);
                Document doc = parser.getDocument();
                //System.out.println("***doc : "+ doc.getLocalName());

                //Get the schema definition prefix given the url.
                NodeList defNodeList = doc.getChildNodes();
                String prefix = "";
                if (defNodeList.getLength() > 0) {
                    for (int i=0; i<defNodeList.getLength(); i++) {
                        if (defNodeList.item (i) instanceof Element) {
                            Element defroot = (Element) defNodeList.item (i);
                            //System.out.println("***defroot:<" + defroot.getNodeName()+">");
                            prefix = defroot.lookupPrefix ("http://www.w3.org/2001/XMLSchema");
                            //System.out.println("******WSDL prefix: " + prefix);
                            if (prefix == null) {
                                prefix = "";
                                //System.out.println("******prefix Null for XSD:<" + prefix + ">");
                            }
                            else {
                                prefix = prefix + ":";
                            }
                        }
                    }
                }

                //Check for all imported ontologies defined in the wsdl file
                NodeList nsNodeList = doc.getElementsByTagName (prefix + "import");
                //System.out.println("***nsNodeList length : "+ nsNodeList.getLength());
                if (nsNodeList.getLength() > 0) {
                    for (int i=0; i<nsNodeList.getLength(); i++) {
                        Element nsroot = (Element) nsNodeList.item (i);
                        //System.out.println("***nsroot:<" + nsroot.getNodeName()+">");
                        uri = nsroot.getAttribute ("namespace");
                        //System.out.println("******uri from import init**: " + uri);
                        /*String pref = nsroot.lookupPrefix (uri);
                        if (pref != null) {
                            _impOntDefMap.put (pref, uri);
                        }*/
                        //System.out.println("******pref from import init**: " + pref);
                        String att = nsroot.getAttribute ("schemaLocation");
                        schLocList.add (att);
                        //System.out.println("******att:schema location: " + att);
                    }
                }
                else {
                    NodeList nsimpNodeList = doc.getElementsByTagName ("import");
                    //System.out.println("***nsNodeList length : "+ nsNodeList.getLength());
                    if (nsimpNodeList.getLength() > 0) {
                        for (int i=0; i<nsimpNodeList.getLength(); i++) {
                            Element nsroot = (Element) nsimpNodeList.item (i);
                            //System.out.println("***nsroot:<" + nsroot.getNodeName()+">");
                            uri = nsroot.getAttribute ("namespace");
                            //System.out.println("******uri from import init no pref**: " + uri);
                            /*String pref = nsroot.lookupPrefix (uri);
                            if (pref != null) {
                                _impOntDefMap.put (pref, uri);
                            }*/
                            //System.out.println("******pref from import init**: " + pref);
                            String att = nsroot.getAttribute ("schemaLocation");
                            schLocList.add (att);
                        }
                    }
                }

                NodeList nodeList = doc.getElementsByTagName ("wsdl:message");
                //Method names
                Vector<String> methodNameVector = new Vector<String>();
                if (nodeList.getLength() > 0) {
                    for (int i=0; i<nodeList.getLength(); i++) {
                        Element root = (Element) nodeList.item (i);
                        //System.out.println("***root:<" + root.getNodeName()+">");
                        String[] names1 = {"wsdl:part"};
                        String[] attributes1 = {""};
                        String[] values1 = {""};
                        Element elementTop = findElementWithPath (root, names1, attributes1, values1);
                        String methodName = elementTop.getAttribute ("element"); //name
                        if (methodName.contains(":")) {
                            String[] methodNameArray = methodName.split(":");
                            //System.out.println("******MethodName:init: " + methodNameArray[1]);
                            if (methodNameArray.length > 0) {
                                methodNameVector.addElement (methodNameArray[1].trim());
                            }
                        }
                        else {
                            methodNameVector.addElement (methodName);
                        }
                    }
                }
                else {
                    NodeList nodeList2 = doc.getElementsByTagName ("message");
                    for (int i=0; i<nodeList2.getLength(); i++) {
                        //if (defNodeList.item (i) instanceof Element) {
                        Element root = (Element) nodeList2.item (i);
                        String[] names1 = {"part"};
                        String[] attributes1 = {""};
                        String[] values1 = {""};
                        Element elementTop = findElementWithPath (root, names1, attributes1, values1);
                        String methodName = elementTop.getAttribute ("element"); //name
                        //System.out.println("******MethodName1: " + methodName);
                        if (methodName != null && !methodName.equals("")) {
                            if (methodName.contains(":")) {
                                String[] methodNameArray = methodName.split(":");
                                if (methodNameArray.length > 0) {
                                    methodNameVector.addElement (methodNameArray[1].trim());
                                    //System.out.println("******MethodName:init: " + methodNameArray[1]);
                                }
                            }
                            else {
                                methodNameVector.addElement (methodName);
                            }
                        }
                        else {
                              methodName = elementTop.getAttribute ("name");
                              System.out.println("******MethodName2: " + methodName);
                        }
                    }
                }

                String eleStr = prefix + "element";
                String ctStr = prefix + "complexType";
                String seqStr = prefix + "sequence";
                String allStr = prefix + "all";

                NodeList nodeList2 = doc.getElementsByTagName (eleStr);
                //System.out.println("******nodeList2: " + nodeList2.getLength());
                if (nodeList2.getLength() > 0) {
                    for (int i=0; i<nodeList2.getLength(); i++) {
                        Element root = (Element) nodeList2.item (i);
                        //System.out.println("******root: " + root.getLocalName());
                        //Check if the element have complex types
                        String schStr = prefix + "schema";
                        //System.out.println("*****meth name: " + root.getAttribute ("name"));
                        if (root.getParentNode().getNodeName().equals (schStr)) {
                            //System.out.println("*****meth name root schema: " + root.getAttribute ("name"));
                            String methodName = root.getAttribute ("name");
                            if (!root.getAttribute("type").equals("")) {
                                //The element have no complex types
                                String attrName = methodName;
                                String attrType = root.getAttribute ("type");
                                Map<String, Vector> map = new HashMap<String, Vector>();
                                Vector<ElementObject> v1 = new Vector<ElementObject>();
                                //System.out.println("*****No CT attrName: " + attrName + " ..No CT attrType: " + attrType);
                                ElementObject eo = new ElementObject (attrName, attrType, "", "", "");
                                v1.add (eo);
                                map.put (attrName, v1);
                                _fileInfo.put (methodName, map);
                            }
                            else {
                                //Check if the node is a root. Get the complex types
                                if (methodNameVector.contains (root.getAttribute("name"))) {
                                    String rootName = root.getAttribute("name");
                                    //System.out.println("***root:<" + rootName+">");

                                    String[] names = new String[]{ctStr, seqStr};
                                    String[] attributes = new String[]{"", ""};
                                    String[] values = new String[]{"", ""};

                                    Element element2 = findElementWithPath (root, names, attributes, values);
                                    NodeList list = element2.getElementsByTagName (eleStr);

                                    Map<String, Vector> attrMap = new HashMap<String, Vector>();
                                    Vector v = new Vector();
                                    if (list.getLength() == 0) {
                                        ElementObject eo = new ElementObject ("NoAttribute", "NoType", "NoRef", "", "");
                                        v.add (eo);
                                        //attrMap.put(methodName, v);
                                    }
                                    else {
                                        for (int j=0; j<list.getLength(); j++) {
                                            Element element3 = (Element) list.item (j);
                                            ElementObject eo = getElementObjectFromAttributes (element3);

                                            v.add (eo);
                                            //System.out.println("******v: " + v);
                                            //attrMap.put (methodName, v);
                                        }
                                    }
                                    if (!v.isEmpty()) {
                                        attrMap.put (methodName, v);
                                    }
                                    _fileInfo.put (root.getAttribute("name").trim(), attrMap);
                                }
                            }
                        }
                    }
                }
                else {
                    //System.out.println("*****else no element root: ");
                    Iterator it = methodNameVector.iterator();
                    while (it.hasNext()) {
                        String methodName = (String) it.next();
                        String attrName = "NoAttribute";
                        String attrType = "NoType";
                        Map<String, Vector> map = new HashMap<String, Vector>();
                        Vector<ElementObject> v1 = new Vector<ElementObject>();
                        ElementObject eo = new ElementObject (attrName, attrType, "", "", "");
                        v1.add (eo);
                        map.put (attrName, v1);
                        _fileInfo.put (methodName, map);
                    }
                }

                //System.out.println("*****ONLY complex types");
                NodeList nodeList4 = doc.getElementsByTagName (ctStr);
                //System.out.println("*****nodeList4:lenght:" + nodeList4.getLength());
                if (nodeList4.getLength() > 1) {
                    for (int j=0; j<nodeList4.getLength(); j++) {
                        //System.out.println("*****nodeList4:lenght:" + nodeList4.getLength());
                        Element element3 = (Element) nodeList4.item (j);
                        //System.out.println("*****Complex types:element3: " + element3);
                        String methName = element3.getAttribute ("name");
                        //System.out.println("*****nodeList4:ComplexTypes:methName<" + methName + ">");
                        Element element4 = null;
                        if (!methName.equals("")) {
                            if (!methodNameVector.contains (methName)) {
                                Map<String, Vector> attrMap = new HashMap<String, Vector>();
                                if (element3 == null) {
                                    String[] names = new String[]{allStr};
                                    String[] attributes = new String[]{""};
                                    String[] values = new String[]{""};
                                    //System.out.println("******names: " + names.length);
                                    //System.out.println("******attributes: " + attributes.length);
                                    //System.out.println("******values: " + values.length);
                                    element4 = findElementWithPath (element3, names, attributes, values);
                                }
                                else {
                                    String[] names = new String[]{seqStr};
                                    String[] attributes = new String[]{""};
                                    String[] values = new String[]{""};
                                    //System.out.println("******names: " + names.length);
                                    //System.out.println("******attributes: " + attributes.length);
                                    //System.out.println("******values: " + values.length);
                                    element4 = findElementWithPath (element3, names, attributes, values);
                                }
                                if (element4 != null) {
                                    NodeList nlist = element4.getElementsByTagName (eleStr);
                                    Vector v = new Vector();
                                    for (int k=0; k<nlist.getLength(); k++) {
                                        Element element5 = (Element) nlist.item (k);
                                        ElementObject eo = getElementObjectFromAttributes (element5);
                                        v.add (eo);
                                    }
                                    if (!v.isEmpty()) {
                                        //System.out.println("******v: " + v);
                                         //System.out.println("******methName: " + methName);
                                         attrMap.put (methName, v);
                                    }
                                    //System.out.println("*****Name complex types for attrMap: " + methName);
                                    _complexTypeInfo.put (methName.trim(), attrMap);
                                }
                            }
                        }
                    }
                }
                //System.out.println("*****ONLY simple types");
                String restStr = prefix + "restriction";
                String enumStr = prefix + "enumeration";
                NodeList nodeList6 = doc.getElementsByTagName (prefix + "simpleType");
                //Map<String, Vector> simpAttrMap = new HashMap<String, Vector>();
                _simpleTypeInfo = new HashMap<String,Vector>();

                if (nodeList6.getLength() > 0) {
                    for (int i=0; i<nodeList6.getLength(); i++) {
                        //System.out.println("******nodeList2: " + nodeList2.getLength());
                        Element root = (Element) nodeList6.item (i);

                        String simpleName = root.getAttribute ("name");
                        //System.out.println("*****simpleName: " + simpleName);

                        String[] names = new String[]{restStr};
                        String[] attributes = new String[]{""};
                        String[] values = new String[]{""};

                        Element element4 = findElementWithPath (root, names, attributes, values);
                        //System.out.println("*****simpAttr:base " + element4.getAttribute ("base"));
                        Vector<String> simpVec = new Vector<String>();
                        NodeList list = element4.getElementsByTagName (enumStr);
                        if (list.getLength() == 0) {
                        }
                        else {
                            for (int j=0; j<list.getLength(); j++) {
                                Element element5 = (Element) list.item (j);
                                String enStr = element5.getAttribute ("value");
                                //System.out.println("*****simpAttr:value " + enStr);
                                simpVec.addElement (enStr);
                            }
                        }
                        if (!simpVec.isEmpty()) {
                            _simpleTypeInfo.put (simpleName, simpVec);
                        }
                    }
                }


                /*Iterator it = simpAttrMap.keySet().iterator();
                while (it.hasNext()) {
                    String name = (String) it.next();
                    System.out.println ("**simpAttrMap: " + name);
                    Vector v = simpAttrMap.get(name);
                    System.out.println ("**v: " + v);
                }*/

                //System.out.println ("**uri: " + uri + "  .....Filename: " + filename);
                if (_complexTypeInfo.size() > 0) {
                    schLocList.add ("Inner Classes");
                }

                _treeObject = new TreeFileObject (filename, uri, schLocList);
            }

          //System.out.println("******Hashtable: " + _fileInfo);
        }
        catch (Exception ex) {
            ex.printStackTrace();
            System.out.println("**Exception: " + ex);
        }
    }

    protected ElementObject getElementObjectFromAttributes (Element element)
    {
        String attrName = element.getAttribute ("name");
        //System.out.println("******init:attrName: " + attrName);
        String attrType = element.getAttribute ("type");
        //System.out.println("******init:attrType: " + attrType);
        String attrRef = element.getAttribute ("ref");
        //System.out.println("******init:attrRef: " + attrRef);
        String minAtt = element.getAttribute ("minOccurs");
        //System.out.println("******init2:minAtt5: " + minAtt);
        String maxAtt = element.getAttribute ("maxOccurs");
        //System.out.println("******init2:maxAtt5: " + maxAtt);

        String atn = "";
        String tyn = "";
        String refn = "";
        String mnAtt = "";
        String mxAtt = "";

        if (attrName != null && !attrName.equals("")) {
            //System.out.println("******attrName: " + attrName);
            //v.addElement(attrName);
            atn = attrName;
        }
        if (attrType != null && !attrType.equals("")) {
            //System.out.println("******attrType: " + attrType);
            //v.addElement(attrType);
            tyn = attrType;
        }
        if (attrRef != null && !attrRef.equals("")) {
            //System.out.println("******attrRef: " + attrRef);
            //v.addElement (attrRef);
            //v.addElement(attrRef);
            refn = attrRef;
        }
        if (minAtt != null && !minAtt.equals("")) {
            //System.out.println("******minAtt: " + minAtt);
            mnAtt = minAtt;
        }
        if (maxAtt != null && !maxAtt.equals("")) {
            //System.out.println("******maxAtt: " + maxAtt);
            mxAtt = maxAtt;
        }
        //System.out.println("******methodName: " + methodName);

        //ElementObject eo = new ElementObject (atn, tyn, refn, mnAtt, mxAtt);
        ElementObject eo = new ElementObject (atn, tyn, refn, mxAtt, mnAtt);
        return eo;
    }

    /**
     * Parses the xsd files
     *
     * @param str  the xml text from the xsd file
     * @param filename the xsd file name
     */
    public void init2 (String str, String filename)
    {
        try {
            //System.out.println("***file name:init2: "+ filename);
            _fileInfo = new HashMap<String,Map>();
            _complexTypeInfo = new HashMap<String,Map>();
            // _impOntDefMap = new HashMap<String,String>();
            ArrayList schLocList = new ArrayList();
            String uri = "";

            File wsdlFile = new File (str);
            //System.out.println("***wsdlFile : "+ wsdlFile.getName());
            if (wsdlFile.exists()){
                DOMParser parser = new DOMParser();
                parser.parse (str);
                Document doc = parser.getDocument();


                //Get the schema definition prefix given the url.
                NodeList defNodeList = doc.getChildNodes();
                String prefix = "";
                if (defNodeList.getLength() > 0) {
                    for (int i=0; i<defNodeList.getLength(); i++) {
                        if (defNodeList.item (i) instanceof Element) {
                            Element defroot = (Element) defNodeList.item (i);
                            //System.out.println("***defroot:<" + defroot.getNodeName()+">");
                            prefix = defroot.lookupPrefix ("http://www.w3.org/2001/XMLSchema");
                            //System.out.println("******prefix for XSD: " + prefix);
                            if (prefix == null) {
                                prefix = "";
                                //System.out.println("******prefix Null for XSD:<" + prefix + ">");
                            }
                            else {
                                prefix = prefix + ":";
                            }
                        }
                    }
                }

                //Check if it has imports
                NodeList impNodeList = doc.getElementsByTagName (prefix + "import");
                //System.out.println("***nsNodeList length : "+ nsNodeList.getLength());
                if (impNodeList.getLength() > 0) {
                    for (int i=0; i<impNodeList.getLength(); i++) {
                        Element nsroot = (Element) impNodeList.item (i);
                        //System.out.println("***nsroot:<" + nsroot.getNodeName()+">");
                        uri = nsroot.getNamespaceURI();
                        //System.out.println("******import:uri: " + uri);
                        if (uri == null) {
                            uri = nsroot.getAttribute ("targetNamespace");
                            //System.out.println("******XSDimport:uri2: " + uri);
                        }

                       /* String pref = nsroot.lookupPrefix (uri);
                        //System.out.println("******XSDimport:p1: " + pref);
                        if (pref != null) {
                            _impOntDefMap.put (pref, uri);
                        }*/
                        String att = nsroot.getAttribute ("schemaLocation");
                        schLocList.add (att);
                        //System.out.println("******att:schema location: " + att);
                    }
                }

                //System.out.println("******prefix Null for XSD:<" + prefix + ">");
                String schStr = prefix + "schema";
                //System.out.println("******schStr: " + schStr);
                NodeList nsNodeList = doc.getElementsByTagName (schStr);
                //System.out.println("******XSD nsNodeList*******: " + nsNodeList.getLength());
                if (nsNodeList.getLength() > 0) {
                    for (int i=0; i<nsNodeList.getLength(); i++) {
                        Element nsroot = (Element) nsNodeList.item (i);
                        String att = nsroot.getAttribute ("targetNamespace");
                        uri = att;
                        //System.out.println("******XSD uri: " + uri);
                        /*if (uri != null) {
                            String pref = nsroot.lookupPrefix (uri);
                            if (pref != null) {
                                _impOntDefMap.put (pref, uri);
                                System.out.println("******XSDimport:pref: " + pref);
                            }

                        }*/
                        schLocList.add (att);
                        //System.out.println("******XSD att: " + att);
                    }
                }
                if (prefix.equals ("")) {
                    String eleStr = prefix + "element";
                    //System.out.println("******eleStr: " + eleStr);
                    NodeList nodeList2 = doc.getElementsByTagName (eleStr);
                    for (int i=0; i<nodeList2.getLength(); i++) {
                        //System.out.println("******nodeList2: " + nodeList2.getLength());
                        Element root = (Element) nodeList2.item (i);
                        //System.out.println("******root: " + root.getLocalName());
                        //Check if the element have complex types
                        if (root.getParentNode().getNodeName().equals (schStr)) {
                            String methodName = root.getAttribute ("name");
                            //System.out.println("******methodName**: " + methodName);
                            if (!root.getAttribute("type").equals("")) {
                                //The element have no complex types and the type is the superClass
                                //No parameters shown for this case.
                                String attrName = methodName;
                                String attrType = root.getAttribute ("type");
                                //System.out.println("******attrType**: " + attrType);
                                Map<String, Vector> map = new HashMap<String, Vector>();
                                Vector<ElementObject> v1 = new Vector<ElementObject>();
                                //System.out.println("***XSD1**No CT attrName: " + attrName + " ..No CT attrType: " + attrType);
                                ElementObject eo = null;
                                if (attrType.contains(":")) {
                                    eo = new ElementObject (attrName, attrType, "", "", "");
                                }
                                else {
                                    eo = new ElementObject (attrName, attrType, "NoCT", "", "");
                                }
                                v1.add (eo);
                                map.put (attrName, v1);
                                _fileInfo.put (methodName, map);
                            }
                            else {
                                //Check if the node is a root. Get the complex types
                                String rootName = root.getAttribute("name");
                                //System.out.println("***root:<" + rootName+">");

                                String ctStr = prefix + "complexType";
                                String seqStr = prefix + "sequence";

                                //System.out.println("******ctStr: " + ctStr + "............seqStr:" + seqStr);
                                String[] names = new String[]{ctStr, seqStr};
                                String[] attributes = new String[]{"", ""};
                                String[] values = new String[]{"", ""};

                                Element element2 = findElementWithPath (root, names, attributes, values);
                                //System.out.println("******eleStr: " + eleStr);
                                NodeList list = element2.getElementsByTagName (eleStr);
                                //System.out.println("******list.length: " + list.getLength());
                                Map<String, Vector> attrMap = new HashMap<String, Vector>();
                                Vector v = new Vector();
                                if (list.getLength() == 0) {
                                    ElementObject eo = new ElementObject ("NoAttribute", "NoType", "NoRef", "", "");
                                    v.add (eo);
                                    //attrMap.put(methodName, v);
                                }
                                else {
                                    for (int j=0; j<list.getLength(); j++) {
                                        Element element3 = (Element) list.item (j);

                                        ElementObject eo = getElementObjectFromAttributes (element3);

                                        v.add (eo);
                                    }
                                }
                                //System.out.println("******v: " + v);
                                if (!v.isEmpty()) {
                                    attrMap.put (methodName, v);
                                }
                                _fileInfo.put (root.getAttribute("name").trim(), attrMap);
                            }
                        }
                    }
                    //System.out.println("*****ONLY the simple types for xsd");
                    String restStr = prefix + "restriction";
                    String enumStr = prefix + "enumeration";
                    NodeList nodeList6 = doc.getElementsByTagName (prefix + "simpleType");
                    //Map<String, Vector> simpAttrMap = new HashMap<String, Vector>();
                    _simpleTypeInfo = new HashMap<String,Vector>();

                    if (nodeList6.getLength() > 0) {
                        for (int i=0; i<nodeList6.getLength(); i++) {
                            //System.out.println("******nodeList2: " + nodeList2.getLength());
                            Element root = (Element) nodeList6.item (i);

                            String simpleName = root.getAttribute ("name");
                            //System.out.println("*****simpleName: " + simpleName);

                            String[] names = new String[]{restStr};
                            String[] attributes = new String[]{""};
                            String[] values = new String[]{""};

                            Element element4 = findElementWithPath (root, names, attributes, values);
                            //System.out.println("*****simpAttr:base " + element4.getAttribute ("base"));
                            Vector<String> simpVec = new Vector<String>();
                            NodeList list = element4.getElementsByTagName (enumStr);
                            if (list.getLength() == 0) {
                            }
                            else {
                                for (int j=0; j<list.getLength(); j++) {
                                    Element element5 = (Element) list.item (j);
                                    String enStr = element5.getAttribute ("value");
                                    //System.out.println("*****simpAttr:value " + enStr);
                                    simpVec.addElement (enStr);
                                }
                            }
                            if (!simpVec.isEmpty()) {
                                _simpleTypeInfo.put(simpleName, simpVec);
                            }
                        }
                    }
                }
                else {
                    getParsedInfoFromXSschema (doc, prefix);
                }
            }

            /*Iterator it = schLocList.iterator();
            while (it.hasNext()) {
                String name = (String) it.next();
                System.out.println ("**schLocList[m]: " + name);
            }*/
            //System.out.println ("**uri:init2: " + uri + "  .....Filename: " + filename);
            _treeObject = new TreeFileObject (filename, uri, schLocList);
        }
        catch (IOException e) {
            System.out.println("**IOException: " + e);
        }
        catch (Exception ex) {
            ex.printStackTrace();
            System.out.println("**Exception: " + ex);
        }
    }

    protected void getParsedInfoFromXSschema (Document doc, String prefix)
    {
        Vector<String> methodNameVector = new Vector<String>();

        String eleStr = prefix + "element";
        //System.out.println("******eleStr: " + eleStr);
        String ctStr = prefix + "complexType";
        String seqStr = prefix + "sequence";
        String schStr = prefix + "schema";

        NodeList nodeList2 = doc.getElementsByTagName (eleStr);
        for (int i=0; i<nodeList2.getLength(); i++) {
            //System.out.println("******nodeList2************: " + nodeList2.getLength());
            Element root = (Element) nodeList2.item (i);
            //System.out.println("******root: " + root.getLocalName());

            //Check if the element have complex types
            if (root.getParentNode().getNodeName().equals (schStr)) {
                String methodName = root.getAttribute ("name");
                //System.out.println("******methodName: " + methodName);
                if (!root.getAttribute("type").equals("")) {
                    //ystem.out.println("******Root with attributes!");
                    //The element have no complex types
                    String attrName = methodName;
                    String attrType = root.getAttribute ("type");
                    //System.out.println("******root.getAttribute: " + root.getAttribute("type"));
                    Map<String, Vector> map = new HashMap<String, Vector>();
                    Vector<ElementObject> v1 = new Vector<ElementObject>();
                    //System.out.println("***XSD2**No CT attrName: " + attrName + " ..No CT attrType: " + attrType);
                    ElementObject eo = null;
                    if (attrType.contains(":")) {
                        eo = new ElementObject (attrName, attrType, "", "", "");
                    }
                    else {
                        eo = new ElementObject (attrName, attrType, "NoCT", "", "");
                    }
                    //ElementObject eo = new ElementObject (attrName, attrType, "", "", "");
                    v1.add (eo);
                    map.put (attrName, v1);
                    _fileInfo.put (methodName, map);
                    methodNameVector.addElement (methodName);
                }
                else {
                    //Check if the node is a root. Get the complex types
                    if (methodNameVector.contains (root.getAttribute("name"))) {
                        String rootName = root.getAttribute("name");
                        //System.out.println("***root:<" + rootName+">");

                        String[] names = new String[]{ctStr, seqStr};
                        String[] attributes = new String[]{"", ""};
                        String[] values = new String[]{"", ""};

                        Element element2 = findElementWithPath (root, names, attributes, values);
                        NodeList list = element2.getElementsByTagName (eleStr);
                        //System.out.println("******list.length: " + list.getLength());
                        Map<String, Vector> attrMap = new HashMap<String, Vector>();
                        Vector v = new Vector();
                        if (list.getLength() == 0) {
                            ElementObject eo = new ElementObject ("NoAttribute", "NoType", "NoRef", "", "");
                            v.add (eo);
                            //attrMap.put(methodName, v);
                        }
                        else {
                            for (int j=0; j<list.getLength(); j++) {
                                Element element3 = (Element) list.item (j);
                                ElementObject eo = getElementObjectFromAttributes (element3);
                                v.add (eo);
                            }
                        }
                        //System.out.println("******v: " + v);
                        if (!v.isEmpty()) {
                            attrMap.put (methodName, v);
                        }
                        _fileInfo.put (root.getAttribute("name").trim(), attrMap);
                    }
                }
            }
            else {
                //System.out.println("*****else No root schema");
                NodeList nodeList4 = doc.getElementsByTagName (ctStr);
                Map<String, Vector> attrMap = new HashMap<String, Vector>();
                for (int j=0; j<nodeList4.getLength(); j++) {
                    //System.out.println("*****nodeList4:lenght:" + nodeList4.getLength());
                    Element element3 = (Element) nodeList4.item (j);
                    if (element3 == null) {
                            continue;
                    }
                    String methName = element3.getAttribute ("name");
                    //System.out.println("*****nodeList4:methName:" + methName);
                    if (!methodNameVector.contains (methName)) {
                        String[] names = new String[]{seqStr};
                        String[] attributes = new String[]{""};
                        String[] values = new String[]{""};

                        Element element4 = findElementWithPath (element3, names, attributes, values);

                        NodeList nlist = element4.getElementsByTagName (eleStr);
                        Vector v = new Vector();
                        for (int k=0; k<nlist.getLength(); k++) {
                            Element element5 = (Element) nlist.item (k);
                            ElementObject eo = getElementObjectFromAttributes (element5);

                            v.add (eo);
                        }
                        if (!v.isEmpty()) {
                            //System.out.println("******v: " + v);
                            // System.out.println("******methName to add to Map: " + methName);
                             attrMap.put (methName, v);
                        }
                        //System.out.println("******methName: " + methName);
                        _fileInfo.put (methName.trim(), attrMap); //before
                        //_complexTypeInfo.put (methName.trim(), attrMap);

                        /*Iterator it = attrMap.keySet().iterator();
                        while (it.hasNext()) {
                            String key = (String) it.next();
                            System.out.println ("**attrMap:key: " + key);
                        }*/
                    }
                    else {
                        //System.out.println("******methName is in the vector: " + methName);
                        String attrName = element3.getAttribute ("name");
                        //System.out.println("******init5:attrName3: " + attrName);

                        String[] names = new String[]{seqStr};
                        String[] attributes = new String[]{""};
                        String[] values = new String[]{""};

                        Element element4 = findElementWithPath (element3, names, attributes, values);
                        NodeList nlist = element4.getElementsByTagName (eleStr);
                        Vector v = new Vector();
                        Map<String, Vector> atMap = new HashMap<String, Vector>();
                        if (nlist.getLength() > 0 && methodNameVector.contains (methName)) {
                            for (int k=0; k<nlist.getLength(); k++) {
                                Element element5 = (Element) nlist.item (k);
                                ElementObject eo = getElementObjectFromAttributes (element5);
                                v.add (eo);
                            }
                            if (!v.isEmpty()) {
                                atMap.put (methName, v);
                            }
                            //System.out.println("******methName: " + methName);
                            if (_fileInfo.containsKey (methName.trim())) {
                                _fileInfo.remove(methName.trim());
                                _fileInfo.put (methName.trim(), atMap);
                            }
                        }
                    }
                }
            }
        }
    }

    /**
     * Add anotations to the node elements in the wsdl files that represent the operations.
     *
     * @param str
     * @param serviceType
     * @param serviceFileName
     * @param filePath
     * @throws Exception
     */

    public void writeAnnotations (String str, String serviceType, String serviceFileName, String filePath)
            throws Exception
    {
       try {
            //System.out.println("***serviceFileName:writeAnnotations : "+ serviceFileName);
            File wsdlFile = new File (str);

            if (wsdlFile.exists()){
                DOMParser parser = new DOMParser();
                parser.parse (str);
                Document doc = parser.getDocument();
                //System.out.println("***doc : "+ doc.getLocalName());
                if (serviceType.equals("webService")) {
                    NodeList nodeList = doc.getElementsByTagName ("wsdl:definitions");
                     Element defNode = (Element) nodeList.item (0);
                     //System.out.println("***defNode:<" + defNode.getNodeName()+">");
                     defNode.setAttribute ("xmlns:sawsdl", "http://www.w3.org/ns/sawsdl");
                }

                NodeList nodeList = doc.getElementsByTagName ("wsdl:message");
                //Method names
                Vector<String> methodNameVector = new Vector<String>();
                for (int i=0; i<nodeList.getLength(); i++) {
                    Element root = (Element) nodeList.item (i);
                    //System.out.println("***root:<" + root.getNodeName()+">");
                    String[] names1 = {"wsdl:part"};
                    String[] attributes1 = {""};
                    String[] values1 = {""};
                    Element elementTop = findElementWithPath (root, names1, attributes1, values1);
                    String methodName = elementTop.getAttribute ("element"); //name
                    String[] methodNameArray = methodName.split(":");
                    //System.out.println("******MethodName: " + methodNameArray[1]);

                    methodNameVector.addElement (methodNameArray[1].trim());
                }

                NodeList nodeList2 = doc.getElementsByTagName ("xsd:element");
                for (int i=0; i<nodeList2.getLength(); i++) {
                    //System.out.println("******nodeList2: " + nodeList2.getLength());
                    Element root = (Element) nodeList2.item (i);
                    //Check if the element have complex types
                    if (root.getParentNode().getNodeName().equals("xsd:schema")) {
                        String methodName = root.getAttribute ("name");

                        //System.out.println("***methodName:" + methodName);
                        if (!root.getAttribute("type").equals("")) {
                            root.setAttribute ("sawsdl:modelReference", "http://ontology.ihmc.us/" + serviceFileName +
                                               "Action.owl#" + methodName + "Action");
                            root.setAttribute ("sawsdl:liftingSchemaMapping", methodName + "2Ont.xsl");
                        }
                        else {
                            //Check if the node is a root. Get the complex types
                            if (methodNameVector.contains (root.getAttribute("name"))) {
                                String rootName = root.getAttribute("name");
                                //System.out.println("***root:<" + rootName+">");
                                root.setAttribute ("sawsdl:modelReference", "http://ontology.ihmc.us/" +
                                                   serviceFileName + "Action.owl#" + methodName + "Action");
                                root.setAttribute ("sawsdl:liftingSchemaMapping", methodName + "2Ont.xsl");

                                //root.setAttribute ("sawsdl:modelReference", "http://ontology.ihmc.us/TargetAction.owl#CreateTargetAction");
                                //root.setAttribute ("sawsdl:liftingSchemaMapping", "CreateTarget2Ont.xsl");
                           }
                       }

                    }
                }

                //print the resulting xml
                TransformerFactory tFactory = TransformerFactory.newInstance();
                Transformer tformer = tFactory.newTransformer();
                tformer.setOutputProperty (OutputKeys.METHOD, "xml");
                Source source = new DOMSource (doc);

                if (serviceType.equals("webService")) {
                    JFileChooser chooser = new JFileChooser (_configPath);
                    ExampleFileFilter configFilter = new ExampleFileFilter();
                    configFilter.addExtension ("anot");
                    configFilter.setDescription ("AnotationsFile");
                    chooser.addChoosableFileFilter (configFilter);
                    chooser.setFileFilter (configFilter);
                    int returnVal = chooser.showSaveDialog (new JFrame());

                    if (returnVal != JFileChooser.APPROVE_OPTION) {
                        return;
                    }
                    String filename = chooser.getSelectedFile().getPath();
                    if (filename.indexOf (".wsdl") < 0) {
                        filename = filename + ".wsdl";
                    }

                    Result result = new StreamResult (new File (filename));//to write the file
                    //Result result = new StreamResult(System.out);//to view in the console
                    tformer.transform (source, result); //last, we print the resulting xml
                }
                else {
                    //String newFile = filePath;
                    //String newFile = filePath + ".anot";
                    System.out.println("***filePath:<" + filePath+">");
                    Result result = new StreamResult (new File (filePath));//to write the file
                    //Result result = new StreamResult(System.out);//to view in the console
                    tformer.transform (source, result); //last, we print the resulting xml
                 }

            }
        }
        catch (IOException e) {
            System.out.println("**IOException: " + e);
        }
        catch (Exception ex) {
            ex.printStackTrace();
            System.out.println("**Exception: " + ex);
        }
    }

    /**
     * Returns a map of the wsdl file read.
     * @return _fileInfo
     */
    public Map<String,Map> getFileInfo()
    {
        return _fileInfo;
    }

    /**
     * Returns a map of the wsdl complex types read.
     * @return _complexTypeInfo
     */
    public Map<String,Map> getFileComplexTypeInfo()
    {
        return _complexTypeInfo;
    }

    /**
     * Returns a map of the wsdl simple types read.
     * @return _simpleTypeInfo
     */
    public Map<String,Vector> getSimpleTypeInfo()
    {
        if (_simpleTypeInfo == null) {
            return new HashMap<String,Vector>();
        }
        else {
            return _simpleTypeInfo;
        }
    }

    /**
     * Returns an object that represents the file read.
     * @return _treeObject
     */
    public TreeFileObject getTreeFileObject()
    {
        return _treeObject;
    }

    /**
     * Finds the first element in the tree.
     *
     * @param element
     * @param name
     * @param attribute
     * @param value
     * @return that element
     */
    private Element findFirstElement (Element element, String name, String attribute, String value)
    {
        NodeList nl = element.getElementsByTagName (name);//not reached //UPDATE : it's working
        if (nl.getLength()<1) {
            throw new NullPointerException ("Element : "+ element +" doesn't include "+ name  );
        }

        for (int i=0;i<nl.getLength();i++) {
          //System.out.println("using attributes");
            if (attribute.equals(""))//test if the attributes is not null (for the other method)
                return (Element)nl.item(0);
            //we don't need to put an 'else'
            if (nl.item(i).getAttributes().getNamedItem(attribute).getFirstChild().getNodeValue().equals(value)) {
              //System.out.println("Element with correct attribute found");
                return (Element)nl.item(i);
            }
        }
        //if we haven't found anything
        //System.out.println("nothing found");
        return null;
    }

    /**
     * Finds the element path in the tree.
     *
     * @param element
     * @param names
     * @param attributes
     * @param values
     * @return result
     */
    private Element findElementWithPath (Element element, String[] names, String[] attributes, String[] values)
    {
        Element result = null;
        //if we are just searching for 1 element
        if (names.length<2){
            result = findFirstElement (element, names[0], attributes[0], values[0]);
        }
        //else, we have to parse trough the different names
        else{
            String[] names2 = new String[names.length-1];
            String[] attributes2 = new String[attributes.length-1];
            String[] values2 = new String[values.length-1];
            //we duplicate the lists without the first items
            for (int i=1;i<names.length;i++){
                names2[i-1] = names[i];
                attributes2[i-1] = attributes[i];
                values2[i-1] = values[i];
            }
            //first we initialize tempResult with a search using the first items in the lists
            Element tempResult = findFirstElement (element, names[0], attributes[0], values[0]);
            //then we apply this method recursively using result
            result = findElementWithPath(tempResult, names2, attributes2, values2);

        }
        return result;//when we get the final element, and then we can read the attributes
    }

    /**
     * Reads the information from a wsdl URL from a website into a string buffer.
     *
     * @param wsdlURL
     * @return buf
     *
     * */
    public StringBuffer getStreamByURL (String wsdlURL)
    {
        StringBuffer buf = new StringBuffer (1024 * 50);
        int numBytesRead;
        int numTotalBytesRead = 0;
        byte buffer[] = new byte[1024];

        BufferedInputStream bis = null;
        //String serviceURL = System.getProperty (KAoSConfigurationParameters.SERVICE_URL);

        // Try to retrieve the data without using a proxy server
        try {
            //System.out.println ("**Parser:wsdlURL getting a stream: " + wsdlURL);
            URL url = new URL (wsdlURL);
            //System.out.println ("**wsdlURL before getting a stream: " + url.toString());
            if (!url.toString().contains("-sts")) {
                bis = new BufferedInputStream (url.openStream());
            }
        }
        catch (MalformedURLException e) {
            e.printStackTrace();
        }
        catch (IOException e2) {
            System.out.println ("**wsdlURL getting a stream error ");
            e2.printStackTrace();
        }

        // Do not return a null input stream; at least make it an empty one
        if (bis == null) {
            bis = new BufferedInputStream(new ByteArrayInputStream(new byte[0]));
        }

         // Load the wsdl file
        try {
            while ((numBytesRead = bis.read (buffer, 0, 1024)) >= 0) {
                buf.append (new String (buffer, 0, numBytesRead));
                numTotalBytesRead += numBytesRead;
            }
            bis.close();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        //System.out.println ("**StringBuff: " + buf.toString());
        return buf;
    }

    /**
     * Reads the information from the wsdl file contained in the file system
     * into a string buffer.
     *
     * @param file the wsdl file
     * @return  buf
     */
    protected StringBuffer getFileBufStream (File file)
    {
        StringBuffer buf = new StringBuffer (1024 * 50);
        int numBytesRead;
        int numTotalBytesRead = 0;
        byte buffer[] = new byte[1024];

         FileInputStream bis = null;
         try {
            bis = new FileInputStream (file);
        }
        catch (IOException e) {
            e.printStackTrace();
        }

         // Load the wsdl file
        try {
            while ((numBytesRead = bis.read (buffer, 0, 1024)) >= 0) {
                buf.append (new String (buffer, 0, numBytesRead));
                numTotalBytesRead += numBytesRead;
            }
            bis.close();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
       // System.out.println ("**StringBuff: " + buf.toString());
        return buf;
    }

    public static void main (String[] args)
    {
        ParseWithDOM parseWithDOM = new ParseWithDOM ();
    }

    //Class Variables
    protected static String _configPath = ".";
    protected String _wsdlURL;
    protected TreeFileObject _treeObject;
    protected Map<String,Vector> _wsdlFileInfo;
    protected Map<String,Map> _fileInfo;    //Maps the method name with a map of its attributes.
    protected Map<String,Map> _complexTypeInfo;    //Maps the complexType name with a map of its attributes.
    protected Map<String,Vector> _simpleTypeInfo;    //Maps the simple type name with a vector of its enumeration.
    //protected Map<String,String> _impOntDefMap; //Maps the filename with a Map of abbr and url;
}
