package kaos.tools.webServiceTool;

import org.apache.commons.io.FileUtils;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.io.ByteArrayOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Map;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Collection;
import java.util.ArrayList;
import java.util.prefs.Preferences;

import kaos.kpat.applet.ExampleFileFilter;

import net.percederberg.mibble.Mib;
import net.percederberg.mibble.MibLoader;
import net.percederberg.mibble.MibLoaderException;

/**
 * Dialog to load the services from JBOSS or from the file system.
 *
 * Date: Jul 27, 2010
 * Time: 3:28:11 PM
 * 
 * @author Maggie Breedy
 * @version: $Revision: 1.32 $
 */
public class RequestServicesDialog extends JDialog
{
    /**
     * Constructor
     */
    public RequestServicesDialog()
    {
        _fileTable = new HashMap<String, File>();
        _mibFileTable = new HashMap<String, Mib>();
        createGui();
    }

    /**
     * Creates all dialog components.
     */
    protected void createGui()
    {
        setModal (true);
        setResizable (true);
        setTitle ("Request of Services");
        setSize (550, 250);
        setLayout (new GridBagLayout());
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        setBounds ((screenSize.width-550)/2, (screenSize.height-250)/2, 550, 250);

        GridBagConstraints gbc = new GridBagConstraints();
        JPanel topPanel = new JPanel(new GridBagLayout());
        //topPanel.setBorder (new EtchedBorder());
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.anchor = GridBagConstraints.NORTH;
        gbc.weightx = 1.0;
        gbc.weighty = 1.0;
        gbc.gridwidth = 3;
        //gbc.gridheight = 2;
        gbc.insets = new Insets (0,0,0,0);
        getContentPane().add (topPanel,gbc);

        JPanel centerPanel = new JPanel(new GridBagLayout());
        //topPanel.setBorder (new EtchedBorder());
        gbc.gridx = 0;
        gbc.gridy = 1;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.anchor = GridBagConstraints.CENTER;
        gbc.weightx = 1.0;
        gbc.weighty = 1.0;
        //gbc.gridheight = 1;
        gbc.insets = new Insets (0,0,0,0);
        getContentPane().add (centerPanel,gbc);

        JPanel btnPanel = new JPanel (new GridBagLayout());
        //btnPanel.setBorder (new EtchedBorder());
        gbc.gridx = 0;
        gbc.gridy = 2;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.anchor = GridBagConstraints.SOUTH;
        gbc.weightx = 1.0;
        gbc.weighty = 1.0;
        //gbc.gridheight = 1;
        gbc.insets = new Insets (0,0,0,0);
        getContentPane().add (btnPanel,gbc);

        //topPanel
        gbc = new GridBagConstraints();
        JLabel servLabel = new JLabel ("Select Services Source");
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.insets = new Insets (5,13,5,5);
        gbc.weightx = 1.0;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.NORTH;
        topPanel.add (servLabel, gbc);

        JButton localButton = new JButton ("WSDL from File System");
        localButton.setEnabled (true);
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.NORTH;
        gbc.gridx = 0;
        gbc.gridy = 1;
        gbc.weightx = 0.3;
        gbc.insets = new Insets (5,13,5,13);
        topPanel.add (localButton, gbc);

        JButton webButton = new JButton ("WSDL from Web Services");
        webButton.setEnabled (true);
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.NORTHEAST;
        gbc.gridx = 1;
        gbc.gridy = 1;
        gbc.weightx = 0.3;
        gbc.insets = new Insets (5,13,5,13);
        topPanel.add (webButton, gbc);

        JButton mibButton = new JButton ("MIB Files");
        webButton.setEnabled (true);
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.NORTHEAST;
        gbc.gridx = 2;
        gbc.gridy = 1;
        gbc.weightx = 0.3;
        gbc.insets = new Insets (5,13,5,13);
        topPanel.add (mibButton, gbc);

        //centerPanel
        gbc = new GridBagConstraints();
        _urlLabel = new JLabel ("Select or Write the URL:");
        _urlLabel.setEnabled (false);
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.insets = new Insets (5,13,5,5);
        gbc.weightx = 0.1;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.NORTHWEST;
        centerPanel.add (_urlLabel, gbc);

        _textField = new JTextField();
        //_textField.setEnabled (false);
        _textField.setEditable (true);
        _textField.setText ("http://localhost:8080/jbossws/services");
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbc.insets = new Insets(5,0,5,13);
        gbc.gridx = 1;
        gbc.gridy = 0;
        gbc.weightx = 0.9;
        centerPanel.add (_textField, gbc);

        //buttonsPanel
        gbc = new GridBagConstraints();
        JButton okButton = new JButton ("OK");
        okButton.setEnabled (true);
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.NORTHEAST;
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.weightx = 1.0;
        gbc.insets = new Insets (5,13,5,13);
        btnPanel.add (okButton, gbc);

        JButton clButton = new JButton ("Cancel");
        clButton.setEnabled (true);
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.SOUTHEAST;
        gbc.gridx = 1;
        gbc.gridy = 0;
        gbc.weightx = 1.0;
        gbc.insets = new Insets (5,13,5,13);
        btnPanel.add (clButton, gbc);


        okButton.addActionListener (new ActionListener() {
            public void actionPerformed (ActionEvent e) {
                _selection = OK_SELECTED;
                if (!_textField.isEditable()) {
                    _webServicesSelected = false;
                }
                else {
                     _urlString = _textField.getText();
                    _webServicesSelected = true;
                }
                dispose();
            }
        });

        clButton.addActionListener (new ActionListener() {
            public void actionPerformed (ActionEvent e) {
                _selection = CANCEL_SELECTED;
                _textField.setEnabled (false);
                _urlLabel.setEnabled (false);
                dispose();
            }
        });

        localButton.addActionListener (new ActionListener() {
            public void actionPerformed (ActionEvent e) {
                _textField.setEnabled (true);
                _textField.setEditable (false);
                loadFiles();
            }
        });

        webButton.addActionListener (new ActionListener() {
            public void actionPerformed (ActionEvent e) {
                _textField.setEnabled (true);
                _urlLabel.setEnabled (true);
                _mibFileSelected = false;
           }
        });

        mibButton.addActionListener (new ActionListener() {
            public void actionPerformed (ActionEvent e) {
                _textField.setEnabled (true);
                _textField.setEditable (false);
                String kaosPath = "";
                try {
                    String executionPath = System.getProperty ("user.dir");
                    kaosPath = executionPath.replace("\\", "/");
                    //System.out.print("Executing at =>: "+ kaosPath + "\n");
                }
                catch (Exception ex) {
                    System.out.println ("Exception="+ ex.getMessage());
                }

                _loader.addDir (new File( kaosPath + "/lib/ext/mib/iana"));
                _loader.addDir (new File (kaosPath + "/lib/ext/mib/ietf"));

                //loadMib();
                loadMIBFiles();
           }
        });

        this.addWindowListener (new WindowAdapter() {
            public void windowClosing (WindowEvent e) {
                dispose();
                System.exit (1);
            }
        });
    }

    /**
     * Loads the files from the file system with extensions wsdl and xsd only.
     */
    protected void loadFiles()
    {
        _fileTable.clear();
        JFileChooser chooser = new JFileChooser (_configPath);

        chooser.setFileSelectionMode (JFileChooser.DIRECTORIES_ONLY);
        if (chooser.showOpenDialog (this) == JFileChooser.APPROVE_OPTION) {
            //File root = new File (_configPath);
            File root = chooser.getSelectedFile();
            _textField.setText ("");
            _textField.setText (root.getAbsolutePath());
            if (root.isDirectory()) {
               // String[] extensions = {"wsdl"};
                String[] extensions = {"wsdl", "xsd"};
                boolean recursive = true;
                _configPath = root.getAbsolutePath(); //To remember last path
                Collection files = FileUtils.listFiles (root, extensions, recursive);
                for (Iterator iterator = files.iterator(); iterator.hasNext();) {
                    File file = (File) iterator.next();
                    //System.out.println("File = " + file.getAbsolutePath());
                    _fileTable.put (file.getName(), file);
                }
            }
            _webServicesSelected = false;
            _mibFileSelected = false;
            _selection = OK_SELECTED;
            this.dispose();
        }
        //System.out.println ("****_fileTable: " + _fileTable);
    }

    protected void loadMIBFiles()
    {
        JFileChooser chooser = new JFileChooser (_cfgPath);
        chooser.setFileSelectionMode (JFileChooser.DIRECTORIES_ONLY);
        chooser.setDialogTitle("MIB files will be loaded");
        if (chooser.showOpenDialog (new JDialog()) == JFileChooser.APPROVE_OPTION) {
            File root = chooser.getSelectedFile();
            if (root.isDirectory()) {
                _cfgPath = root.getAbsolutePath();  //To remember the last path
                String[] extensions = {"mib", "my"};
                boolean recursive = true;
                try {
                    Collection files = FileUtils.listFiles (root, extensions, recursive);
                    File[] fileArray = new File [files.size()];
                    //System.out.println ("Files size: " + fileArray.length);
                    for (Iterator iterator = files.iterator(); iterator.hasNext();) {
                        File file1 = (File) iterator.next();
                        //System.out.println ("File = " + file.getAbsolutePath());
                        if (file1.exists()) {
                            _fileTable.put (file1.getName(), file1);
                            //System.out.println ("**Adding to file table File = " + file.getName());
                            String src = file1.toString();
                            //loadMib (file.toString());

                            File  file = new File (src);
                            Mib mib;
                            if (file.exists()) {
                               if (_loader.getMib (file) != null) {
                                   mib = _loader.load (file);
                                   //System.out.println ("**mib loaded11: " + mib.getName());
                                   if (mib != null) {
                                       _mibFileTable.put (file.getName(), mib);
                                   }
                                }
                                if (!_loader.hasDir(file.getParentFile())) {
                                    _loader.removeAllDirs();
                                    _loader.addDir (file.getParentFile());
                                }

                                mib = _loader.load (file);
                                //System.out.println ("**mib loaded1: " + mib.getName());
                                if (mib != null) {
                                    _mibFileTable.put (file.getName(), mib);
                                }

                            }
                            else {
                                mib = _loader.load (src);
                                //System.out.println ("**mib loaded2: " + mib.getName());
                                if (mib != null) {
                                    _mibFileTable.put (file.getName(), mib);
                                }
                            }
                        }
                    }
                }
                catch (MibLoaderException ex) {
                    String message = "Failed to load " + root.getName();
                    ByteArrayOutputStream output = new ByteArrayOutputStream();
                    ex.getLog().printTo (new PrintStream (output));
                    //System.out.println ("**mib loaded: " + output.toString());
                    dispose();
                    ErrorMsgDialog  dlg = new ErrorMsgDialog (output.toString());
                    dlg.setVisible(true);
                }
                catch (IOException ioe) {
                    ioe.printStackTrace();
                }
            }
        }

        _webServicesSelected = false;
        _mibFileSelected = true;
        _selection = OK_SELECTED;
        dispose();
    }

     /**
     * Loads MIB file or URL.
     *
     *
     * @throws IOException if the MIB file couldn't be found in the
     *             MIB search path
     * @throws MibLoaderException if the MIB file couldn't be loaded
     *             correctly
     */
    public void loadMib (String src) throws IOException, MibLoaderException
    {
        Mib mib;
        //System.out.println ("**mib src: " + src);
        File  file = new File (src);
        if (file.exists()) {
           if (_loader.getMib(file) != null) {
               mib = _loader.load (file);
               //System.out.println ("**mib loaded11: " + mib.getName());
               if (mib != null) {
                   _mibFileTable.put (file.getName(), mib);
               }
            }
            if (!_loader.hasDir(file.getParentFile())) {
                _loader.removeAllDirs();
                _loader.addDir (file.getParentFile());
            }
            
            mib = _loader.load (file);
            System.out.println ("**mib loaded1: " + mib.getName());
            if (mib != null) {
                _mibFileTable.put (file.getName(), mib);
            }

        }
        else {
            mib = _loader.load (src);
            //System.out.println ("**mib loaded2: " + mib.getName());
            if (mib != null) {
                _mibFileTable.put (file.getName(), mib);
            }
        }
    }

    protected void loadMib()
    {
    	JFileChooser chooser = new JFileChooser (_configPath);
    	chooser.setDialogTitle ("Select a MIB file");
    	
        if (chooser.showOpenDialog (this) == JFileChooser.APPROVE_OPTION) {
            File file = chooser.getSelectedFile();
            _cfgPath = file.getAbsolutePath();  //To remember the last path
            try {
                //System.out.println ("**loading: " + files[i].toString());
                _fileTable.put (file.getName(), file);
                loadMib (file.toString());
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }

        _webServicesSelected = false;
        _mibFileSelected = true;
        _selection = OK_SELECTED;
        this.dispose();
    }

    protected MibLoader getMibLoaderFromDlg()
    {
        return _loader;
    }

    protected String getMibFilename()
    {
        return _mibFilename;
    }

/**
     * Get the list of files.
     *
     * @return  list of files.
     */
    public Map getListOfMibFiles()
    {
        return _mibFileTable;
    }

    /**
     * Get the list of files.
     * 
     * @return  list of files.
     */
    public Map getListOfFiles()
    {
        return _fileTable;
    }

    /**
     * Get the URL from the RSD dialog.
     * @return  URL string
     */
    public String getURLStringFromDialog()
    {
        return _urlString;
    }

    /**
     * Returns the if dialog selection is OK or Cancel.
     *
     * @return  integer selection.
     */
    public int showDialog()
    {
        return _selection;
    }

    /**
     * Returns a boolean that indicates if the web services or file system is selected.
     *
     * @return  true or false.
     */
    public boolean isWebServiceSelected()
    {
        return _webServicesSelected;
    }

    /**
     * Retruns a boolean indicating if a Mib file is selected
     * 
     * @return true or false
     */
    public boolean isMibFileSelected()
    {
        return _mibFileSelected;
    }

    public static void main(String[] argv)
    {
        RequestServicesDialog rsd = new RequestServicesDialog();
        rsd.setVisible (true);
    }

    protected class ErrorMsgDialog extends JDialog
    {
        public ErrorMsgDialog (String errorStr)
        {
            setModal (true);
            setResizable (true);
            setTitle ("Error Message");
            setSize (500, 300);
            Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
            setBounds ((screenSize.width-500)/2, (screenSize.height-300)/2, 500, 300);
            JTextArea descriptionArea = new JTextArea();
            JScrollPane sp = new JScrollPane (descriptionArea);
            descriptionArea.append (errorStr);
            getContentPane().add (sp, SwingConstants.CENTER);

            try {
                int position = descriptionArea.getLineStartOffset (0);   // If last line: _rightTextArea.getLineCount() - 1);
                descriptionArea.setCaretPosition (position);
            }
            catch (Exception e) {
                e.printStackTrace();
            }

            addWindowListener (new WindowAdapter() {
                public void windowClosing (WindowEvent e) {
                    dispose();
                }
            });
        }
    }

    //Variables
    public static final int OK_SELECTED = 1;
    public static final int CANCEL_SELECTED = 0;
    protected int _selection = CANCEL_SELECTED;

    //protected static String _configPath = "C:\\users\\mbreedy\\develop\\delegation\\DelegationManagement\\services";
    //protected static String _configPath = "C:\\users\\mbreedy\\develop\\cerdec\\Demo2011\\config";
    protected static String _configPath = System.getProperty ("user.dir");
    protected static String _cfgPath = System.getProperty ("user.dir");
    //protected static String _cfgPath = "C:\\users\\mbreedy\\develop\\cerdec\\Demo2011\\config";

    protected boolean _webServicesSelected = true;
    protected boolean _mibFileSelected = true;
    protected String _urlString = "";
    protected String _mibFilename;
    protected JLabel _urlLabel;
    protected JTextField _textField;

    protected Map<String,File> _fileTable;          //Maps the filename to its file object.
    protected Map<String, Mib> _mibFileTable;       //Maps the mib filename to its Mib object.
    private MibLoader _loader = new MibLoader();
}
