package kaos.tools.webServiceTool;

import net.htmlparser.jericho.MicrosoftTagTypes;
import net.htmlparser.jericho.PHPTagTypes;
import net.htmlparser.jericho.MasonTagTypes;
import net.htmlparser.jericho.Source;
import net.htmlparser.jericho.Segment;
import net.percederberg.mibble.Mib;
import net.percederberg.mibble.MibLoader;

import javax.agent.service.directory.DirectoryFailure;
import javax.swing.*;
import javax.swing.tree.*;
import static javax.swing.JFileChooser.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.border.*;

import java.util.*;
import java.io.File;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.awt.*;
import java.awt.event.*;
import java.net.URL;

import kaos.core.csi.ontology.OntologyService;
import kaos.kpat.applet.ExampleFileFilter;
import kaos.ontology.repository.JTPOntologyRepository;

/**
 * Date: Jul 26, 2010
 * Time: 11:29:35 AM
 *
 * @author Maggie Breedy <KAoS group>
 * @version: $Revision: 1.106 $
 *
 */
public class ServicesManagementTool extends JFrame
{
    /**
     * Constructor initialize the components
     */
    public ServicesManagementTool()
    {
        _mainServicesMap = new Hashtable<String, ServicesObject>();
        _webServHashtable = new Hashtable <String, String>();
        _xsdFileHashtable = new Hashtable <String, String>();
        _threadsMap = new Hashtable <String, TimerThread>();
        _ontologyRepMap = new Hashtable <String, OntologyService>();
        _xsdObjList = new ArrayList();

        initComponents();
    }

    /**
     * Creates the frame that holds the components.
     */
    protected void initComponents()
    {
        setResizable (true);
        setTitle ("Services Management Tool");
        setSize (1300, 900);
        setLayout (new GridBagLayout());
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        setBounds ((screenSize.width-1300)/2, (screenSize.height-900)/2, 1300, 900);

        GridBagConstraints gbc = new GridBagConstraints();
        JPanel topPanel = new JPanel (new GridBagLayout());
        topPanel.setPreferredSize(new Dimension (990, 50));
        topPanel.setMinimumSize (new Dimension (990, 50));
        topPanel.setBorder (new EtchedBorder());
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbc.weightx = 0.1;
        gbc.weighty = 0.1;
        gbc.gridwidth = 3;
        gbc.gridheight = 1;
        gbc.insets = new Insets (0,0,0,0);
        getContentPane().add (topPanel,gbc);

        JPanel leftTopPanel = new JPanel (new GridBagLayout());
        leftTopPanel.setPreferredSize(new Dimension (280, 250));
        leftTopPanel.setMinimumSize (new Dimension (280, 250));
        leftTopPanel.setBorder (new EtchedBorder());
        gbc.gridx = 0;
        gbc.gridy = 1;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbc.weightx = 0.5;
        gbc.weighty = 0.5;
        gbc.gridwidth = 1;
        gbc.gridheight = 1;
        gbc.insets = new Insets (0,0,0,0);
        getContentPane().add (leftTopPanel,gbc);

        JPanel leftBottomPanel = new JPanel (new GridBagLayout());
        leftBottomPanel.setPreferredSize(new Dimension (280, 200));
        leftBottomPanel.setMinimumSize (new Dimension (280, 200));
        leftBottomPanel.setBorder (new EtchedBorder());
        gbc.gridx = 0;
        gbc.gridy = 2;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbc.weightx = 0.5;
        gbc.weighty = 0.5;
        gbc.gridwidth = 1;
        gbc.gridheight = 1;
        gbc.insets = new Insets (0,0,0,0);
        getContentPane().add (leftBottomPanel,gbc);

        gbc = new GridBagConstraints();
        JPanel centerTopPanel = new JPanel (new GridBagLayout());
        centerTopPanel.setPreferredSize(new Dimension (300, 250));
        centerTopPanel.setMinimumSize (new Dimension (300, 250));
        centerTopPanel.setBorder (new EtchedBorder());
        gbc.gridx = 1;
        gbc.gridy = 1;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.anchor = GridBagConstraints.CENTER;
        gbc.weightx = 0.5;
        gbc.weighty = 0.5;
        gbc.gridwidth = 1;
        gbc.gridheight = 1;
        gbc.insets = new Insets (0,0,0,0);
        getContentPane().add (centerTopPanel,gbc);

        JPanel centerBottomPanel = new JPanel (new GridBagLayout());
        centerBottomPanel.setPreferredSize(new Dimension (410, 200));
        centerBottomPanel.setMinimumSize (new Dimension (410, 200));
        centerBottomPanel.setBorder (new EtchedBorder());
        gbc.gridx = 1;
        gbc.gridy = 2;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.anchor = GridBagConstraints.CENTER;
        gbc.weightx = 0.5;
        gbc.weighty = 0.5;
        gbc.gridwidth = 1;
        gbc.gridheight = 1;
        gbc.insets = new Insets (0,0,0,0);
        getContentPane().add (centerBottomPanel,gbc);

        gbc = new GridBagConstraints();
        JPanel rightPanel = new JPanel (new GridBagLayout());
        rightPanel.setPreferredSize(new Dimension (410, 850));
        rightPanel.setMinimumSize (new Dimension (410, 850));
        rightPanel.setBorder (new EtchedBorder());
        gbc.gridx = 2;
        gbc.gridy = 1;
        gbc.gridheight = 2;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.anchor = GridBagConstraints.SOUTHEAST;
        gbc.weightx = 1.0;
        gbc.weighty = 1.0;
        gbc.gridwidth = 1;
        gbc.gridheight = 2;
        gbc.insets = new Insets (0,0,0,0);
        getContentPane().add (rightPanel,gbc);

        //Top panel components
        gbc = new GridBagConstraints();
        JLabel topLabel = new JLabel ("Service Source: ");
        topLabel.setFont (new Font ("Frame", Font.BOLD, 12));
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.insets = new Insets (5,5,5,0);
        gbc.weightx = 0.0;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.NORTHWEST;
        topPanel.add (topLabel, gbc);

        _urlsComboBoxModel = new DefaultComboBoxModel();
        _urlsComboBox = new JComboBox (_urlsComboBoxModel);
        _urlsComboBox.setEditable (true);
        _urlsComboBox.setSelectedItem ("");
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbc.insets = new Insets(5,0,5,5);
        gbc.gridx = 1;
        gbc.gridy = 0;
        gbc.weightx = 0.8;
        topPanel.add (_urlsComboBox, gbc);

        JButton browseButton = new JButton ("Browse");
        //browseButton.setFont (new Font ("Frame", Font.BOLD, 10));
        browseButton.setEnabled (true);
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.NORTHEAST;
        gbc.gridx = 2;
        gbc.gridy = 0;
        gbc.weightx = 0.0;
        gbc.insets = new Insets (5,5,5,5);
        topPanel.add (browseButton, gbc);

        _urlsComboBox.addActionListener (new ActionListener() {
            public void actionPerformed (ActionEvent e) {
                JComboBox cb = (JComboBox)e.getSource();
                String name = (String)cb.getSelectedItem();

            }
        });

        browseButton.addActionListener (new ActionListener() {
            public void actionPerformed (ActionEvent e) {
                displayServicesDialog();
            }
        });

        //Left Panels components
        //Top Left panel
        gbc = new GridBagConstraints();
        _servLabel = new JLabel ("Services");
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.insets = new Insets (5,5,5,5);
        gbc.weightx = 0.1;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.NORTHWEST;
        leftTopPanel.add (_servLabel, gbc);

        _rootTree = new DefaultMutableTreeNode ("");
        _treeModel = new DefaultTreeModel (_rootTree);
        _servicesTree = new JTree(_treeModel);
        _servicesTree.setRootVisible (false);
        _treeScrollPane = new JScrollPane (_servicesTree);
        gbc.fill = GridBagConstraints.BOTH;
        gbc.anchor = GridBagConstraints.CENTER;
        gbc.insets = new Insets (5,5,5,5);
        gbc.gridx = 0;
        gbc.gridy = 1;
        gbc.weightx = 1.0;
        gbc.weighty = 1.0;
        leftTopPanel.add (_treeScrollPane, gbc);

        _servicesTree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
        _servicesTree.addTreeExpansionListener (new ServicesTreeExpansionListener());
        _servicesTree.expandRow (0);

        _servicesTree.addTreeSelectionListener (new TreeSelectionListener() {
            public void valueChanged (TreeSelectionEvent e) {
                //Need to check if the tree is still visible
                String serviceName = "";

                if (e.getNewLeadSelectionPath() != null) {
                    _bChangingServiceSelected = true;
                    //System.out.println("********_bChangingServiceSelected1: " +_bChangingServiceSelected);
                    ((JTree) e.getSource()).scrollPathToVisible (e.getNewLeadSelectionPath());
                    JTree t = (JTree) e.getSource();
                    serviceName = t.getLastSelectedPathComponent().toString();
                    //System.out.println ("****serviceName: " + serviceName);
                    if (serviceName.contains (".wsdl")) {
                        _operLabel.setText ("Operations");
                        _actLabel.setText ("Action Name:");
                        _sactLabel.setText ("Super Action Name:");
                    }
                    else {
                        _operLabel.setText ("Classes");
                        _actLabel.setText ("Class Name:");
                        _sactLabel.setText ("Super Class Name:");
                    }

                    _rightTextArea.removeAll();
                    _opListModel.removeAllElements();
                    _wsdlTable.removeAll();
                    _namespTable.removeAll();
                    _namespTableVector.removeAllElements();
                    
                    if (_usingWebServices) {
                        if (!_xsdFileHashtable.isEmpty() && serviceName.contains(".xsd")) {
                            serviceName = _xsdFileHashtable.get (serviceName);
                            _operLabel.setText ("Classes");
                            _actLabel.setText ("Class Name:");
                            _sactLabel.setText ("Super Class Name:");
                            //System.out.println ("****serviceName: " + serviceName);
                        }
                        else {
                            _operLabel.setText ("Operations");
                            _actLabel.setText ("Action Name:");
                            _sactLabel.setText ("Super Action Name:");
                        }
                    }

                    if (serviceName == null) {
                        _bChangingServiceSelected = false;
                        return;
                    }
                    else {
                       if (_urlsComboBoxModel.getSize() > 0) {
                           for (int i = 0; i < _urlsComboBoxModel.getSize(); i++) {
                               if ( _urlsComboBoxModel.getElementAt(i).toString().endsWith (serviceName)) {
                                   _urlsComboBox.setSelectedIndex (i);
                               }
                            }
                        }
                    }
                    //Get ontology repository instances
                    getOntologyRepDefInstances (serviceName);
                    _serviceCurrentlySelected = serviceName;
                    //System.out.println ("****serviceName _serviceCurrentlySelected: " + _serviceCurrentlySelected);

                    //System.out.println ("****_mainServicesMap: " + _mainServicesMap);
                    if (_mainServicesMap.size() > 0) {
                        ServicesObject servObj = _mainServicesMap.get (serviceName);
                        //System.out.println ("****_mainServicesMap:servObj: " + servObj);
                        //String abbr = servObj._defaultAbbr;
                        //String defImpOnt = servObj._defaultImpOntology;
                        String logicalURL = servObj._logicalURL;
                        //System.out.println ("****serviceName Selected logicalURL: " + logicalURL);
                        _logicalTextField.setText (logicalURL);

                        Map<String,String> impOntMap = servObj._importedOntMap;
                        //System.out.println ("****_mainServicesMap:impOntMap size: " + impOntMap.size());
                        if (impOntMap.isEmpty()) {
                            Vector<String> vio = new Vector<String>();
                            vio.addElement (servObj._defaultAbbr);
                            vio.addElement (servObj._defaultImpOntology);
                            _namespTableVector.addElement (vio);
                        }
                        else {
                            Iterator itr = impOntMap.keySet().iterator();
                            while (itr.hasNext()) {
                                // Get key Object
                                Vector<String> vio = new Vector<String>();
                                String impAbbr = (String) itr.next();
                                //System.out.println ("****_mainServicesMap:impAbbr: " + impAbbr);
                                String impURI = impOntMap.get(impAbbr);
                                //System.out.println ("****_mainServicesMap:impURI: " + impURI);
                                vio.addElement (impAbbr);
                                vio.addElement (impURI);
                                //System.out.println ("****_mainServicesMap:vio: " + vio);
                                //System.out.println ("****Service selection:Adding:abbr " + impAbbr + " ...uri: " + impURI);
                                _namespTableVector.addElement (vio);
                                //System.out.println ("**_ontologyRepMap server selected: " + _ontologyRepMap);
                            }
                        }
                        //System.out.println ("****_mainServicesMap:_namespTableVector: " + _namespTableVector);
                        _dModel.fireTableDataChanged();

                        Map<String, OperationsObject> operationsMap = servObj._operationsMap;

                        if (operationsMap != null) {
                            Vector v = new Vector (operationsMap.keySet());
                            //System.out.println ("****v: " + v);
                            Collections.sort (v);

                            Iterator it = v.iterator();
                            while (it.hasNext()) {
                                String opName = (String) it.next();
                                //System.out.println("********Adding opName to model: " + opName);
                                if (_fileType.equals ("mib")) {
                                    if (!opName.contains("Trap")) {
                                        _opListModel.addElement (opName);
                                    }
                                }
                                else {
                                    _opListModel.addElement (opName);
                                }
                            }
                        }
                    }
                }

                //System.out.println("********serviceName: " + serviceName);
                if (serviceName.contains ("wsdl")) {
                    _fileType = "wsdl";
                }
                else if (serviceName.contains ("xsd")) {
                    _fileType = "xsd";
                }

                //System.out.println("********fileType: " + _fileType);
                OntologyServicesBuilder osb = new OntologyServicesBuilder (_mainServicesMap, _fileType);
                if (!serviceName.equals ("")) {
                    StringBuffer sb = osb.init (serviceName);
                    //System.out.println("********setDataFromFile:ontology: " + sb.toString());
                    String stringWsdl = sb.toString();
                    //_rightTextArea.setText("");
                    _rightTextArea.setText (stringWsdl);
                }

                try {
                    int position = _rightTextArea.getLineStartOffset (0);   // If last line: _rightTextArea.getLineCount() - 1);
                    _rightTextArea.setCaretPosition(position);
                }
                catch (Exception ex) {
                    ex.printStackTrace();
                }

                _bChangingServiceSelected = false;
                
                //System.out.println("**_opListModel.size(): " + _opListModel.size());
                if (_opListModel.size() > 0) {
                    _opList.setSelectedIndex (0);
                }
            }
        });

        //Bottom Left panel
        gbc = new GridBagConstraints();
        JLabel logLabel = new JLabel ("Logical URL:");
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.insets = new Insets (5,5,5,5);
        gbc.weightx = 0.1;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.NORTHWEST;
        leftBottomPanel.add (logLabel, gbc);

        _logicalTextField = new JTextField();
        _logicalTextField.setText ("");
        _logicalTextField.setEditable (true);
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbc.insets = new Insets(5,5,5,5);
        gbc.gridx = 0;
        gbc.gridy = 1;
        gbc.weightx = 0.5;
        leftBottomPanel.add (_logicalTextField, gbc);

        gbc = new GridBagConstraints();
        JLabel impOntLabel = new JLabel ("Imported Ontologies");
        gbc.gridx = 0;
        gbc.gridy = 2;
        gbc.insets = new Insets (5,5,5,5);
        gbc.weightx = 0.1;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.NORTHWEST;
        leftBottomPanel.add (impOntLabel, gbc);

        Vector columnNames = new Vector(2);
        columnNames.addElement ("Abbr");
        columnNames.addElement ("URI");

        _namespTableVector = new Vector<Object>();
        //setNamespacesOnTable();
        _dModel = new DataTableModel (_namespTableVector, columnNames);
        _namespTable = new JTable (_dModel) {
           public boolean isCellEditable(int row, int column) {
               return true;
           }
        };

        // _namespTable.getTableHeader().setReorderingAllowed(false);
        _namespTable.setCellSelectionEnabled (false);
        _namespTable.setShowGrid (true);
        _namespTable.setShowHorizontalLines (true);
        _namespTable.setShowVerticalLines (true);
        _namespTable.setColumnSelectionAllowed (false);
        _namespTable.setRowSelectionAllowed (true);

        _namespTable.putClientProperty ("terminateEditOnFocusLost", Boolean.TRUE);

        for (int i = 0; i < 2; i++) {
           TableColumn tableMod = _namespTable.getColumnModel().getColumn(i);
           if (i == 0) {
               tableMod.setPreferredWidth (50);
           }
           else {
                tableMod.setPreferredWidth (250);
           }
        }

        JScrollPane tbScrollPane = new JScrollPane (_namespTable);
        tbScrollPane.setPreferredSize(new Dimension (280, 200));
        tbScrollPane.setMinimumSize (new Dimension (280, 200));
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 3;
        gbc.anchor = GridBagConstraints.SOUTHWEST;
        gbc.fill = java.awt.GridBagConstraints.BOTH;
        gbc.insets = new Insets (5,5,5,5);
        gbc.weightx = 0.5;
        gbc.weighty = 0.5;
        //tbScrollPane.setViewportView (_namespTable);
        leftBottomPanel.add (tbScrollPane, gbc);

        _namespTable.getSelectionModel().addListSelectionListener (new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                ListSelectionModel lsm = (ListSelectionModel) e.getSource();
                if (e.getValueIsAdjusting()) {
                    return;
                }
                else {
                    int row = _namespTable.getSelectedRow();
                    //System.out.println(" ********sel row: " + row);
                }
            }
        });

        _dModel.addTableModelListener (new TableModelListener() {
            public void tableChanged(TableModelEvent e) {
                int row = _namespTable.getSelectedRow();
                if (row >= 0) {
                    //System.out.println(" ********Calling Update Ontology sel row: " + row);
                    if (_mainServicesMap != null) {
                        updateOntology();
                    }
                }
            }
        });

        JButton addButton = new JButton ("Add Abbr/URI");
        gbc.gridx = 0;
        gbc.gridy = 4;
        gbc.insets = new Insets (5,50,5,50);
        gbc.weightx = 0.1;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.CENTER;
        leftBottomPanel.add (addButton, gbc);

        addButton.addActionListener (new ActionListener() {
           public void actionPerformed (ActionEvent e) {
               Vector<String> names = new Vector<String>();
               names.addElement ("");
               names.addElement ("");
               _namespTableVector.addElement (names);
               _dModel.fireTableDataChanged();
           }
        });

        //Top center panel
        gbc = new GridBagConstraints();
        _operLabel = new JLabel ("Operations");
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.insets = new Insets (5,5,5,5);
        gbc.weightx = 0.1;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.NORTHWEST;
        centerTopPanel.add (_operLabel, gbc);

        _anotButton = new JButton ("Add Anotations and XSL files");
        gbc.gridx = 1;
        gbc.gridy = 0;
        gbc.insets = new Insets (5,50,5,5);
        gbc.weightx = 0.1;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.EAST;
        centerTopPanel.add (_anotButton, gbc);
        _anotButton.setEnabled (true);

        _opListModel = new DefaultListModel();
        _opList = new JList (_opListModel);
        JScrollPane opPane = new JScrollPane (_opList);
        gbc.fill = GridBagConstraints.BOTH;
        gbc.anchor = GridBagConstraints.CENTER;
        gbc.insets = new Insets (5,5,5,5);
        gbc.gridx = 0;
        gbc.gridy = 1;
        gbc.gridwidth = 2;
        gbc.weightx = 0.5;
        gbc.weighty = 0.5;
        centerTopPanel.add (opPane, gbc);

        _opList.getSelectionModel().addListSelectionListener (new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                ListSelectionModel lsm = (ListSelectionModel) e.getSource();
                if (e.getValueIsAdjusting()) {
                    return;
                }
                else {
                    String operationName = (String) _opList.getSelectedValue();
                    if (operationName != null) {
                        //System.out.println ("****calling handleOperationSelection: " + operationName);
                        //System.out.println ("****calling selected: " + _opList.getSelectedIndex());
                        handleOperationSelection (operationName);
                    }
                }
            }
        });

        _anotButton.addActionListener (new ActionListener() {
           public void actionPerformed (ActionEvent e) {
               String filePath = _urlsComboBoxModel.getSelectedItem().toString();
               //System.out.println ("****filePath: " + filePath);
               getAnnotations();
           }
        });

        gbc = new GridBagConstraints();
        _actLabel = new JLabel ("Action Name:");
        gbc.gridx = 0;
        gbc.gridy = 2;
        gbc.insets = new Insets (5,5,5,5);
        gbc.weightx = 0.1;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.NORTHWEST;
        centerTopPanel.add (_actLabel, gbc);

        _actTextField = new JTextField();
        _actTextField.setText ("");
        _actTextField.setEditable (true);
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.CENTER;
        gbc.insets = new Insets(5,5,5,5);
        gbc.gridx = 1;
        gbc.gridy = 2;
        gbc.weightx = 0.9;
        centerTopPanel.add (_actTextField, gbc);
        //_textAutoCompleter = new TextAutoCompleter (_actTextField);

        gbc = new GridBagConstraints();
        _sactLabel = new JLabel ("Super Action Name:");
        gbc.gridx = 0;
        gbc.gridy = 3;
        gbc.insets = new Insets (5,5,5,5);
        gbc.weightx = 0.1;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.NORTHWEST;
        centerTopPanel.add (_sactLabel, gbc);

        _supActTextField = new JTextField();
        _supActTextField.setText ("");
        _supActTextField.setEditable (true);
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.CENTER;
        gbc.insets = new Insets(5,5,5,5);
        gbc.gridx = 1;
        gbc.gridy = 3;
        gbc.weightx = 0.9;
        centerTopPanel.add (_supActTextField, gbc);


        DocumentListener documentListener = new DocumentListener() {
            public void changedUpdate (DocumentEvent documentEvent) {
                System.out.println ("changed text: " + _actTextField.getText());
            }
            public void insertUpdate(DocumentEvent documentEvent) {
                String servNameSel = "";
                servNameSel = _servicesTree.getLastSelectedPathComponent().toString();
                //System.out.println ("***Thread servNameSel: " + servNameSel);
                TimerThread timerThread = _threadsMap.get (servNameSel);
                if (timerThread == null || !timerThread.isAlive()) {
                    timerThread = new TimerThread();
                    _threadsMap.put (servNameSel, timerThread);
                    timerThread.start();
                }
                else {
                    timerThread._reset = true;
                }
            }
            public void removeUpdate(DocumentEvent documentEvent) {
            }
        };

        _actTextField.getDocument().addDocumentListener (documentListener);
        _textAutoCompleter = new TextAutoCompleter (_actTextField, false, _mainServicesMap, _ontologyRepMap,
                                                    _columnSelected, _rowSelected, this);
        

        _supActTextField.getDocument().addDocumentListener (documentListener);
        _textAutoCompleter = new TextAutoCompleter (_supActTextField, false, _mainServicesMap, _ontologyRepMap,
                                                    _columnSelected, _rowSelected, this);
        _logicalTextField.getDocument().addDocumentListener (documentListener);

        //Bottom center panel
        _colNames = new Vector (4);
        _colNames.addElement ("WSDLParams");
        _colNames.addElement ("WSDLType");
        _colNames.addElement ("OWLPropValue");
        _colNames.addElement ("OWLPropRange");

        _wsdlTableVector = new Vector<Object>();
        _wsdlTableModel = new WsdlDataTableModel (_wsdlTableVector, _colNames);

        _wsdlTable = new JTable (_wsdlTableModel) {
           public boolean isCellEditable (int row, int column) {
               if (column == 2 || column == 3) {
                   return true;
               }
               else {
                   return false;
               }
           }

           //Implement table cell tool tips.
           /*public String getToolTipText(MouseEvent e)
           {
                String tip = null;
                java.awt.Point p = e.getPoint();
                int rowIndex = rowAtPoint(p);
                int colIndex = columnAtPoint(p);
                int realColumnIndex = convertColumnIndexToModel(colIndex);

                if (realColumnIndex == 2 || realColumnIndex == 3) {
                    tip = "For Code Completion: Press Enter and then click outside";
                }
                else {
                    tip = super.getToolTipText(e);
                }
                return tip;
            }*/

            //Implement table header tool tips.
           protected JTableHeader createDefaultTableHeader() {
               return new JTableHeader(columnModel) {
                   public String getToolTipText(MouseEvent e) {
                       String tip = null;
                       java.awt.Point p = e.getPoint();
                       int index = columnModel.getColumnIndexAtX(p.x);
                       int realIndex = columnModel.getColumn(index).getModelIndex();
                       return _columnToolTips[realIndex];
                   }
               };
           }
        };

        _wsdlTable.setCellSelectionEnabled (false);
        _wsdlTable.setShowGrid (true);
        _wsdlTable.setShowHorizontalLines (true);
        _wsdlTable.setShowVerticalLines (true);
        _wsdlTable.setColumnSelectionAllowed (false);
        _wsdlTable.setRowSelectionAllowed (true);

        for (int i = 0; i < 2; i++) {
            TableColumn tableMod = _wsdlTable.getColumnModel().getColumn(i);
            if (i == 0 || i == 1) {
                tableMod.setPreferredWidth (50);
            }
            else {
                tableMod.setPreferredWidth (75);
            }
        }

        //Magic Property: when a table loses focus any uncommitted changes will be saved.
        _wsdlTable.putClientProperty ("terminateEditOnFocusLost", Boolean.TRUE);
        //_wsdlTable.setDefaultRenderer (Object.class, new ServicesTableCellRenderer());

        JScrollPane tScrollPane = new JScrollPane (_wsdlTable);
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.anchor = GridBagConstraints.SOUTH;
        gbc.fill = java.awt.GridBagConstraints.BOTH;
        gbc.weightx = 0.5;
        gbc.weighty = 0.5;
        gbc.gridwidth = 2;
        gbc.insets = new Insets(5,5,5,5);
        //tScrollPane.setViewportView (_wsdlTable);
        centerBottomPanel.add (tScrollPane, gbc);

        _wsdlTable.getSelectionModel().addListSelectionListener (new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                ListSelectionModel lsm = (ListSelectionModel) e.getSource();
                if (e.getValueIsAdjusting()) return;
                
                if (lsm.isSelectionEmpty()) {
                }
                else {
                    _rowSelected = _wsdlTable.getSelectedRow();
                    _columnSelected = _wsdlTable.getSelectedColumn();
                    _wsdlTable.setDefaultEditor (Object.class, new ParamsTableEditor());
                    String value = _wsdlTable.getValueAt(_rowSelected, 2).toString();
                    //System.out.println("******value CurrentlySelected:" + value);
                    if (value.contains(":")) {
                        String[] array = value.split(":");
                        if (array.length > 1) {
                            value = array[1];
                        }
                    }
                    scrollToFirst (value);
                    underlineEach (value);
                }
            }
        });

        _wsdlTableModel.addTableModelListener (new TableModelListener() {
            public void tableChanged(TableModelEvent e) {
                int row = _wsdlTable.getSelectedRow();
                int col = _wsdlTable.getSelectedColumn();

                if (row >= 0) {
                    //System.out.println(" ********_wsdlTableModel:calling update Ontology");
                    if (_mainServicesMap != null) {
                        updateOntology();
                        ServicesObject so =_mainServicesMap.get (_serviceCurrentlySelected);
                        //System.out.println("******Update _serviceCurrentlySelected:" +_serviceCurrentlySelected);
                        Map<String, String> importedOntMap = so._importedOntMap;
                        //System.out.println("******Update _importedOntMap:" + importedOntMap.size());
                        //System.out.println("******Update row:" + row + " column:" + col);
                        //System.out.println("******Update v: " + v.elementAt(col));
                        if (col == 0 || col == 1) {
                            return;
                        }
                        Vector v = _wsdlTableModel.getRowElements (row);
                        if (v.size() > 0) {
                            String str = v.elementAt(col).toString();
                            //System.out.println("******Update str:" + str);
                            if (str.contains (":")) {
                                String[] array = str.split(":");
                                if (array.length > 0) {
                                    if (importedOntMap.containsKey (array[0]) && array[1] != "") {
                                        str = array[1];
                                        //System.out.println("******Update str:" + str);
                                    }
                                }
                            }
                            scrollToFirst (str);
                            underlineEach (str);
                        }
                    }
                }
            }
         });

        //Right panel
        gbc = new GridBagConstraints();
        JLabel descLabel = new JLabel ("Ontology");
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.insets = new Insets (5,5,5,5);
        gbc.weightx = 0.1;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.NORTHEAST;
        rightPanel.add (descLabel, gbc);

        JButton saveButton = new JButton ("Save Ontology");
        gbc.gridx = 1;
        gbc.gridy = 0;
        gbc.insets = new Insets (5,50,5,5);
        gbc.weightx = 0.1;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.anchor = GridBagConstraints.EAST;
        rightPanel.add (saveButton, gbc);

        _rightTextArea = new JTextArea();
        JScrollPane jspr = new JScrollPane (_rightTextArea);
        gbc.anchor = GridBagConstraints.NORTHEAST;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.gridx = 0;
        gbc.gridy = 1;
        gbc.gridwidth = 2;
        gbc.insets = new Insets (5, 5, 5, 5);
        gbc.weightx = 1.0;
        gbc.weighty = 1.0;
        rightPanel.add (jspr, gbc);

        saveButton.addActionListener (new ActionListener() {
            public void actionPerformed (ActionEvent e) {
                saveWsdlToFile();
            }
        });

        this.addWindowListener (new WindowAdapter() {
            public void windowClosing (WindowEvent e) {
                dispose();
                System.exit (1);
            }
        });
    }

    public void scrollToFirst (String string)
    {
        //System.out.println ("****calling scrollToFirst string: " + string);
        String text = _rightTextArea.getText();
        int totalLines = _rightTextArea.getLineCount();
        for (int i = 0; i < totalLines; i++) {
            try {
                int start = _rightTextArea.getLineStartOffset(i);
                int end = _rightTextArea.getLineEndOffset(i);
                String line = text.substring(start, end);
                if(line.contains(string)) {
                   _rightTextArea.setCaretPosition(start);
                   break;
                }
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    public void underlineEach (String string)
    {
        //System.out.println ("****calling underlineEach string: " + string);
        WordSearcher wordSearcher = new WordSearcher (_rightTextArea);
        wordSearcher.search (string);
    }

    /**
     * Gets the data parsed from DOM for each web service
     *
     * @param serviceStr   web service name
     */
    protected TreeFileObject getWebServicesData (String serviceStr)
    {
        String wsdlURL = _webServHashtable.get (serviceStr);
        //System.out.println ("**url getting the stream: " + wsdlURL);
        ParseWithDOM parser = new ParseWithDOM();
        StringBuffer buffer = parser.getStreamByURL (wsdlURL);
        String strBuf = buffer.toString();
        //System.out.println("***str : "+ strBuf.toString());
        String str = "test.xml";
         try {
            BufferedWriter out = new BufferedWriter (new FileWriter(str));
            out.write (strBuf);
            out.close();
        }
         catch (Exception e) {
             e.printStackTrace();
        }
        parser.init (str, serviceStr);
        Map<String, Map> data = parser.getFileInfo();   //Maps operation name with a map of attributes.
        //Map<String, String> importedOntDefinitions = parser.getImportedOntDefinitionsMap();
        Map<String, Map> compTypesData = parser.getFileComplexTypeInfo(); //Maps comp types class name with a map
                                                                          // of attributes.
        Map<String, Vector> simpleTypesData = parser.getSimpleTypeInfo(); //Map of simple type name with a vector of
                                                                           // enumerations

        //System.out.println ("**data from map: " + data);
        TreeFileObject treeObj = parser.getTreeFileObject();
        //System.out.println ("**Web service treeObj : " + treeObj);

        setDataFromFile (data, serviceStr, treeObj, "", simpleTypesData);

        ArrayList al = treeObj._listOfChildren;
        if (al.size() > 0) {
            for (Object urlObj : al) {
                String url = urlObj.toString();
                //System.out.println ("**Web service urls : " + url);
                if (url.contains (".xsd")) {
                    //getParserServices (url);
                    getWebServicesXSDData (url);
                }
                else if (url.equals("Inner Classes")) {
                    if (!compTypesData.isEmpty()) {
                        System.out.println ("****compTypesData is not empty");
                        getComplexTypesData (compTypesData, "Inner Classes", treeObj, serviceStr);
                    }
                }
            }
        }

        //setDataFromFile (data, serviceStr, treeObj, compTypesData);
        
        return treeObj;
    }

    protected void getComplexTypesData (Map<String, Map> compTypesData, String name, TreeFileObject treeObj,
                                        String servParentName)
    {
        setDataFromFile (compTypesData, name, treeObj, servParentName, new HashMap<String, Vector>());
    }

    /**
     * Parses the information from the xsd files
     *
     * @param xsdURL the xsd file name.
     */
    protected void getWebServicesXSDData (String xsdURL)
    {
        //System.out.println ("**url getWebServicesXSDData the xsdURL: " + xsdURL);
        //System.out.println ("**url getWebServicesXSDData the _webServHashtable: " + _webServHashtable);

        //String wsdlURL = _webServHashtable.get (serviceStr);
        //System.out.println ("**url getting the stream: " + wsdlURL);
        ParseWithDOM parser = new ParseWithDOM();
        StringBuffer buffer = parser.getStreamByURL (xsdURL);
        String strBuf = buffer.toString();
        //System.out.println("***str : "+ strBuf.toString());
        String str = "test.xml";
         try {
            BufferedWriter out = new BufferedWriter (new FileWriter(str));
            out.write (strBuf);
            out.close();
        }
         catch (Exception e) {
             e.printStackTrace();
        }
        parser.init2 (str, xsdURL);
        Map<String, Map> data = parser.getFileInfo();   //Maps operation name with a map of attributes.
        //System.out.println ("**XSD data from map: " + data);
        //Map<String, String> importedOntDefinitions = parser.getImportedOntDefinitionsMap();

        Map<String, Vector> simpleTypesData = parser.getSimpleTypeInfo();

        TreeFileObject treeObj = parser.getTreeFileObject();
        //System.out.println ("**treeObj: " + treeObj);
        setDataFromFile (data, xsdURL, treeObj, "", simpleTypesData);
    }

    /**
     * Gets the data parsed from DOM for the each wsdl file from the file system.
     *
     * @param fileStr
     */
    protected TreeFileObject getFileServicesData (String fileStr)
    {
        TreeFileObject treeObj = null;
        //System.out.println("***fileStr : "+ fileStr);
        if (fileStr.contains(".wsdl")) {
            File file = _fileTable.get (fileStr);
            ParseWithDOM parser = new ParseWithDOM();
            StringBuffer buffer = parser.getFileBufStream (file);
            String strBuf = buffer.toString();
            //System.out.println("***str : "+ strBuf.toString());
            String str = "test.xml";
            try {
                BufferedWriter out = new BufferedWriter (new FileWriter(str));
                out.write (strBuf);
                out.close();
            }
            catch (Exception e) {
                e.printStackTrace();
            }

            parser.init (str, fileStr);
            Map<String,Map> fileData = parser.getFileInfo();
            //Map<String, String> importedOntDefinitions = parser.getImportedOntDefinitionsMap();
            Map<String, Vector> simpleTypesData = parser.getSimpleTypeInfo();

            //System.out.println("***WSDL:fileData : "+ fileData);
            treeObj = parser.getTreeFileObject();



            Map<String, Map> compTypesData = parser.getFileComplexTypeInfo();

            //setDataFromFile (fileData, fileStr, treeObj);

            //System.out.println ("**Web service treeObj : " + treeObj);
            ArrayList al = treeObj._listOfChildren;
            if (al.size() > 0) {
                for (Object urlObj : al) {
                    String url = urlObj.toString();
                    //System.out.println ("**Web service urls : " + url);
                    if (url.equals("Inner Classes")) {
                        if (!compTypesData.isEmpty()) {
                            System.out.println ("****compTypesData is not empty");
                            getComplexTypesData (compTypesData, "Inner Classes", treeObj, fileStr);
                        }
                    }
                }
            }
      
            setDataFromFile (fileData, fileStr, treeObj, "", simpleTypesData);
        }
        else if (fileStr.contains (".xsd")) {
            //System.out.println ("**XSD_fileTable: " + _fileTable);
            File file = _fileTable.get (fileStr);
            //System.out.println ("**file: " + file.getName());
            ParseWithDOM parser = new ParseWithDOM();
            StringBuffer buffer = parser.getFileBufStream (file);
            String strBuf = buffer.toString();
            //System.out.println("***str : "+ strBuf.toString());
            String str = "test.xml";
            try {
                BufferedWriter out = new BufferedWriter (new FileWriter(str));
                out.write (strBuf);
                out.close();
            }
            catch (Exception e) {
                e.printStackTrace();
            }

            parser.init2 (str, fileStr);
            Map<String,Map> fileData = parser.getFileInfo();
            Map<String, Vector> simpleTypesData = parser.getSimpleTypeInfo();
            //Map<String, String> importedOntDefinitions = parser.getImportedOntDefinitionsMap();

           // XSDObject xsdObj = new XSDObject (fileStr, fileData);
           // _xsdObjList.add (xsdObj);
            treeObj = parser.getTreeFileObject();
            //System.out.println ("**XSDtreeObj: " + treeObj);
            setDataFromFile (fileData, fileStr, treeObj, "", simpleTypesData);
        }
        else {
            System.out.println ("No web service file");
            treeObj = null;
        }
        return treeObj;
    }


    /**Builds the data structure from the already parsed data and build the ontology.
      *
      * @param: _operationsMap     maps each operation with its attributes
      *                            and types
      */
     protected void setDataFromFile (Map<String, Map> data, String webServiceName, TreeFileObject treeObject,
                                     String parentServiceName, Map<String, Vector> simpleTypesData)
     {

        //System.out.println ("********setDataFromFile:webServiceName: " + webServiceName);
        //_namespTable.removeAll();
        String operationName = null;
        //String attr = null;
        //String type = null;
        ParametersObject paramsObj = null;
        OperationsObject operationsObj = null;
        Map<String, OperationsObject> allOperationsMap = new Hashtable<String, OperationsObject>();
        //Map the operations with the parameters.
        Map<String, ParametersObject> operationsMap = new Hashtable<String, ParametersObject>();
        Map<String, String> importedOntMap = new Hashtable<String, String>();
        /*Iterator iter = importedOntDefinitions.keySet().iterator();
        while (iter.hasNext()) {
            String key = (String) iter.next();
            String value = importedOntDefinitions.get(key);
            importedOntMap.put (key, value);
        }*/


        //String logicalURL = _logicalTextField.getText();
        //System.out.println ("**setDataFromFile logicalURL: " +  logicalURL);
        String logicalURL = "";
        String defaultLogURL = "http://ontology.ihmc.us/services/";
        String shortNameServName = "";
        if (webServiceName.contains (".wsdl")) {
            String[] array = webServiceName.split (".wsdl");
            //System.out.println ("**array[0]: " + array[0]);
            if (array.length > 0) {
                shortNameServName = array[0];
            }
            //System.out.println ("**handleOperationSelection:operationsMap]: " + operationsMap);
            logicalURL = defaultLogURL + shortNameServName + ".owl";
            //_logicalTextField.setText (logicalURL);
        }
        else if (webServiceName.contains (".xsd") && _usingWebServices == false) {
            String[] array = webServiceName.split (".xsd");
            if (array.length > 0) {
                shortNameServName = array[0];
            }
            logicalURL = defaultLogURL + shortNameServName + "Data" + ".owl";
            //_logicalTextField.setText (logicalURL);
        }
        else {
            logicalURL = defaultLogURL + webServiceName + ".owl";
           // _logicalTextField.setText (logicalURL);
        }

        //Map<String, String> importedOntMap = new Hashtable<String, String>();

        String defAbbr = "";
        String defImpOnt = "";

       // System.out.println ("**setDataFromFile webServiceName: " +  webServiceName);
        if (webServiceName.contains (".xsd")) {
            XSDObject xsdObj = new XSDObject (webServiceName, logicalURL, allOperationsMap, importedOntMap);
            _xsdObjList.add (xsdObj);
            defAbbr = "KaosEntity";
            defImpOnt = "http://ontology.ihmc.us/Entity.owl";
        }
        else {
            defAbbr = "KaosAction";
            defImpOnt = "http://ontology.ihmc.us/Action.owl";
        }

        //System.out.println ("**setDataFromFile::defAbbr: " +  defAbbr + "  defImpOnt: " + defImpOnt);
        importedOntMap.put (defAbbr, defImpOnt);

        String lioAbbr = "";
        String lioURL = "";
        //Add the imported ontologies from xsd files
        ArrayList listOfXSD = treeObject._listOfChildren;
        //System.out.println ("**setDataFromFile::listOfXSD: " + listOfXSD.size());
        //System.out.println(" ********xsd URI*****: " + treeObject._uri);

        if (listOfXSD.size() > 0) {
            for (Object servNameObj : listOfXSD) {
                if (servNameObj.toString().contains(".xsd")) {
                    String localImpOntServ = servNameObj.toString();
                    String[] array = localImpOntServ.split (".xsd");
                    String shortNameServ = array[0];
                    lioAbbr = "dm" + localImpOntServ.substring (0,1);
                    //String lioURL = "";
                    if (_usingWebServices) {
                        lioURL = shortNameServ + "Data" + ".owl";
                    }
                    else {
                        lioURL = defaultLogURL + shortNameServ + "Data" + ".owl";
                    }
                    //System.out.println(" ********lioURL: " + lioURL + " lioAbbr:" + lioAbbr);
                    importedOntMap.put (lioAbbr, lioURL);
                }
                else if (servNameObj.equals ("Inner Classes")) {
                    //System.out.println(" ********servNameObj:" + servNameObj);
                    String icURL = shortNameServName + "Data" + ".owl";
                    //importedOntMap.put (defAbbr, defImpOnt);
                    //webServiceName = "Inner Classes";
                }
            }
        }
        
        // Iterate over the operation names which are the keys
        Iterator it = data.keySet().iterator();
        while (it.hasNext()) {
            // Get key Object
            operationName = (String) it.next();
            //System.out.println ("********Map operationName: " + operationName);
            Map<String, Vector> attributesMap = data.get (operationName);
            //System.out.println ("**attributesMap size: " + attributesMap.size());
            Vector<String> paramVector = new Vector<String>();
            Vector<String> typeVector = new Vector<String>();
            Vector<String> minVector = new Vector<String>();
            Vector<String> maxVector = new Vector<String>();
            String superClassForNoCT = "";

            if (attributesMap.size() == 0) {
                paramVector.addElement ("NoAttribute");
                typeVector.addElement ("NoType");
            }

            Iterator it1 = attributesMap.keySet().iterator();
            while (it1.hasNext()) {
                 String name = (String) it1.next();
                 //System.out.println ("********attributesMap name: " + name);
                 Vector attVector = attributesMap.get (name);
                 //System.out.println ("********attributesMap attVector size: " + attVector.size());
                 //System.out.println ("********Vector attVector: " + attVector);
                for (Enumeration e = attVector.elements(); e.hasMoreElements();) {
                    ElementObject eo = (ElementObject) e.nextElement();
                    //System.out.println ("**eo name: " + eo._name);
                    //System.out.println ("**Adding to minOccur Vector minOccur: " + eo._minOccur);
                   //System.out.println ("**Adding to maxOccur Vector maxOccur: " + eo._maxOccur);
                    if (eo._ref.contains (":")) {
                        //System.out.println ("**eo ref: " + eo._ref);
                        String[] paramArray = eo._ref.split(":");
                        //System.out.println ("**paramArray: " + paramArray[0]);
                        if (paramArray.length > 1) {
                            if (paramArray[0].equals ("tns")) {
                                //System.out.println ("**paramArray tns:param " + paramArray[0]);
                                //System.out.println ("**paramArray tns:type: " + paramArray[1]);
                                String type = paramArray[1];
                                paramVector.addElement ("has" + type);
                                typeVector.addElement (type);
                            }
                            else {
                                String abbr = paramArray[0];
                                if (webServiceName.contains(".xsd")) {
                                    String[] array = webServiceName.split (".xsd");
                                    String shortNameServ = array[0];
                                    String ab = abbr + shortNameServ.substring (0,1);
                                    //System.out.println ("**paramArray else other:param " + ab + ":" +   paramArray[1]);
                                    //System.out.println ("**paramArray else other:type: " + paramArray[1]);
                                    paramVector.addElement (ab + ":" +   paramArray[1]);
                                    typeVector.addElement (paramArray[1]);
                                }
                                else {
                                    String type = paramArray[1];
                                    //System.out.println ("**paramArray else :param " + eo._ref);
                                    //System.out.println ("**paramArray else :type: " + paramArray[1]);
                                    typeVector.addElement (eo._ref);
                                    paramVector.addElement (type);
                                }
                            }
                            if (eo._minOccur.equals("unbounded")) {
                                minVector.addElement ("");
                            }
                            else {
                                minVector.addElement (eo._minOccur);
                            }
                            if (eo._maxOccur.equals("unbounded")) {
                                maxVector.addElement ("");
                            }
                            else {
                                 maxVector.addElement (eo._maxOccur);
                            }
                        }
                    }
                    else if (eo._ref.equals ("NoCT")) {
                        paramVector.addElement ("NoAttribute");
                        typeVector.addElement ("NoCT");
                        //System.out.println ("**eo NO CT _type: " + eo._type);
                        superClassForNoCT = eo._type;
                    }
                    else {
                        //System.out.println ("**eo name no abbr param: " + eo._name);
                        //System.out.println ("**eo name no abbr _type: " + eo._type);
                        paramVector.addElement (eo._name);
                        typeVector.addElement (eo._type);
                        if (eo._minOccur.equals("unbounded")) {
                            minVector.addElement ("");
                        }
                        else {
                            minVector.addElement (eo._minOccur);
                        }
                        if (eo._maxOccur.equals("unbounded")) {
                            maxVector.addElement ("");
                        }
                        else {
                             maxVector.addElement (eo._maxOccur);
                        }
                        //System.out.println ("**Adding to param Vector name: " + eo._name);
                        //System.out.println ("**Adding to type Vector type: " + eo._type);
                        //System.out.println ("**Adding to minOccur Vector minOccur: " + eo._minOccur);
                        //System.out.println ("**Adding to maxOccur Vector maxOccur: " + eo._maxOccur);
                     }
                }
                //System.out.println ("**setDataFromFile:paramVector: " + paramVector);
                //System.out.println ("**setDataFromFile:typeVector: " + typeVector);
             }
             //System.out.println ("**setDataFromFile:operationName: " + operationName);
             paramsObj = new ParametersObject (paramVector, typeVector, paramVector, typeVector, minVector, maxVector,
                                               new Vector<Object>());
             operationsMap.put (operationName, paramsObj);

            String action = "";
            if (operationName.contains ("Action")) {
                action = operationName;
            }
            else {
                action = operationName + "Action";
            }

            String actionSuperClass = "";

             if (webServiceName.contains(".wsdl")) {
                 if (!superClassForNoCT.equals("")) {
                     actionSuperClass = superClassForNoCT;
                 }
                 else {
                     String[] name = webServiceName.split(".wsdl");
                     //System.out.println ("**setDataFromFile wsdl: name[0]: " +  name[0]);
                     actionSuperClass = name[0] + "Action";
                     //System.out.println ("**setDataFromFile wsdl: actionSuperClass: " +  actionSuperClass);                     
                 }
             }
             else if (webServiceName.contains(".xsd") && _usingWebServices == true) {
                 if (!superClassForNoCT.equals("")) {
                     actionSuperClass = superClassForNoCT;
                 }
                 else {
                     String[] sa = webServiceName.split ("=");
                     //actionSuperClass = sa[1] + "Action";
                     actionSuperClass = sa[1];
                 }
             }
             else if (webServiceName.contains(".xsd")) {
                 if (!superClassForNoCT.equals("")) {
                     actionSuperClass = superClassForNoCT;
                 }
                 else {
                     String[] name = webServiceName.split(".xsd");
                     //System.out.println ("**setDataFromFile xsd: name[0]: " +  name[0]);
                     //actionSuperClass = name[0] + "Action";
                     actionSuperClass = name[0];
                 }
             }
             else if (webServiceName.contains ("Inner Class")) {
                 //System.out.println ("**setDataFromFile Inner class: parentServiceName: " +  parentServiceName);
                 if (parentServiceName.equals("")) {
                     actionSuperClass = webServiceName;
                 }
                 else {
                     actionSuperClass = parentServiceName;
                 }
             }
             else {
                 //actionSuperClass = webServiceName + "Action";
                 actionSuperClass = webServiceName;
                 //System.out.println ("**setDataFromFile else: " +  actionSuperClass);
             }

             operationsObj = new OperationsObject (operationName, action, actionSuperClass, operationsMap, "");
             allOperationsMap.put (operationName, operationsObj);
         }

        /*System.out.println ("**webServiceName: " + webServiceName);
        System.out.println ("**logicalURL: " + logicalURL);
         System.out.println ("**importedOntMap: " + importedOntMap);
         System.out.println ("**allOperationsMap: " + allOperationsMap);
         System.out.println ("**treeObject: " + treeObject);
         System.out.println ("**defAbbr: " + defAbbr);
        System.out.println ("**defImpOnt: " + defImpOnt);*/

        ServicesObject servicesObj = new ServicesObject (webServiceName, logicalURL, importedOntMap, allOperationsMap, treeObject,
                                                         defAbbr, defImpOnt, simpleTypesData);

         //Main table that map the web service name with the services object
        //System.out.println ("**webServiceName to _mainServicesMap: " + webServiceName);
        _mainServicesMap.put (webServiceName, servicesObj);
        //System.out.println ("**_mainServicesMap: " + _mainServicesMap);
    }

    protected void getOntologyRepDefInstances (String webServiceName)
    {
        String defAbbr = "";
        String defImpOnt = "";

        if (webServiceName.contains(".xsd")) {
            defAbbr = "KaosEntity";
            defImpOnt = "http://ontology.ihmc.us/Entity.owl";
        }
        else {
            defAbbr = "KaosAction";
            defImpOnt = "http://ontology.ihmc.us/Action.owl";
        }

        //Get the ontology repository instance for the default url.
        try {
            OntologyService ontRep = new JTPOntologyRepository (false);
            //System.out.println(" ********defImpOnt: " + defImpOnt);
            //System.out.println(" ********defAbbr: " + defAbbr);
            ontRep.loadOntology (defImpOnt, false);
            _ontologyRepMap.put (defAbbr, ontRep);
            //System.out.println ("**setDataFromFile::_ontologyRepMap size: " +  _ontologyRepMap.size());
        }
        catch (Exception ex) {
            JOptionPane.showMessageDialog (new JFrame(), "Unknown Loaded Ontology: " + defImpOnt);
             _ontologyRepMap.put ("NoData", new JTPOntologyRepository (false));
            ex.printStackTrace();
        }
    }

    /**
     * Finds the xsd file that defines the range index.
     * @param servObj
     * @param rangeStr
     * @return the range index
     */
    public String findXSDFileForRange (ServicesObject servObj, String rangeStr)
    {
        String rangeDef = "";
        Map<String, OperationsObject> operationsMap = null;
        //System.out.println(" ********rangeStr: " + rangeStr);
        TreeFileObject treeObject = servObj._treeObject;
        ArrayList listOfXSD = treeObject._listOfChildren;
        if (listOfXSD.size() > 0) {
            for (Object servNameObj : listOfXSD) {
                //System.out.println(" ********_mainServicesMap: " + _mainServicesMap);
                //System.out.println(" ********_xsdFileHashtable: " + _xsdFileHashtable);
                //System.out.println(" ********servNameObj: " + servNameObj.toString());
                if (_usingWebServices) {
                    for (int i=0; i<_xsdObjList.size(); i++) {
                        XSDObject xsdo = (XSDObject) _xsdObjList.get(i);
                        //System.out.println(" ********xsdo._serviceName: " + xsdo._serviceName);
                        if (xsdo._serviceName.equals (servNameObj.toString())) {
                            operationsMap = xsdo._allOperationsMap;
                            String[] serArr = servNameObj.toString().split("=");
                            servNameObj = serArr[1];
                            break;
                        }
                     }
                }
                else {
                    ServicesObject so = _mainServicesMap.get (servNameObj.toString());
                    if (so != null) {
                        operationsMap = so._operationsMap;
                    }
                }
                if (operationsMap != null) {
                    Iterator it = operationsMap.keySet().iterator();
                    while (it.hasNext()) {
                        String opName = (String) it.next();
                        //System.out.println(" ********opName: " + opName);
                        if (opName.equals (rangeStr)) {
                            String str = servNameObj.toString();
                            rangeDef = str.substring (0,1);
                        }
                    }
                }
            }
        }
        //System.out.println(" ********Substring of: " + rangeDef);
        return rangeDef;
    }

   /**
     * Displays the services dialog to choose between web services urls
     * or files in the file system.
     */
    protected void displayServicesDialog()
    {
        RequestServicesDialog rsd = new RequestServicesDialog();
        rsd.setVisible (true);

        if (!_webServHashtable.isEmpty()) {
            _webServHashtable.clear();
        }
        _urlsComboBoxModel.removeAllElements();
        //servListModel.removeAllElements();
        _servicesTree.removeAll();
        _namespTable.removeAll();

        if (_bChangingServiceSelected) return;   //Added to avoid race conditions in slower machines

        if (rsd.showDialog() == OK_SELECTED) {
            //System.out.println(" ******** (rsd.isWebServiceSelected(): " + rsd.isWebServiceSelected());
            _opListModel.removeAllElements();
            _servicesTree.removeAll();
            _rightTextArea.setText("");
            _wsdlTableVector.removeAllElements();
            _wsdlTable.removeAll();
            _namespTable.removeAll();

            _treeModel.setRoot (null);
            _servicesTree.removeAll();
            _rootTree = new DefaultMutableTreeNode ("");
            _treeModel.setRoot (_rootTree);

            if (rsd.isMibFileSelected()) {
                _anotButton.setEnabled (false);
                _fileTable = rsd.getListOfFiles();
                _fileType = "mib";
                //System.out.println("********fileType: " + _fileType);
                _loader = rsd.getMibLoaderFromDlg();
                _usingMibFiles = true;
                if (_mainServicesMap.size() > 0) {
                    _mainServicesMap.clear();
                }

                Map<String, Mib> mibFileTable = rsd.getListOfMibFiles();

                Vector mibTableVector = new Vector (mibFileTable.keySet());
                Collections.sort (mibTableVector);

                Iterator it = mibTableVector.iterator();
                while (it.hasNext()) {
                    String fileName = (String) it.next();
                    //System.out.println("**This is the MIB fileName:display services: " + fileName);
                    _urlsComboBoxModel.addElement (_fileTable.get (fileName).getAbsolutePath());
                    //_servListModel.addElement (fileName);
                    Mib mib = mibFileTable.get (fileName);
                    DefaultMutableTreeNode parent = new DefaultMutableTreeNode (mib.getName());
                    _rootTree.add (parent);
                    //MIBFilesHandler handler = new MIBFilesHandler (mib);
                    MIBFilesParser handler = new MIBFilesParser (mib);
                    Map<String, ServicesObject> map = handler.init();
                    //handleMIBFile (mib);
                    Iterator itr = map.keySet().iterator();
                    while (itr.hasNext()) {
                        String servname = (String) itr.next();
                        //System.out.println("**This is the MIB display services:servname: " + servname);
                        ServicesObject so =  map.get (servname);
                        _mainServicesMap.put (servname, so);
                    }
                    
                    _servicesTree.expandRow(0);
                    _treeModel.nodeStructureChanged (_rootTree);
                    expandTreeNodes (_servicesTree, _rootTree);
                }
            }
            else if (rsd.isWebServiceSelected()) {
                _usingMibFiles = false;
                _anotButton.setEnabled (true);
                _servicesTree.removeAll();
                _treeScrollPane.getViewport().setView (_servicesTree);
                _usingWebServices = rsd.isWebServiceSelected();
                String url = rsd.getURLStringFromDialog();
                //System.out.println(" ******** url: " + url);
                _urlsComboBoxModel.addElement (url);
                getParserServices (url);

                for (String key : _webServHashtable.keySet()) {
                    //System.out.println(" ********Adding key:" + key);
                    if (key.contains("xsd")) {
                        //System.out.println(" ********Adding key with xsd:" + key);
                    }
                    else if (!key.contains ("sts")) {
                        //System.out.println(" ********Adding no sts:" + key);
                        TreeFileObject treeObj = getWebServicesData (key);
                        DefaultMutableTreeNode child = new DefaultMutableTreeNode (key);
                        _rootTree.add (child);

                        if (treeObj == null) {
                            return;
                        }
                        else {
                            ArrayList list = treeObj._listOfChildren;
                            if (list.size() > 0) {
                                for (Object obj : list) {
                                    //System.out.println("******Inserting:obj: " + obj.toString());
                                    String objStr = obj.toString();
                                    String[] sa = objStr.split ("=");
                                    DefaultMutableTreeNode objNode = new DefaultMutableTreeNode (sa[1], true);
                                    child.add (objNode);
                                    _xsdFileHashtable.put(sa[1], objStr);
                                }
                            }
                        }
                    }
                }
            }
            else {
                _usingMibFiles = false;
                _anotButton.setEnabled (true);
                _servicesTree.removeAll();
                _treeScrollPane.getViewport().setView (_servicesTree);
                _usingWebServices = false;
                _fileTable = rsd.getListOfFiles();
                //System.out.println("**After DisplayServices DialogThis is _fileTable: " + _fileTable);
                //_webServicesSelected = false;
                Vector fileTableVector = new Vector (_fileTable.keySet());
                Collections.sort (fileTableVector);

                Iterator it = fileTableVector.iterator();
                while (it.hasNext()) {
                    String fileName = (String) it.next();
                    //System.out.println("**This is the fileName: " + fileName);
                    _urlsComboBoxModel.addElement (_fileTable.get(fileName).getAbsolutePath());
                    //_servListModel.addElement (fileName);
                    DefaultMutableTreeNode parent = new DefaultMutableTreeNode (fileName);
                    if (fileName.contains (".wsdl")) {
                        _rootTree.add (parent);
                        TreeFileObject treeObj = getFileServicesData (fileName);
                        //System.out.println("******treeObj: " + treeObj);
                        if (treeObj == null) {
                            return;
                        }
                        else {
                            ArrayList list = treeObj._listOfChildren;
                            if (list.size() > 0) {
                                for (Object obj : list) {
                                    //System.out.println("******Inserting:obj: " + obj.toString());
                                    DefaultMutableTreeNode objNode = new DefaultMutableTreeNode (obj, true);
                                    parent.add (objNode);
                                    //_treeModel.insertNodeInto (objNode, parent, parent.getChildCount());
                                }
                            }
                        }
                    }
                    else if (fileName.contains (".xsd")) {
                        TreeFileObject treeObj = getFileServicesData (fileName);
                    }
                    _servicesTree.expandRow(0);
                    _treeModel.nodeStructureChanged (_rootTree);
                }
            }
            expandTreeNodes (_servicesTree, _rootTree);
            _servicesTree.setSelectionRow (0);
        }
    }

    /**
     * Recursively expand the given node, and all its children.
     * @param jt tree
     * @param startNode first node
     */
    public static void expandTreeNodes (JTree jt, TreeNode startNode)
    {
        TreePath tp = new TreePath(((DefaultMutableTreeNode)startNode).getPath());
        jt.expandPath(tp);
        for (int i=0; i<startNode.getChildCount(); i++) {
            expandTreeNodes(jt, startNode.getChildAt(i));
        }
     }
    
    /**
     * Gets the web services url from jboss
     *
     * @param serviceURL
     */
    public void getParserServices (String serviceURL)
    {
        MicrosoftTagTypes.register();
        PHPTagTypes.register();
        PHPTagTypes.PHP_SHORT.deregister(); //remove PHP short tags for this example otherwise
                                            // they override processing instructions
        MasonTagTypes.register();
        Source source = null;
        try {
            source = new Source (new URL(serviceURL));
        }
        catch (Exception e) {
            JOptionPane.showMessageDialog (new JFrame(), "No Web Service is Running", "Invalid Option",
                                           JOptionPane.WARNING_MESSAGE);
            return;
            //e.printStackTrace();
        }
        if (source != null) {
            displaySegments (source.getAllStartTags("a href="));
        }
    }

    /**
     * Displays the web services
     *
     * @param segments
     */
    private void displaySegments (java.util.List<? extends Segment> segments)
    {
        for (Segment segment : segments) {
			//System.out.println(" ** segment: " + segment.toString());
            String segString = segment.toString();

            String[] parsedStr = segString.split("'");
            String wsdlURL = parsedStr[1].trim();
            //System.out.println(" ** wsdlURL:" + wsdlURL);

            String webServName = getWebServiceName (wsdlURL);
            //System.out.println(" ** webServName:" + webServName);

            _webServHashtable.put (webServName, wsdlURL);
        }
    }

    //Gets the web service name from the url.
    private String getWebServiceName (String wsdlStr)
    {
        String webServiceName = null;
        try {
            URL url = new URL (wsdlStr);
            String str = url.getPath();
            webServiceName = str.substring (1).trim();
            //System.out.println(" ** webServiceName:" + webServiceName);
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        return webServiceName;
    }

    /**
     * Handles the operation name list selection to display the attributes and types for
     * each operation.
     *
     * @param operationName
     */
    protected void handleOperationSelection (String operationName)
    {
        //System.out.println("******handleOperationSelection:operationName: " + operationName);
        _wsdlTableVector.removeAllElements();
        _wsdlTable.removeAll();
        String logServName = "";
        ServicesObject servObj = null;
        String serviceName = "";

        Map<String, OperationsObject> operationsMap = null;
        serviceName = _servicesTree.getLastSelectedPathComponent().toString();

        //System.out.println ("**handleOperationSelection:_mainServicesMap]: " + _mainServicesMap);
        if (_usingMibFiles) {
            //System.out.println ("**serviceName: " + serviceName);
            servObj = _mainServicesMap.get (serviceName);
            operationsMap = servObj._operationsMap;

            //System.out.println ("**handleOperationSelection:operationsMap: " + operationsMap);
            if (servObj._logicalURL.length() <= 0) {
                logServName = "http://ontology.ihmc.us/Computing/Network/mib/" + serviceName + ".owl";
                _logicalTextField.setText (logServName);
            }
            else {
                _logicalTextField.setText (servObj._logicalURL);
            }
        }
        else if (serviceName.contains (".wsdl")) {
            String[] array = serviceName.split (".wsdl");
            //System.out.println ("**array[0]: " + array[0]);
            String servName = array[0];
            servObj = _mainServicesMap.get (serviceName);
            operationsMap = servObj._operationsMap;
            _logicalTextField.setText (servObj._logicalURL);
        }
        else if (serviceName.contains (".xsd") && _usingWebServices == false) {
            servObj = _mainServicesMap.get (serviceName);
            String[] array = serviceName.split (".xsd");
            String servName = array[0];
            for (int i=0; i<_xsdObjList.size(); i++) {
                XSDObject xsdo = (XSDObject) _xsdObjList.get(i);
                if (xsdo._serviceName.equals (serviceName)) {
                    operationsMap = xsdo._allOperationsMap;
                    //String logicalURL = xsdo._logicalURL;
                    /*if (xsdo._logicalURL.length() <= 0) {
                        logServName = "http://ontology.ihmc.us/services/" + servName + ".owl";
                        _logicalTextField.setText (logServName);
                    }
                    else {*/
                        _logicalTextField.setText (xsdo._logicalURL);
                   // }
                    break;
                }
            }
        }
        else {
            if (!_xsdFileHashtable.isEmpty() && serviceName.contains(".xsd")) {
                String name = _xsdFileHashtable.get (serviceName);
                //System.out.println ("****name: " + name);
                serviceName = name;
            }
            servObj = _mainServicesMap.get (serviceName);
            operationsMap = servObj._operationsMap;

            //System.out.println ("**handleOperationSelection:operationsMap: " + operationsMap);
            if (servObj._logicalURL.length() <= 0) {
                logServName = "http://ontology.ihmc.us/services/" + serviceName + ".owl";
                _logicalTextField.setText (logServName);
            }
            else {
                _logicalTextField.setText (servObj._logicalURL);
            }
        }
        
        //System.out.println("******handleOperationSelection:operationName: " + operationName);
        OperationsObject opObj = operationsMap.get (operationName);
        if (opObj == null) {
            return;
        }
        String opName = opObj._operationName;
        //System.out.println("******OpertObject opName: " + opName);
        String action = opObj._actionName;
        //System.out.println("******handleOperationSelection:action: " + action);

        String actionSuperClass = opObj._actionSuperClassName;
        //System.out.println("******handleOperationSelection:actionSuperClass: " + actionSuperClass);
        Map<String, ParametersObject> paramsMap = opObj._paramsMap;
        //System.out.println("******handleOperationSelection:paramsMap: " + paramsMap.size());
        ParametersObject po = paramsMap.get (operationName);

        if (po == null) {
            //System.out.println("******handleOperationSelection: po null**************");
            return;
        }
        Vector<String> params = po._wsdlParam;
        //System.out.println("******handleOperationSelection params: " + params);
        //System.out.println("******handleOperationSelection params size: " + params.size());
        Vector<String> types = po._wsdlTypes;
        //System.out.println("******handleOperationSelection types: " + types);
        //System.out.println("******handleOperationSelection types size: " + types.size());
        Vector<String> owlParams = po._owlPropertyName;
        //System.out.println("******handleOperationSelection owlParams: " + owlParams);
        //System.out.println("******handleOperationSelection owlParams size: " + owlParams.size());
        Vector<String> owlRange = po._owlPropertyRange;
        //System.out.println("******handleOperationSelection owlRange size: " + owlRange.size());
        //System.out.println("******handleOperationSelection owlRange: " + owlRange);

        //System.out.println("******handleOperationSelection owlParams size: " + owlParams.size());
        //System.out.println("******handleOperationSelection params size: " + params.size());
        if (params.size() > 0 && types.size() > 0) {
            for (int i = 0; i< params.size(); i++) {
                //System.out.println("******handleOperationSelection i: " + i);
                Vector<String> vec = new  Vector<String>();
                //System.out.println("******handleOperationSelection:params.elementAt(i): " + params.elementAt(i));
                //System.out.println("******handleOperationSelection:types.elementAt(i): " + types.elementAt(i));
                //System.out.println("******handleOperationSelection:owlRange.elementAt(i): " + owlRange.elementAt(i));
                if (types.elementAt(i).equals("NoCT")) {
                    continue;
                }
                vec.addElement (params.elementAt(i));
                
                if (types.elementAt(i).contains (":")) {
                    //String[] typesArray = types.elementAt(i).split("dm:");
                    String[] typesArray = types.elementAt(i).split(":");
                    //System.out.println("******handleOperationSelection:typesArray size: " + typesArray.length);
                    //System.out.println("******handleOperationSelection:typesArray {0}: " + typesArray[0]);
                    if (typesArray.length > 1) {
                        if (typesArray[0].equals("tns")) {
                            vec.addElement (typesArray[1]);
                        }
                        else if (typesArray[0].contains("x")) {
                            vec.addElement (typesArray[0] + ":" + typesArray[1]);
                        }
                        else {
                            //System.out.println("******handleOperationSelection:typesArray[0]: " +typesArray[0]);
                            String letter = findXSDFileForRange (servObj, typesArray[1]);
                            String type = typesArray[0] + letter + ":" + typesArray[1];
                            //System.out.println("******handleOperationSelection:typesArray[0]: " +type);
                            vec.addElement (type);
                        }
                    }
                }
                else {
                    vec.addElement (types.elementAt(i));
                }
           
                //vec.addElement (types.elementAt(i));
                vec.addElement (owlParams.elementAt(i));
                //System.out.println("******owlParams.elementAt(i): " + owlParams.elementAt(i));
                //System.out.println("******owlRange.elementAt(i): " + owlRange.elementAt(i));

                //if (owlRange.elementAt(i).contains ("dm:")) {
                if (owlRange.elementAt(i).contains (":")) {
                    //String[] rangeArray = owlRange.elementAt(i).split("dm:");
                    //System.out.println("******owlRange.elementAt(i): " + owlRange.elementAt(i));
                    String[] rangeArray = owlRange.elementAt(i).split (":");
                    //System.out.println("******handleOperationSelection:rangeArray size: " + rangeArray.length);
                    //System.out.println("******handleOperationSelection:rangeArray {0}: " + rangeArray[0]);
                    if (rangeArray.length > 1) {
                        if (rangeArray[0].equals("tns")) {
                            vec.addElement (rangeArray[0] + ":" +rangeArray[1]);
                        }
                        else if (rangeArray[0].contains("x")) {
                            vec.addElement (rangeArray[0] + ":" + rangeArray[1]);
                        }
                        else {
                            String letter = findXSDFileForRange (servObj, rangeArray[1]);
                            if (rangeArray[0].contains (letter)) {
                                vec.addElement (rangeArray[0] + ":" + rangeArray[1]);
                            }
                            else {
                                String range = rangeArray[0] + letter + ":" + rangeArray[1];
                                //System.out.println("******handleOperationSelection:range: " + range);
                                vec.addElement (range);
                             }
                        }
                    }
                }
                else {
                    vec.addElement (owlRange.elementAt(i));
                }
                if (!vec.isEmpty()) {
                    _wsdlTableVector.addElement (vec);
                }
            }
            
            //System.out.println("******actionSuperClass: " + actionSuperClass);
            //System.out.println("******actionClass: " + action);
            if (actionSuperClass.contains(".xsd")) {
                String[] sa = actionSuperClass.split (".xsd");
                if (sa.length > 0) {
                    actionSuperClass = sa[0];
                }
            }
            else if (actionSuperClass.contains(".wsdl")) {
                String[] sa = actionSuperClass.split (".wsdl");
                if (sa.length > 0) {
                    actionSuperClass = sa[0];
                }
            }

            if (_usingWebServices) {
                if (!actionSuperClass.contains ("Action")) {
                    _supActTextField.setText (actionSuperClass + "Action");
                }
                else {
                    _supActTextField.setText (actionSuperClass);
                }

                if (!action.contains ("Action")) {
                    _actTextField.setText (action + "Action");
                }
                else {
                    _actTextField.setText (action);
                }
            }
            else if (serviceName.contains (".wsdl") && _usingWebServices == false) {
                if (!actionSuperClass.contains ("Action")) {
                    _supActTextField.setText (actionSuperClass + "Action");
                }
                else {

                    _supActTextField.setText (actionSuperClass);
                }

                if (!action.contains ("Action")) {
                    _actTextField.setText (action + "Action");
                }
                else {
                    _actTextField.setText (action);
                }
            }
            else {
                //System.out.println("*Else******actionSuperClass: " + actionSuperClass);
                //System.out.println("*Else******actionClass: " + action);
                if (!actionSuperClass.contains ("Action")) {
                    _supActTextField.setText (actionSuperClass);
                }
                else {
                    String[] sa = actionSuperClass.split ("Action");
                    if (sa.length > 0) {
                        actionSuperClass = sa[0];
                    }
                    _supActTextField.setText (actionSuperClass);
                }

                if (!action.contains ("Action")) {
                    _actTextField.setText (action);
                }
                else {
                    String[] sa = action.split ("Action");
                    if (sa.length > 0) {
                        action = sa[0];
                    }
                    _actTextField.setText (action);
                }
            }
        }
        _wsdlTableModel.fireTableDataChanged();
        //_opList.revalidate();
    }

    /**
     * Updates the ontology when any component changes.
     */
    protected void updateOntology()
    {
        //System.out.println ("****_bChangingServiceSelected:update: " + _bChangingServiceSelected);
        if (_bChangingServiceSelected) return;

        String serviceName = "";
        ServicesObject servObj = null;
        //System.out.println ("****_usingMibFiles: " + _usingMibFiles);
        if (_usingMibFiles) {
            serviceName = _servicesTree.getLastSelectedPathComponent().toString();
            servObj = _mainServicesMap.get (serviceName);
            updateOntology (servObj);
        }
        else {
            serviceName = _servicesTree.getLastSelectedPathComponent().toString();

            if (_usingWebServices) {
                if (!_xsdFileHashtable.isEmpty() && serviceName.contains(".xsd")) {
                    String name = _xsdFileHashtable.get (serviceName);
                    //System.out.println ("****name: " + name);
                    serviceName = name;
                }
            }

            servObj = _mainServicesMap.get (serviceName);
            updateOntology (servObj);
        }
    }

    /**
     * Updates the ontology when any component changes.
     * @param servObj   services object data structure
     */
    protected void updateOntology (ServicesObject servObj)
    {
        //ServicesObject servObj = _mainServicesMap.get(_servList.getSelectedValue());
        Map<String, OperationsObject> operationsMap = servObj._operationsMap;

       String abbr = "";
       String uri = "";

        Map<String, String> importedOntMap = servObj._importedOntMap;
        //System.out.println("********updateOntology:_namespTable.getRowCount(): " + _namespTable.getRowCount());

        int irow = _namespTable.getSelectedRow();

        if (irow >= 0) {
            Vector<String> rowVec = _dModel.getRowElements (irow);

            if (!rowVec.isEmpty()) {
                abbr = rowVec.elementAt (0).trim();
                //System.out.println("********updateOntology:abbr1:<" + abbr + ">");
                uri = rowVec.elementAt (1).trim();
                //System.out.println("********updateOntology:uri:<" + uri + ">");
            }
            if (!importedOntMap.containsKey (abbr) && !uri.equals ("")) {
                //System.out.println("********updateOntology:abbr:<" + abbr + ">");
                importedOntMap.put (abbr, uri);
                //System.out.println("********update importedOntMap: " + importedOntMap);
                //System.out.println("********update _ontologyRepMap1: " + _ontologyRepMap);
                try {
                    OntologyService ontRep = new JTPOntologyRepository (false);
                    ontRep.loadOntology (uri, false);
                    _ontologyRepMap.put (abbr, ontRep);
                }
                catch (IOException ioex) {
                    JOptionPane.showMessageDialog (new JFrame(), "Unknown File: " + uri);
                    //ioex.printStackTrace();
                }
                catch (OntologyService.ReasoningException rex) {
                    JOptionPane.showMessageDialog (new JFrame(), "Reasoning Exception Occured");
                    //rex.printStackTrace();
                }
                catch (DirectoryFailure e)
                {
                    //rex.printStackTrace();
                }
            }
        }

        if (_opList.getSelectedValue() == null) {
            return;
        }

        String operationNameSelected = _opList.getSelectedValue().toString();

        //System.out.println(" ********updateOntology:operationNameSelected: " + operationNameSelected);
        OperationsObject oo = operationsMap.get (operationNameSelected);
        if (oo == null) {
            return;
        }
        String opName = oo._operationName;
        //System.out.println("******updateOntology:opName: " + opName);
        String action = oo._actionName;
        //System.out.println("******updateOntology:action from oo: " + action);
        String actionSuperClass = oo._actionSuperClassName;
        //System.out.println("******updateOntology:actionSuperClass: " + actionSuperClass);
        Map<String, ParametersObject> paramsMap = oo._paramsMap;
        ParametersObject po = paramsMap.get (operationNameSelected);
        if (po == null) {
            return;
        }

        Vector<String> owlPV = po._owlPropertyName;
        //System.out.println("******updateOntology:owlPV: " + owlPV);
        Vector<String> owlTV = po._owlPropertyRange;
        //System.out.println("******updateOntology:owlTV: " + owlTV);

        Vector<String> wsdlParam = new Vector<String>();
        Vector<String> wsdlTypes = new Vector<String>();
        Vector<String> owlProp = new Vector<String>();
        Vector<String> owlRange = new Vector<String>();

        for (int row = 0; row<_wsdlTable.getRowCount(); row++) {
            Vector<String> rowVector =  _wsdlTableModel.getRowElements (row);
            //System.out.println(" ********rowVector: " + rowVector);
            //System.out.println(" ********rowVector:size " + rowVector.size());
            if (rowVector.size() >= 4) {
                //System.out.println(" ********rowVector.elementAt(0): " + rowVector.elementAt(0));
                wsdlParam.addElement (rowVector.elementAt(0));
                //System.out.println(" ********rowVector.elementAt(1): " + rowVector.elementAt(1));
                wsdlTypes.addElement (rowVector.elementAt(1));
                //System.out.println(" ********rowVector.elementAt(2): " + rowVector.elementAt(2));
                owlProp.addElement (rowVector.elementAt(2));
                //System.out.println(" ********rowVector.elementAt(3): " + rowVector.elementAt(3));
                owlRange.addElement (rowVector.elementAt(3));
            }
        }

        //System.out.println("******Update owlProp: " + owlProp);
        //System.out.println("******Update owlRange: " + owlRange);
        //System.out.println("******Update po._owlPropertyName: " + po._owlPropertyName);
        //System.out.println("******Update po._owlPropertyRange: " + po._owlPropertyRange);
        if (!owlPV.equals (owlProp)) {
            po._owlPropertyName = owlProp;
            //System.out.println ("******SMT**Update owl props from " + owlPV);
        }
        if (!owlTV.equals (owlRange)) {
            //System.out.println ("******Update owl range from " + po._owlPropertyRange);
            if (!po._owlPropertyRange.contains("tns")) {
                po._owlPropertyRange = owlRange;
                 //System.out.println ("******SMT**Update owl range from " + owlRange);
            }
        }
        paramsMap.put (operationNameSelected, po);
        oo._paramsMap = paramsMap;

        String actionText = _actTextField.getText();
        //System.out.println("******updateOntology:actionText: " + actionText);
        if (actionText.contains (":")) {
            String[] array = actionText.split(":");
            abbr = array[0];
        }

        oo._actionName = actionText;
        oo._operationName = actionText;

        String superAcText = _supActTextField.getText();
        //System.out.println("******updateOntology:superAcText: " + superAcText);

        if (superAcText.equals ("")) {
            superAcText = _servicesTree.getLastSelectedPathComponent().toString();
        }
        else if (superAcText.contains(":")) {
            String[] array = superAcText.split(":");
            abbr = array[0];
        }
        oo._actionSuperClassName = superAcText;
        //servObj._serviceName = superAcText;   //Added in case the superclass changes. Changes should be in super class.

        //System.out.println("******updateOntology:superAcText: " + superAcText);
        //System.out.println("******_logicalURL: " + _logicalTextField.getText());
        servObj._logicalURL = _logicalTextField.getText();

        //BuildOntologyForServices bofw = new BuildOntologyForServices (_mainServicesMap);

        String serviceSelected ="";
        serviceSelected = _servicesTree.getLastSelectedPathComponent().toString();
        //System.out.println ("****Update: serviceSelected: " + serviceSelected);
        if (_usingWebServices) {
             if (_usingWebServices == true && serviceSelected.contains(".xsd")) {
                serviceSelected = _xsdFileHashtable.get (serviceSelected);
                //System.out.println ("****serviceSelected: " + serviceSelected);
            }
        }

        String serviceName = _servicesTree.getLastSelectedPathComponent().toString();
        //System.out.println("********serviceName: " + serviceName);
        //String fileType = "";
        if (serviceName.contains (".wsdl")) {
            _fileType = "wsdl";
        }
        else if (serviceName.contains (".xsd")) {
            _fileType = "xsd";
        }
        //System.out.println("********fileType: " + _fileType);

        OntologyServicesBuilder osb = new OntologyServicesBuilder (_mainServicesMap, _fileType);
        StringBuffer sb = osb.init (serviceSelected);

        _rightTextArea.setText (sb.toString());

        try {
            int position = _rightTextArea.getLineStartOffset (0);   // If last line: _rightTextArea.getLineCount() - 1);
            _rightTextArea.setCaretPosition(position);
        }
        catch (Exception e) {
            e.printStackTrace();
        }

        if (_usingWebServices || serviceSelected.contains(".wsdl")) {
            if (!operationNameSelected.contains("Action")) {
                operationNameSelected = operationNameSelected + "Action";
            }
            if (!opName.contains ("Action")) {
                opName = opName + "Action";
            }
        }
        else {
            if (operationNameSelected.contains("Action")) {
                String[] sa = operationNameSelected.split ("Action");
                if (sa.length > 0) {
                    operationNameSelected = sa[0];
                }
            }
            if (opName.contains("Action")) {
                String[] sa = opName.split ("Action");
                if (sa.length > 0) {
                    opName = sa[0];
                }
            }
        }

        //Set the scroll and underline the string.
        if (!superAcText.equals (actionSuperClass)) {
            //System.out.println("******updateOntology:superAcText: " + superAcText + " actionSuperClass:" + actionSuperClass);
            if (superAcText.contains (":")) {
                String[] sarray = superAcText.split(":");
                if (sarray.length > 1) {
                   scrollToFirst (sarray[1]);
                   underlineEach (sarray[1]);
                }
            }
            else {
                scrollToFirst (superAcText);
                underlineEach (superAcText);
            }
        }

        else if (!actionText.equals (action)) {
            //System.out.println("******updateOntology:actionText: " + actionText + " actionName:" + action);
            if (actionText.contains (":")) {
                //System.out.println("******updateOntology:actionText: " + actionText);
                String[] array = actionText.split(":");
                if (array.length > 1) {
                   scrollToFirst (array[1]);
                   underlineEach (array[1]);
                }
            }
            else {
                //System.out.println("******updateOntology:actionText else!!!!: " + actionText);
                scrollToFirst (actionText);
                underlineEach (actionText);
            }
        }
        else if (operationNameSelected.equals (opName)) {
            //System.out.println("******updateOntology:operationNameSelected: " + operationNameSelected + " opName:" + opName);
            scrollToFirst (operationNameSelected);
            underlineEach (operationNameSelected);
        }
        else {
            //System.out.println("******updateOntology: else operationNameSelected:<" + operationNameSelected + "> opName:<" + opName + ">");
            if (opName.contains(":")) {
                String[] array = opName.split(":");
                if (array.length > 1) {
                   scrollToFirst (array[1]);
                   underlineEach (array[1]);
                }
            }
            else {
                scrollToFirst (opName);
                underlineEach (opName);
            }
        }
    }

    /**
     * Parses the wsdl file with DOM parser and write the wsdl annotations to an XSL file.
     */
    protected void getAnnotations()
    {
        serviceFileName = _servicesTree.getLastSelectedPathComponent().toString();
        System.out.println ("****serviceFile for annotations: " + serviceFileName);
        if (serviceFileName == null) {
            return;
        }

        //run annotations and constructing XSL work in separate thread
        final kaos.kpat.applet.SwingWorker worker = new kaos.kpat.applet.SwingWorker(){
            public Object construct() {
                //System.out.println ("****serviceFile for annotations: " + serviceFileName);
                if (serviceFileName.contains(".wsdl") || serviceFileName.contains(".xsd") ) {
                    File fileName = _fileTable.get (serviceFileName);
                    //System.out.println ("****File path for annotations: " + fileName.getAbsolutePath());
                    buffer = parser.getFileBufStream (fileName);
                    serviceType = "file";
                    filePath = fileName.getAbsolutePath();
                }
                else {
                    String wsdlURL = _webServHashtable.get (serviceFileName);
                    buffer = parser.getStreamByURL (wsdlURL);
                    serviceType = "webService";
                    filePath = "";
                }

                String strBuf = buffer.toString();
                //System.out.println("***str : "+ strBuf.toString());
                String str = "test.xml";
                try {
                    BufferedWriter out = new BufferedWriter (new FileWriter(str));
                    out.write (strBuf);
                    out.close();
                }
                catch (Exception e) {
                    e.printStackTrace();
                }

                try {
                    //System.out.println("***str : "+ str);
                    parser.writeAnnotations (str, serviceType, serviceFileName, filePath);
                    //System.out.println("***_mainDataMap : "+ _mainDataMap);
                    BuildXSLFile buildFile = new BuildXSLFile (_mainServicesMap, serviceFileName, filePath);
                    buildFile.getXSLDataForFile();
                }
                catch (Exception e) {
                    JOptionPane.showMessageDialog (new JFrame(), "Error Writing the Annotations",
                                                   "Error", JOptionPane.ERROR_MESSAGE);
                    e.printStackTrace();
                }

                return new Object();
            }

            public void finished(){
                System.out.println ("**Annotations:finished**");
                JOptionPane.showMessageDialog (new JFrame(), "Successfully Finished Annotations " + "\n" +
                                               "to WSDL and Creation of XSL Files");
            }
        };
        worker.start();
    }

    protected String serviceType = null;
    protected String filePath = "";
    ParseWithDOM parser = new ParseWithDOM();
    protected StringBuffer buffer = null;
    protected String serviceFileName = null;

    /**
     * Saves the wsdl file to a file.
     */
    protected void saveWsdlToFile()
    {
        String stringWsdl = _rightTextArea.getText();

        JFileChooser chooser = new JFileChooser (_configPath);
        chooser.setSelectedFile (new File (_logicalTextField.getText())); //Default text for fileName field.
        ExampleFileFilter configFilter = new ExampleFileFilter();
        configFilter.addExtension ("owl");
        configFilter.setDescription ("File in OWL");

        chooser.addChoosableFileFilter (configFilter);
        chooser.setFileFilter (configFilter);
        int returnVal = chooser.showSaveDialog (this);

        if (returnVal != APPROVE_OPTION) {
            return;
        }

        String filename = chooser.getSelectedFile().getPath();
        //System.out.println ("**filename: " + filename);

        String path = "";
        int idx = filename.lastIndexOf (FILE_BREAK);
        if (idx >= 0) {
            path = filename.substring (0, idx);
        }
        //System.out.println ("**path: " + path);
        _configPath = path;

        if (filename.indexOf (".owl") < 0) {
            filename = filename + ".owl";
        }
        try {
            BufferedWriter out = new BufferedWriter (new FileWriter(filename));
            if (stringWsdl != null) {
                //System.out.println ("**writing wsdl");
                out.write (stringWsdl);
            }
            out.close();
        }
        catch (IOException ioe) {
            ioe.printStackTrace();
        }

    }

    /**
     *  Return the short name for this url.
     */
    protected String getShortName (String name)
    {
        if (name != null) {
            //parse shortname by taking everything after the #
            for (StringTokenizer t = new StringTokenizer (name, "#"); t.hasMoreTokens(); ) {
                name = t.nextToken();
            }
        }
        else {
            System.out.println (">>Error!. Name is null<<");
        }
        return name;
    }

    public static void main(String[] argv)
	{
        ServicesManagementTool smt = new ServicesManagementTool();
        smt.setVisible (true);
    }

    //Utility classes for the TextAutoCompleter
    public String getServiceName()
    {
        String serviceName = _servicesTree.getLastSelectedPathComponent().toString();
        if (_usingWebServices) {
            if (!_xsdFileHashtable.isEmpty() && serviceName.contains(".xsd")) {
                String name = _xsdFileHashtable.get (serviceName);
                //System.out.println ("****name: " + name);
                serviceName = name;
            }
        }
        return serviceName;
    }

    public String getSuperActionText()
    {
        return _supActTextField.getText();
    }

    public String getActionText()
    {
        return _actTextField.getText();
    }

    public WsdlDataTableModel getParamsTableModel()
    {
        return _wsdlTableModel;
    }

    /**
     * *****Inner Classes *****
     */

    /**
     * Table Model for names and URIs.
     */
    protected class DataTableModel extends DefaultTableModel
    {
        public DataTableModel (Vector data, Vector columnNames)
        {
            super (data, columnNames);
        }

        // Get the data from each row of the table.
        public Vector getRowElements (int row)
        {
            Vector rowVector = new Vector();

            if (row < this.getRowCount()) {
                String abbrName = (String) getValueAt (row, 0);
                rowVector.addElement (abbrName);
                String uri = (String) getValueAt (row, 1);
                rowVector.addElement (uri);
            }
            return rowVector;
        }
    }

    /**
     * Timer thread checks for changes in the components so the ontology can be updated.
     */
    public class TimerThread extends Thread implements Runnable
    {
        public TimerThread()
        {
        }

        public void run()
        {
            while (true) {
                try {
                    Thread.sleep (500);
                }
                catch (InterruptedException xcp) { }
                
                if (!_reset) break;
                _reset = false;
            }

            updateOntology();
        }

        public boolean _reset = false;
    }

    /**
     * Listener for tree expansion event.
     */
    public class ServicesTreeExpansionListener implements TreeExpansionListener
    {
        public void treeExpanded(TreeExpansionEvent event)
        {
            TreeNode node = (TreeNode) event.getPath().getLastPathComponent();
            if (node.getChildCount() == 1) {
                JTree t = (JTree) event.getSource();
                t.expandPath(event.getPath().pathByAddingChild(node.getChildAt(0)));
            }
        }

        public void treeCollapsed(TreeExpansionEvent event)
        {
        }
    }

    /**
     * Table Model for operation attributes.
     */
    public class WsdlDataTableModel extends DefaultTableModel
    {
        public WsdlDataTableModel (Vector data, Vector columnNames)
        {
            super (data, columnNames);
        }

        // Get the data from each row of the table.
        public Vector getRowElements (int row)
        {
            Vector rowVector = new Vector();
            String paramName = (String) getValueAt(row, 0);
            //System.out.println(" ********getRowElements:paramName: " + paramName);
            rowVector.addElement (paramName);
            String type = (String) getValueAt(row, 1);
            //System.out.println(" ********getRowElements:type: " + type);
            rowVector.addElement (type);
            String owlProp = (String) getValueAt(row, 2);
            //System.out.println(" ********getRowElements:owlProp: " + owlProp);
            rowVector.addElement (owlProp);
            String owlRange = (String) getValueAt(row, 3);
            //System.out.println(" ********getRowElements:owlRange: " + owlRange);
            rowVector.addElement (owlRange);

            return rowVector;
        }
    }

    protected class ServicesTableCellRenderer extends JLabel implements TableCellRenderer
    {
        public ServicesTableCellRenderer()
        {
            setOpaque (false);
        }

        public Component getTableCellRendererComponent (JTable table, Object value, boolean isSelected,
                                                        boolean hasFocus, int row, int column)
        {
            String str = (String) value;
            setText (str);
            return this;
        }
    }

    protected class ParamsTableEditor extends DefaultCellEditor
    {
        public ParamsTableEditor()
        {
            super (new JTextField());
            JTextField textField = (JTextField) getComponent();
            //System.out.println(" ********_ontologyRepMap: " + _ontologyRepMap.size());
            _textTableAutoCompleter = new TextAutoCompleter (textField, true, _mainServicesMap, _ontologyRepMap,
                                                             _columnSelected, _rowSelected, _thisService);
            textField.setToolTipText ("Press Enter and then click outside");

            textField.getInputMap().put (KeyStroke.getKeyStroke (KeyEvent.VK_ENTER, 0), "check");
            textField.getActionMap().put("check", new AbstractAction() {
                public void actionPerformed(ActionEvent e) {
                }
            });
        }

        //Override to invoke setText on the text field.
        public Component getTableCellEditorComponent(JTable table,
                                                     Object value, boolean isSelected,
                                                     int row, int column)
        {
            JTextField jtf = (JTextField) super.getTableCellEditorComponent(
                              table, value, isSelected, row, column);
            jtf.setText (value.toString());
            return jtf;
        }

        public Object getCellEditorValue()
        {
            JTextField jtf = (JTextField) getComponent();
            Object o = jtf.getText();
            return o.toString();
        }

        public boolean stopCellEditing()
        {
            JTextField jtf = (JTextField) getComponent();
            return super.stopCellEditing();
        }
    }


    /**
     *  Object built from the xsd file.
     */
    protected class XSDObject extends Object
    {
        public XSDObject (String serviceName,  String logicalURL, Map<String, OperationsObject> allOperationsMap,
                          Map<String, String> importedOntMap)
        {
            _serviceName = serviceName;
            _logicalURL = logicalURL;
            _allOperationsMap = allOperationsMap;
            _importedOntMap = importedOntMap;
        }

        protected Map<String, String> _importedOntMap;
        protected Map<String, OperationsObject> _allOperationsMap;
        protected String _logicalURL;
        protected String _serviceName;
    }

    //Variables
    private ServicesManagementTool _thisService = this;
    protected volatile boolean _bChangingServiceSelected = false;
    protected String FILE_BREAK = System.getProperty ("file.separator");
    protected String[] _defaultFiles = {"http://localhost:8080/jbossws/services"}; //Default web services url.
    public static final int OK_SELECTED = 1;
    public static final int CANCEL_SELECTED = 0;
    protected static String _configPath = ".";
    protected boolean _usingWebServices = false;
    protected boolean _usingMibFiles = false;
    protected int _columnSelected;
    protected int _rowSelected;

    protected ArrayList _xsdObjList;
    protected DataTableModel _dModel;
    protected DefaultComboBoxModel _urlsComboBoxModel;
    protected DefaultListModel _opListModel;
    protected DefaultMutableTreeNode _rootTree;
    protected DefaultTreeModel _treeModel;

    protected JButton _anotButton;
    protected JComboBox  _urlsComboBox;
    protected JLabel _actLabel;
    protected JLabel _servLabel;
    protected JLabel _operLabel;
    protected JLabel _sactLabel;
    protected JList _opList;
    protected JList _list;
    protected JScrollPane _treeScrollPane;
    protected JTable _namespTable;
    protected JTable _wsdlTable;
    protected JTextField _actTextField;
    protected JTextField _logicalTextField;
    protected JTextField _supActTextField;
    protected JTextArea _rightTextArea;
    protected JTree _servicesTree;

    protected Map<String, TimerThread> _threadsMap;
    protected Map<String, File> _fileTable; //Maps the file name with the file object.
    protected Map<String, ServicesObject> _mainServicesMap; //Maps the service name with the services object.
    protected Map<String, OperationsObject> _operationsMap; //Maps the operation name with the operations object.
    protected Map<String, Object> _parametersMap;  //Maps the operation name with the list of parameters.
    protected Map<String, String> _webServHashtable;      //Maps the web service name with the wsdl service url.
    protected Map<String, String> _xsdFileHashtable;      //Maps the xsd short service name with the URL
    protected Map<String, OntologyService> _ontologyRepMap; //Maps an instance of the ontology repository for each
                                                               //imported ontology.

    protected MibLoader _loader;
    protected TextAutoCompleter _textAutoCompleter;
    protected TextAutoCompleter _textTableAutoCompleter;

    protected Vector _colNames; //Name of the columns of the wsdlTable
    protected Vector<Object> _namespTableVector;  //Vector of row for the namespaces table.
    protected Vector<Object> _wsdlTableVector;   //Vector of row for the wsdl parameters table.
    protected WsdlDataTableModel _wsdlTableModel;

    protected String _fileType = "";
    protected String _serviceCurrentlySelected = "";
    protected String _mibFilename = null;
    protected String[] _columnToolTips = {null, null, "For Code Completion with Imported Ont.: Press Enter and then click outside",
                                          "For Code Completion with Imported Ont.: Press Enter and then click outside"};
}
