package kaos.tools.webServiceTool;

import java.io.Serializable;
import java.util.Map;
import java.util.Vector;


/**
 * Main object for the web service
 *
 * @author Maggie Breedy
 * @version: $Revision: 1.7 $
 */

public class ServicesObject extends Object implements Serializable
{
    public ServicesObject (String serviceName, String logicalURL, Map<String,String> impOntologyMap,
                           Map<String,OperationsObject> operationsMap, TreeFileObject treeObject,
                           String defaultAbbr, String defaultImpOntology, Map<String, Vector> simpleTypesMap)
    {
        _serviceName = serviceName;
        _logicalURL = logicalURL;
        _importedOntMap = impOntologyMap;
        _operationsMap = operationsMap;
        _treeObject = treeObject;
        _defaultAbbr = defaultAbbr;
        _defaultImpOntology = defaultImpOntology;
        _simpleTypesMap = simpleTypesMap;
    }

    //Variables
    public String _serviceName;     //Service name
    public String _logicalURL;      //The logical URL for the service
    public Map<String, String> _importedOntMap;   //Maps the abbr with the uri.
    public Map<String, OperationsObject> _operationsMap;    //Maps the service name with the operations object
    public TreeFileObject _treeObject;      //The tree object for the service
    public String _defaultAbbr;             //The default ontology abbreviation
    public String _defaultImpOntology;      //The default imported ontology
    public Map<String, Vector> _simpleTypesMap;         //Maps the simple type name with a vector of eunmeration values.
}
